Start... early ages

1985-05-16
- GEMDOS 1.0 released by Digital Research, Inc.

1987-06-05  ACH PROC.C
- Problem - After physical disk error COMMAND.PRG gives "Command not
  found." message for all subsequent external commands. Fix - Changed the
  error handling code in  xexec() to always do an ixterm(t); on any disk
  error, thus freeing memory.

1987-06-26  ACH TIME.C & BIOS
- To enable GEMDOS to take advantage of real-time clock/calendars a new
  BIOS function (11h) has been added. Whenever the BDOS sets a new time
  or date this function is called and, if the hardware supports it, the
  real-time clock can be updated. When the BDOS needs the current time or
  date the function is called to allow the BIOS to update the internal
  BDOS values. If there is no hardware clock the BIOS can  simply ignore
  this call as the BDOS still maintains the time and date internally
  based on the system tick.

1987-09-16  ACH SUP.C
- Problem - the internal date and time variables used to time stamp file
  updates are set to 0 when the OS starts up.

  Fix - Changed cinit() in SUP.C to call new BIOS date_time() function
  (11h) so that the BIOS can initialise the internal variables from a
  hardware real-time clock, if supported.

1987-10-09  ACH BDOSMAIN.C
- Duplicate definition of supstk and SUPSIZ removed from this module.
  (Duplicated in PROC.C and FS.H.) If the supervisor stack is to be OEM
  configurable some more reliable method must be devised.

1987-11-19  ACH RWA.A
- Added _lbmove, _bfill, _bmove routines. (These were supposed to be in
  something called TOOLS.ARC which was not supplied by DRI.)

===== MAD working on his own ===============================================

2001-05-01
- Started working on GEMDOS -> EmuTOS

2001-07-28
- Working on MFP initialization

2001-07-29
- Implementing Cartridge system for work with STonX
- Rewrite of vector setup

2001-07-30
- rewrote some exception handlers
- implemented VBL handler
- implemented HBL handler
- implemented keyboard interrupt handler

2001-09-04
- working on the keyboard interrupt routine

2001-09-05
- got the keyboard interrupt running (wow!)

2001-09-06
- got the keyboard queue running

2001-09-07
- Mega ST clock should work - could not test yet
- Character blit implemented (not tested)
- VT52 emulator implemented (not yet blitted to screen)

2001-09-10
- Worked on character blitting (not tested)

2001-09-11
- Got first real character blitted to screen
- cons_out is basically working

2001-09-12
- Fighting much too long against a too small supervisor stack  :-(
- Got scrolling much to slowly working

2001-09-13
- scrolling now faster
- worked on keyboard decoding for bconin (not tested)
- fixed linker configuration in Makefile (libgcc forgotten)

2001-09-26
- trying to bring BDOS and BIOS together

2001-09-29
- integrating STonX native BIOS emulation to BIOS

2001-09-02
- found out, where the basepage is for DTA stuff

2001-09-04
- got memory setup descritor working
- got the command loading running

2001-09-09
- Uppercase/lowercase is now working
- got old command.prg compiled and started and basically WORKING!!!
- command.prg: directory navigation is working

2001-09-10
- handlers for showing exceptions 0x08 - 0x20 written (atari's bombs)

2001-09-24
- fixed bug in supervisor stack setup (stack was top of stack + size of stack)
- Now no garbage in the diskbuffer -> clean screen while ls or dir executing

2001-09-25
- os_pal changed to word width
- Implemented extended TOS 1.02 header - no basepage set in STonX any longer!
- Did put .org 0x4f2 in front of _sysbase: in tosvars.s

===== Project created on Sourceforge ? ===================================

2001-09-25
- linea commented out of cartridge (LVL)
- added .even after .ascii strings (odd exception handlers) (LVL)
- rwa.s, startup.s - changed "dc.w 0" by '\0' at end of .ascii strings (LVL)
- padded tosvars.s so that _sysbase == 0x4F2 (LVL)
- fixed (?) malloc() bug (due to missing prototype in fs.h) (LVL)
- added/edited some copyright notices on top of files. (rwa.s, startup.s)

2001-09-26
- change a prototype for xmgetblk - now command.prg load other programs!

2001-09-30
- changed XBIOS stubs to right declaration. (MAD)

2001-10-01
- ensured that the MIDI acia was inited (for KBD to work on stonc) (LVL)

2001-10-05
- Makefile (LVL)
- printf() clone for debug messages (LVL)
- 8x16 font in high rez (LVL)
- put all default exception vectors in bios/vectors.s (LVL)
- clear bss before calling C code. (LVL)

2001-10-06
- minor bug in vectors.s (LVL)
- linea stubs (LVL)
- SetScreen() in xbios.c
- some malloc debug info.
- added missing util directory (MAD)
- changed sysvarend to _bssend (it is the BSS, that ends! - got from DRI)
- added end.s with _bssend

2001-10-08
- started iorec and kbdvbase stuff (aim is to reimplement kbd.c to
  be compliant with the way TOS does it) (LVL)
- some debug info in Malloc(), bios(5)

2001-10-09
- Got asm conout working - MiNT did run somewhat better (MAD)
- Includes some more needed lineavars initialized (_esc_init) (MAD)
- cleaned Makefile and end.s ("the end.s episode") (LVL)
- copy paste error in linea stubs, startup.s (LVL)

2001-10-10
- EmuTOS now expects a cartridge of type 3, just as the original TOS. (THH)

2001-10-11
- removed the cart directory and the cartridge - no longer needed (MAD)

2001-10-12
- Initialised linea from startup.s (_esc_init -> _linea_init) (MAD)
- Cleaned up conio.c
- Cleaned up output stuff in bios.c
- Put all linea stuff in bios/linea.s
- Cleaned up some minor things in bdos/proc.c
- Changed linea/graphics init in bios/startup.s
- Set up half of memory config in bios/startup.s
- pseudo reentrant bios xbios trap handler (LVL)
- Supexec() (LVL)
- bios device functions arrays (bconstat_vec, ...) (LVL)

2001-10-13
- Fixed some minor errors while compilation (MAD)
- Added more system vars in tosvars.s and fixed an error (no pun_ptr) (MAD)

2001-10-14
- implemented full memory configuration - much much more memory now (MAD)
- implemented cursor (not blinking - this was easy) (MAD)
- Changed version string of command.prg  (MAD)
- correct fnt8x8 (previous one useless) and fnt8x16 (last char offset) (LVL)
- some progress on iorec, but still not in service (LVL)

2001-10-16
- Fixed some bugs in bios.c (the bconoutx functions need 2 parameters!) (THH)

2001-10-19
- Cleaned up and seperated memory initialisation in memory.s  (MAD)
- Cleaned up command.prg (got rid of cpm code) (MAD)

2001-10-20
- added memmove and memset, erasing bmove, xmovs and bfill in bdos (LVL)
- midi and ikbd bios device functions; new ikbd interrupt (LVL)
- started to clean some headers (removed abbrev.h, btools.h) (LVL)
- added bconout5 (raw console) (LVL)

2001-10-21
- mfp xbios functions; mfp init rewritten using xbios funcs. (LVL)
- vbl routine: added palette handling and vblqueue. (LVL)
- misc. xbios routines (vsync, random, ...) (LVL)
- warning free, automatic built date in command.prg (LVL)
- still some headers cleaning in bios/ and include/ (LVL)

2001-10-22
- Video mode can be set hard in startup.s to all three modes!!! (MAD)
- Cursor is now blinking (thanks Laurent, for Timer stuff!) (MAD)
- switched off debugging for public release in startup.s: _print (MAD)

2001-10-23
- Video mode recognition works (mono/color) (MAD)
- Emulated bigger screen resolutions work in mono mode  (MAD)

===== Initial release 0.1 ===================================================

2001-10-24
- Changed all *.s assembler files to *.S, changed comments from "|" to "//"

2001-10-27
- moved screen-related xbios functions in screen.c (LVL)
- added sound support (untested) in sound.c (LVL)
- added floppy support in floppy.c (LVL)
- started rewriting some of startup.c in C code (not completely done yet) (LVL)
- started cleaning old VME stuff in bios.c (LVL)
- native print is activated by a STONX_NATIVE_PRINT #define in config.h (LVL)

2001-10-28
- emutos.img file now is 192 kb (MAD)
- rewrote complete linea initialization in C (bios/lineainit.c) (MAD)

2001-10-31
- a TOS in RAM loaded using gemdos boot.prg (LVL)
- some memory fixes, got rid of end.o (LVL)
- a TOS in RAM loaded using an autoboot floppy (LVL)

2001-11-01
- removed old stuff from bios.c and startup.s (LVL)
- fixed the BDOS-buffer-init bug: EmuTOS boots a real MegaSTE2!!! (LVL)
- Removed hardcoded default drive #defines
- added EmuCON (EmuTOS console, before command.prg) to EmuTOS      (MAD)
  This is not yet working (it seems command.c is not ROMable for now)

2001-11-02
- EmuCON is now working. (THH)
- Implemented cursconf (XBIOS 0x15)  (MAD)
- Removed F_IOCtl() and the MOUSE:, CLOCK: and NUL: devices.          (THH)
- Mapped the CON:, AUX: and PRN: devices to Atari values (-1, -2, -3) (THH)
- commented out XBIOS calls from command.c (for testing)

2001-11-03
- run AUTO folder prgs, run EmuCON using Pexec(5) (LVL)
- localconf.h taken in consideration (LVL)
- implemented processor check and set of _longframe in BIOS/BDOS (MAD)
- IKBD and MegaRTC clock (setting time & date untested) (LVL)

2001-11-04
- added old VDI sources from DRI (not running yet)

2001-11-05
- added forgotten bios/processor.h (MAD)

2001-11-06
- US kbd default, optional DE and FR kbds, tools to add more KBD defs (LVL)
- changed joystick support in aciavecs.S (untested) (LVL)
- Makefile (updated clean and distclean, BUILDDATE also for CYGWIN) (LVL)
- Reimplemented bios/memory.S in a more readable manner   (MAD)

2001-11-07
- Reimplemented bios/memory.S - is hopefully perfect now   (MAD)

2001-11-08
- Added several ikbd-functions as base for mouse driver    (MAD)
- changed ikbdws (now 2. arg is UBYTE *ptr instead of LONG) (MAD)

2001-11-11
- Put portab.h to include/ for bdos AND bios   (MAD)
- ripped out kprint() (it has been replaced by kprintf()  (MAD)

2001-11-13
- Native Language support tools, french translation (LVL)
- asm glue for kprintf in startup.S (LVL)

2001-11-15
- Native Language support, german translation (MAD)
- introduced PTR in include/portab.h, which is a LONG (MAD)

2001-11-16
- Fixed bug in font_ring init (MAD)

2001-11-18
- Initmous implemented (C part - no data from asm delivered yet)  (MAD)
- removed -Tdata= from Makefile (LVL)
- painfully ANSIfied bdos and removed nearly all warnings (LVL)
- minor changes (LVL)

2001-11-21
- Changed all 'char's in bdos/ to 'BYTE', other will follow (MAD)

2001-11-22
- Partially implemented unused mouse driver in bios/mouse.c (MAD)

2001-11-24
- machine detection up to the MegaSTE and cookie jar filled (LVL)
- country setting now in Makefile, stored in header os_pal (LVL)
- nvram overrides country setting if present (not tested) (LVL)
- dates in EmuCON printed according to _IDT (LVL)
- 0xffff820e used when ste shifter present (LVL)
- added some xbios functions skeletons (LVL)
- a cvs trick to ensure obj/ directory is created even with update -d -P (LVL)
- floppy floprate() and flopfmt() untested (LVL)

2001-11-25
- Worked on bios/mouse.c   (MAD)

2001-11-26
- got Initmous() working (thanks Laurent)  (MAD)
- changed all "VOID"s to "void" in bios/*.[hc]  (MAD)

2001-11-27
- solved bdos-broken-when-floppy bug (xlseek proto wad badly ansified) (LVL)
- removed silly FOREVER, VOID, and others from portab.h (LVL)
- crude mediach(), TODO section and error names in floppy.c (LVL)
- static strcmp in util/nls.c conform to standard semantics (LVL)
- cksum handling of nvram (LVL)
- new 'hardware' section in status.txt (LVL)

2001-11-28
- Did put all *.txt files in doc/, except this.   (MAD)

2001-12-07
- EmuTOS now recognizes Falcon (by detecting VIDEL) and TT030
  (by detecting TT-Shifter). (PES)
- NVRAM is actually initialized now. Added functions for accessing the RTC
  in NVRAM. (PES)
- MegaRTC now checks whether there's the hardware present. (PES)
- clock.c works with the RTC in NVRAM. (PES)
- initinfo.c displays current date and time (sorry, no NLS enabled yet!) (PES)

2001-12-08
- NO_IKBD_CLOCK forgot to disable the XBIOS gettime(). Fixed by disabling
  all lowlevel IKBD functions. STonX boots EmuTOS again. (PES)
- changed back all BYTE to char in bdos/*.[ch] (MAD)
- added/marked up some comments in bios/nvram.c (MAD)

2001-12-09
- standalone command.prg (added replacement _() and N_()) (LVL)

2001-12-11
- added many of the lacking linea-variables (MAD)
- fixed int overflow bug in scrolling in bios/consout.S:p_sc_up (MAD)
- changed scrolling to use memmove (better?) (MAD)

2001-12-12
- changed todo.txt: b/w display bug is bug in STonX (MAD)
- changed bios/conout.S to C like comment style (MAD)

2001-12-13
- ripped out some ugly old gotos in bdos/fsbuf.c:packit() (MAD)

2001-12-15
- tool tounix.c to convert to Unix line ending (LVL)
- make cvsready to automate using expand, this tool, ... (LVL)
- make checkindent, make indent; updated coding rules for indent use (LVL)
- changed some files to remove indent warnings (did NOT indent files) (LVL)
- replaced explicit TABs in strings by \t in command.c (LVL)
- fixed bugs due to obsolete C code in command.c, and wrote a description of
  these bugs in doc/old_code.txt to serve as a reference (LVL)
- moved NORETURN to portab.h (LVL)
- panic() now prints on the screen also (LVL)
- added assert() in kprint (LVL)
- minor changes (LVL)

2001-12-19
- reworked tounix tool to handle temp file and error cases better (LVL)
- TMP variables in Makefile (LVL)
- unix line ending (doc/nls.txt, util/boot.c, tools/mkflop.c) (LVL)
- removed bios/kdump.c and bios/oldstuff (LVL)
- removed old dump stuff in bios/kprint (LVL)
- updated readme.txt (LVL)

2001-12-20
- added "stop" macro to include/asm.h as Laurent suggested (PES)
- added calling the "stop" in bios/ikbd.c (surrounded by #ifdef) (PES)

2001-12-28
- added Falcon memconf routine (PES)
- corrected the memtop in the memconf clear routine to 14MB (PES)
- added memval3 check/set (PES)
- added ramtop/ramvalid set (no FastRAM for now) (PES)
- added run-time check for Falcon MMU that fires a bus error
  on non-Falcon machines. This makes use of stack so the notice
  in bios/startup.S about meminit not using sp is not correct (PES)
- updated status.txt (the hw init paragraph) (PES)

2001-12-31
- added FastRAM (TT-RAM) detection to bios/memory.S. Right now
  it is called if Falcon MMU was detected but generally I need
  to detect CPU type so it would work on TT as well. (PES)
- corrected // notice in bios/startup.S - the meminit actually
  needs stack pointer - for both the bus error handler and for
  occasionals bsr kprintf (PES)

2002-01-01
- FastRAM detection now uses proper CPU check (PES)
- resetvec handling fixed (wrong check 'tst.b resetvec' removed) (PES)
- cartridge is defined at $00fa0000, not $fffa0000 - fixed. (PES)
- _check_read_byte now flushes pipelines at the correct places (PES)

2002-01-03
- replaced "REG" by register in bios/ and bdos/  (MAD)
- made bdos/kpgmld.c better readable (MAD)

2002-01-04
- made bdos/fsio.c better readable (MAD)
- bios/memory.S makes use of routines in bios/detect.S (PES)

2002-01-05
- fixed set_sr(0x0300) to 0x2300 in bios/screen.c:vsync() (LVL)
- added get_sr() macro in include/asm.h (LVL)
- renamed macro stop by stop2300, added the config variable in config.h (LVL)
- changed stop() usage in bios/ikbd.c (LVL)
- changed an explicit tab into \t in a string in command.c (LVL)
- made cvsready (LVL)

2002-01-06
- fixed BAD bug in fsmain.c - the divmod() long number (byte offset of lseek)
  was stripped when converting to (int). Due to that relocation info couldn't
  be read from a file during Pexec() and that caused "invalid exec format"
  bugs. Actually most things in BDOS filesystem could never work! (PES)
- "061a executable file format" debug print corrected: "601a ..." (PES)

2002-01-06
- optimized divmod() and moved it to bdos/fsio.c (MAD)
- did put usr2xfr/xfr2usr to bdos/fsio.c too (MAD)
- CLI: added unix like commands mv, cp, pwd, format, clear, rmdir, mkdir (MAD)

2002-01-07
- added GETBOOT bootsector extractor routine to EmuCON (MAD)
- fixed COPY/MOVE/CP/MV command (MAD)
- fixed NVRAM RTC getting/setting date (month is already 1..12) (PES)
- fixed printing of current time at bootup (month is already 1..12) (PES)
- disabled vsync() neverending loop (MonST works now) (PES)
- fixed LineA v_bytes_lin variable (Clocky works now) (PES)


2002-01-08
- hopefully fixed vsync() - I had omitted 'extern' in the declaration
  'volatile LONG frclock;' inside the routine. (LVL)
- updated fr translations (LVL)

2002-01-09
- bug now tells the number of untranslated entries in po files (LVL)
- make ikbd.dsm creates the 'gcc -S' output of file bios/ikbd.c (LVL)
- initinfo logo code rewritten: it's easier to change the picture now (LVL)
- initinfo messages displayed properly (the fore and back colors were
  not inited) - still the colors should probably be inited elsewhere (LVL)
- bell() and keyclick() now use TOS vars bell_hook and kcl_hook (LVL)
- added general block device functions in bios/blkdev.c (MAD)
- german translation updated (MAD)
- added doc/bugs.txt, entries from doc/todo.txt (MAD)

2002-01-10
- bios/floppy.c: renamed flop_hdv_boot to flop_bootcheck
                 renamed do_hdv_boot to flop_hdv_boot
                 should boot now after warmstart... (MAD)

2002-01-13
- bios/floppy.c: moved BIOS functions (rwabs, getbpb, mediach) to blkdev.c
                 moved geometry from finfo to blkdev struct
                 moved last_access to devices struct
                 moved FATfs bootsector struct to blkdev.h
                 moved compute_cksum() to blkdev.c
                 added floppy_rw() (that's the lowlevel part of floppy_rwabs)
                 added (WORD dev) to flopunlk() in order to update last_access
                 added hackish init of floppy geometry to flopini() (PES)
- bios/floppy.h: disabled bpb struct
                 made getiword externally accessible (PES)
- bios/startup.S: added ara_DMAread() (for calling the aranym's DMAread) (PES)
- bios/tosvars.h: added long recnr parameter to rwabs (like AHDI 3.0) (PES)
- bios/bios.c: added long recnr parameter to bios_4 (like AHDI 3.0) (PES)
- bios/bios.h: enabled bpb struct (PES)
- bios/xbios.c: DMAread()/DMAwrite() implemented (PES)
- Makefile: added disk.c to source files (PES)
- bios/disk.[ch] created, DMAread()/DMAwrite() implemented (PES)
- bios/blkdev.c: deleted most of Martin's framework
                 added full AHDI 3.0 extended Rwabs() (yet to add MEDIACH check)
                 added getBPB() with auto 12/16-bit FAT detection
                 added Mediach() (same as was in floppy.c) (PES)
- bios/blkdev.h: blkdev structure reworked (maybe a bit too much)
                 bpb structure disabled - what's wrong with the bios.h one?
                 UNIT and PARTITION structures - first ideas, incomplete (PES)
- Comment: the only thing I am sure of is the Rwabs() implementation. I am not
           very sure about the blkdev/device concept. Also would need to set
           common language - how to call physical drive (unit? device? drive?)
           and how to call logical disk (C:, partition, disk?). The problem
           now is how many things can be detected during boot - the size of
           partition, of the whole drive (especially with floppy) etc.
           bdos/fsio.c still strikes - passes null pointer for rwabs buffer.
           That needs to be debugged (or maybe rewritten completely). (PES)
- updated po/de.po, because of stupid translations by me (MAD)

2002-01-14
- foreground color now inited in lineainit.c (LVL)
- CZ fonts (first phase - next will have a correct font_ring) (LVL)
- wrote doc/country.txt, an overview of country-dependent stuff (LVL)
- silly BIOS early memory init in biosmem.[ch], used in nvram (LVL)
- changed some struct {...} foo [] = syntax that Indent didn't like (LVL)
- removed from lineavars.h struct VIDEO_MODE used only inside lineainit.c (LVL)
- fixed typos in bios-level memory (LVL)
- fixed the amount of fastram printed in debug mode (PES)
- set the C: in drvbits for the hacked up host access disk drive (PES)

2002-01-15
- disabled the bmem_allowed bug what Petr found in bios/biosmem.c (MAD)
- bios/detect.S: functions now keep register a2 intact (LVL)
- bios/kprint.c: temporarily removed console print in panic, until one
  knows of a way to be certain that the concole is configured (LVL)
- collected a number of <string.h> routines scattered around and put
  them in util/string.c and include/string.h; merged btools.h with
  string.h to be consistent with standard ANSI C (LVL)
- bios/kprint.h: silly debug macro HERE kprintf()s the location in file (LVL)
- bios/bios.c: commented out VEC_ILLEGAL = brkpt; (LVL)
- transferred getmpb from bios.c to biosmem.c (LVL)
- bios/conout.S: fixed bconout5(c) bug when c >= 128 (LVL)
- removed obsolete bios/keyboard.h include/btools.h (LVL)
- in bios/vectors.S, init_user_vec no longer relies on the previous value of
  register a1 from init_exc_vec (LVL)
- bios/blkdev.c - the floppy_init does not use the hdv_init vector. A: works
  under STonX again. (PES)
- bios/bios.c - increased the fixed size sector cache to 4kB sector. That's
  enough for partitions smaller than 512MB. Ideally it should be 32kB (PES).

2002-01-16
- aes and vdi not exported in make tgz (LVL)
- bios/clock.c: enabled MegaRTC clock by commenting out validity test (LVL)
- bios/clock.c: removed old commented-out code (LVL)
- removed unused bdos/bdos.h (LVL)
- bdos/proc.c: setjmp warnings avoided by turning params into static vars (LVL)
- updated doc/install.txt (LVL)
- removed [ OK ] in initinfo, expanded abbreviated messages, and modified
  fr.po and de.po (LVL)
- bios/floppy.c: some untested unique FDC track register bookkeeping (LVL)
- made ramtop and ramvalid visible from C code (LVL)

2002-01-19
- experimental autodetect ARAnyM or STonX native print (activated in
  bios/config.h) (LVL)
- new setjmp/longjmp replacing older ones (LVL)
- updated todo list (LVL)
- started fastram support in bdos (LVL)
- fixed some function prototypes in bios.c (LVL)
- removed cli/Makefile (LVL)
- implemented the font_ring as 3 lists of linked fontheaders (MAD)
- documented all tosvars in bios/tosvar.h till 0x5b0 (MAD)

2002-01-20
- in bios/lineainit.c there is now the sysfonts array for linea.
  font_ring is not longer used by linea (MAD).
- keyboard reset (Alt+Ctrl+Del(+RShift)) implemented (PES)
- trying to get 16-bit sector number working in BDOS - one workaround
  in fsbuf.c makes DIR (fsfirst/fsnext) working correctly (it seems).
  The NEGATIVE_RECN value (currently -200) should be fixed when it will be
  clear what is FAT/DIR negative recn and what is unsigned recn in signed int.
  FAT traversing seems to be broken (Pexec fails for some files) (PES)
- blkdev.h: retrying in emulator is not necessary (PES)
- blkdev.c: 16-bit recn should work now (PES)

2002-01-21
- in bios/lineainit.c: removed font_ring initialization (MAD)
- re-wrote completely Pexec() for header flags support. I kept the old routine
  for reference, but ultimately it will go away. Fastram is allocated when
  requested but it is still not freed (the *term routines in proc need to
  be changed as well); Pexec() flag 6 supported. I did not test on Fastram but
  all of autoexec, EmuCON, loading progs from C: and A: work. (LVL)

2002-01-22
- untested ttram-compliant internal memory stuff in proc.c (LVL)
- cleaned up bios/biosmem.c:bmem_init, removed old _b_mdx from startup.S (MAD)
- put diskbuf from startup.S to floppy.c, made dskbufp a pointer (MAD)
- put parallel and serial output funcs from asm to chardev.c (MAD)
- put cpu_init(), cooki_init() and machine_init() to the beginning of the
  C-startup procedure of bios.c (MAD)
- TT-RAM is added to BDOS memory by calling Maddalt (should be changed) (PES)
- free TT-RAM is displayed in initinfo.c (PES)
- put diskbuf to blkdev.c (MAD)

2002-01-23
- Did move the BCB and bufl_init to bdos/fsbuf.c (MAD)
- updated po/de.po po/fr.po for Fast-RAM texts (MAD)
- did put BPB in bios/blkdev.h (MAD)

2002-01-25
- Did put drvbit stuff into bios/blkdev.c (MAD)
- cleaned up bios/bios.c a bit (MAD)

2002-01-26
- make nodepend does not alter Makefile unnecessarily (faster CVS?) (LVL)
- ramtos reloc address derived automatically (RAMTOS works again) (LVL)
- bdos/pkgmld.c: PF_FASTLOAD implemented, deleted old implementation (LVL)
- bdos/umem.c: has_ttram properly set in Maddalt() (LVL)
- bdos/proc.c: deleted old Pexec implementation (LVL)
- panic() prints on screen if linea is inited (LVL)
- added new BDOS memory functions to doc/status.txt (LVL)
- added make target 512 and some related hints in Makefile (MAD)
- added code for Atari disk partitions detecting (unfinished yet) (PES)
- a check for Control key added to the AUTO folder execution (PES)
- #if ARANYM_NATIVE_DISK added to bios/disk.c - so it doesn't kill STonX (PES)

2002-01-27
- changed kcprintf() calls in panic() to vkcprintf for good CR/LF (MAD)
- drive and partition scanning finished (PES)
- initinfo shows the available gemdos logical drives (PES)

2002-01-28
- 1-bit color depth on Falcon now in proper black-on-white colors (PES)
- machine_init() split to two phases - machine_detect() can be called very
  early() and new machine_init() creates cookies etc. (PES)
- screen.c now detects proper screen size from VIDEL registers - there's no
  more trash on the screen - the size is set to 640x480 (PES)
- lineainit.c sets the variables according to proper screen resolution (PES)
- fixed BDOS 16-bit FAT - integer computing was overflowing in fsdrive.c (PES)

2002-01-30
- bdos/osmem.c variables init fixed. (PES)
- bios/blkdev.c - mediach returns "not changed" status for hard drives (PES)
- bios/machine.c - _FRB buffer for DMA operations to FastRAM added (PES)
- bios/floppy.c - floppy rwabs now use _FRB if destination is in FastRAM (PES)

2002-02-03
- bios/screen.c - do not change VIDEL freq by Shifter init code (PES)
- bios/blkdev.c - buf must be incremented (thanks Laurent) (PES)
                - getbpb no more divide by zero error (thanks Laurent) (PES)
- bios/floppy.c - corrent blkdev[].unit init for floppy B: (thx Laurent) (PES)

2002-03-06
- bios/machine.c - got rid of some compiler warnings

2002-03-07
- Made the VDI compilable again... And it even seems already to work a little
  bit (THH)

2002-03-08
- Cleaned up the AES sources, added prototypes and header files. The AES can
  now be linked with the rest of EmuTOS. (THH)

2002-03-11
- vdi/lisastub.c cleaned up of warnings
- vdi/gsxextrn.h added prototypes

2002-03-12
- vdi/* made prototypes, no warnings anymore, indented whole vdi (MAD)
- vdi/* jmptbl.c changed jumptables functions to void - arguments
  are passed in arrays in VDI, not via stack.  (MAD)
- vdi/lisagem.S partially implemented mouse driver

2002-03-13
- bios/bios.c removed mouse_init. Done, when graphics is initialized (MAD)

2002-03-15
- vdi/lisagem.S - got the mousedriver working (MAD)
- bios/mouse.c  - Added mouse_init - initial setup of mouse parameters (MAD)
- bios/mousedrv.S - Separated the mousedriver from VDI (MAD)
- vdi/lisagem.S - Here is now just the VDI part of mousedriver setup (MAD)
- bios/lineainit.c - implemented v_pl_dspl (bytes/plane) for VDI (MAD)
- bios/screen.c - the last patch for real Falcon reverted because it caused
                  black screen under ARAnyM (PES)
2002-03-17
- vdi/* - corrected the swapped #defines to use Atari and/or VME10 (MAD)
- You can now use the AES as user interface instead of EmuCON (THH)
  (by enabling it in the Makefile, however AES is not yet fully working)

2002-03-18
- bios/kprint.c - registers are printed out to ease debugging (PES)

2002-03-20
- The AES are now succeed in loading and running DESKTOP.APP from disk! (THH)
- Moved some more VDI variables to lineavars.S (THH)
- Cleaned up the VDI, it works now quite good in ST-HIGH resolution (THH)

2002-03-21
- doc/changelog.txt - added vdi/ and aes/ to the tgz target (MAD)
- doc/license.txt   - added GPL for EmuTOS (MAD)

2002-03-25
- Included the GEM.RSC into the ROM (THH).

2002-03-26
- bdos/biosmain.c - made DBGIFOS working by disabl. osif  (MAD)
- bdos/umem.c  switched off DBGUMEM and assert by default (MAD)

2002-03-28
- bios/startup.S - changed the _dummyaes vector for fVDI (MAD)
- bios/startup.S - changed label _dummyaes to _gemtrap (MAD)

2002-04-01
- vdi/lisagem.S - SR switched on for timer interrupt (MAD)
- bios/startup.S - did switch on the etv_timer interrupt vector (MAD)

2002-04-02
- vdi/lisagem.S - put mouse drawing additionally to timer_int (MAD)
- vdi/lisagem.S - put _CLEARMEM to vdi/monout.c (MAD)

2002-04-04
- desk/*  -  Added the desktop sources (THH).

2002-04-05
- newer bug - handles different encoding for different languages (LVL)
- added administrative entry in fr.po and de.po (LVL)
- encoding specified in po/LINGUAS (LVL)
- started removing Kamenicky encoding (LVL)
- doc/todo.txt: added 'Czech i18n' section (LVL)
- added version 0.2a in include/version.h, printed by initinfo.c (LVL)
- make release generates a TGZ named after include/version.h (LVL)
- GPL re-formatted to 72 chars wide (copied over the standard file) (LVL)
- cookie_swi commented out in bios/machine.c (bus error in some cases) (LVL)
- misc involuntary whitespace changes in some files (LVL)
- added po/cs.po from Bohdan for Czech native language support  (MAD)

2002-04-08
- bios/mousedrv.S - cleaned up a bit (MAD)
- vdi/lisagem.S - did remove SR saving in tick_int, like in TOS (MAD)
- aes/* - removed some warnings (MAD)
- bdos/fs* - replaced NULPTR completely by NULLPTR  (MAD)

2002-04-09
- vdi/vdimouse.S - renamed all VEX* functions to lower case (MAD)
- vdi/lisagem.S - renamed EX_TIMV to vex_timv (MAD)
- removed Kamenicky fonts (LVL)
- added ISO latin2 fonts (LVL)
- added CS po file (LVL)
- changed for consistancy CZ to CS as a country name (LVL)
- Makefile: fixed typo for desktop obj files (LVL)
- added some const keywords here and there (LVL)

2002-04-10
- Added additional application stack in aes/gemshlib.c so that it is now
  possible to start another application at least. However, it will still
  crash when it finishs. (THH)
- Some minor bug fixes in aes and desk (THH)
- Disabled the autoexec stuff in bios/startup.S, I think creating a new
  baspage for that is not really necessary (THH).

2002-04-11
- Finally found the other bug that caused EmuTOS to crash when running a
  GEM application (dos_exec() was not reentrant) (THH)
- Now linking desk_rsc.c into EmuTOS, too (THH)

2002-04-13
- doc/vdibind.txt - added documentation for vdi routine implementation (MAD)
- doc/vdimouse.S - put all mouse related stuff here in (MAD)

2002-04-14
- bios/lineavars.S - corrected length and memory position of vars (MAD)

2002-04-15
- finally commited in Czech keyboard (LVL)

2002-04-16
- bios/mousedrv.S - moved to vdi/mouse.drv, because it is not BIOS (MAD)
- vdi/mousedrv.S - did put all non-graphical functions here (MAD)
- vdi/vdimouse.S - did put all graphical functions here (MAD)

2002-04-16
- vdi/mousedrv.S - moved some more routines in there (MAD)

2002-04-18
- vdi/opnwkram - added right screen coordinates to wk info (MAD)

2002-04-20
- vdi/vdimouse.S - used concat routine for screen offset calculation (MAD)
- vdi/vdimouse.S - got mouse working for big screens (MAD)
- vdi/* - got all other routines working for big screens too (MAD)
- vdi/* - remove also many vme10 #ifdefs too (MAD)

2002-04-20
- desk/* - removed/fixed all compiler warnings (MAD)
- vdi/opnwkram - plane number and fonts corr. initialized (MAD)

2002-04-23
- Makefile - fal_$(DESASS) removed on make clean (LVL)
- Fixed text and mouse drawing in VDI color mode (THH).
- Improved the desktop's about dialog (THH).
- bios/startup.S - VBL video mode change written (disabled) (MAD)

2002-04-24
- vdi/* - switched some jmptbl functions to lowercase (MAD)
- vdi/bezier - added raw bezier code from PC GEM's GDOS - not yet working (MAD)

2002-04-25
- vdi/* - switched some more functions to lowercase (MAD)
- vdi/text.c - ripped mono blitting (MAD)

2002-04-26
- vdi/vmouse.c - implemented vex and some other mouse funcs in C (MAD)
- util/miscasm.S - added for smaller asm routines (MAD)
- bdos/umem.c - added missing break in a case that is responsible
                for returning free memory - now everything works OK! (PES)

2002-04-27
- vdi/*.S - changed // back to * inside comments (LVL)
- aes/large.S - moved LSTCPY to util/stringasm.S named strlencpy (LVL)
- aes/optimopt.S - replaced strchk by strcmp (LVL)
- aes/ - removed some calls to scabs by calls to strchr (LVL)
- aes/optimopt.S - replaced bfill by memset, rewrote rest of file (LVL)
- util/stringasm.S - added strlencpy and strchr (LVL)
- aes/gsx2.S - cleaned up, gave better names to labels (LVL)
- updated some todo items (LVL)
- aes/ - wrote comments trying to understand how the processes work (LVL)

2002-04-28
- desk/desk_rsc.c - added string translation using gettext (LVL)
- po/fr.po - updated FR translations to include desktop strings (LVL)
- vdi/vdimain.c - VDI startup and other stuff  (MAD)
- vdi/opnwkram.c -> vdimain.c, file deleted (MAD)
- vdi/vex.c -> vdimain.c, file deleted (MAD)
- vdi/lisagem.S -> vdimain.c, file deleted (MAD)
- vdi/txtblit.S - CLC_DDA now in C in text.c:clc_dda  (MAD)

2002-04-29
- bios/config.h - moved to include/config.h (LVL)
- include/config.h - set CONF_NO_NLS = 1 to disable NLS completely (LVL)
- bios/country.c - moved keyb and font selection tables here from ikbd.c and
    initlinea.c, in an attempt to make next Changelog item easier (LVL)
- include/config.h - set CONF_UNIQUE_COUNTRY = 1 to save some room by
    including only one set of keyboard and fonts in the ROM (LVL)
- renamed back CS into CZ to please Petr; did not alter po/cs.po (LVL)
- vdi/vinput.c - rewrote some key stuff in C (MAD)

2002-05-02
- Added John Elliott's "Desktop 1.2" patches - it's not enabled yet since
  it is quite instable, but you can enable it by compiling with "-DDESK1"
  and adding desk/desk1.c to your Makefile (THH).

2002-05-04
- po/POTFILES.in - removed cli files (LVL)
- added experimental ACSI support in acsi.c; it does work on STonC but
  freezes the atari when no hard disk is present. Activate it by setting
  CONF_WITH_ACSI in include/config.h (LVL)
- bios/tosvars.h: hz_200 declared as volatile (LVL)

2002-05-05
- Makefile : Now linking with gcc instead of ld, so we don't depend
  on a particular library folder (THH).
- aes/gemsuper.c : Added a simple fsel_exinput() (THH).
- Fixed AES keyboard bug (gsx_char() and strlencpy() have been wrong) (THH).

2002-05-10
- bios/bios.c: changed the init order. ACSI now works on STonC and STonX.
  (the trouble was, the DMA timeouts didn't work because the timer C was not
  enabled at the time when disk initialisation occurred) (LVL)
- added limited parallel port implementation (output only) (LVL)
- indented some files (LVL)
- bios/floppy.c: FastRAM floppy read/write (FRB usage was read-only);
  flopvbl added (but still no efficient mediach()) (LVL)
- Makefile: added size checks for targets 192, 256, 512. (LVL)
- vdi/gsxasm1.S: made __ABLINE externally visible (LVL)
- updated some doc/ files (LVL)

2002-05-14
- vdi/vinput.c - renamed to vdiinput.c, should hold all input stuff (MAD)
- vdi/vdiinput.c - implemented gloc_key in C, more will follow (MAD)

2002-05-16
- vdi/vdimouse.S - moved/rewrote DIS_CUR to monobj.c:dis_cur()  (MAD)
- vdi/vdiinput.c - moved/rewrote vdimouse_init/exit to here (MAD)
- vdi/vdimouse.S - move rest of asm routines from mousedrv.S to here (MAD)
- vdi/mousedrv.S - deleted
- util/miscasm.S - put trap1/13/14 to here from bdos/ for common use (MAD)
- include/asm.h - added trap1/13/14 calls as externals (MAD)
- vdi/vdiinput.c - vdimouse_init() fixed (MAD)

2002-05-17
- vdi/*.c - replaced all gotos by other constructs (MAD)
- vdi/lisastubs - removed, put into vdi/monobj.c for less files (MAD)

2002-05-18
- vdi/text.c - act_siz implemented in C (asm commented out) (MAD)

2002-05-30
- aes/* - Removed all "REG"s in old function declarations, GCC seems to
  have problems with "registered" parameters. This fixes the GEM dialog
  bug that caused the text fields not to redraw correctly (THH).
- aes/gemsuper.c - Changed the AES version back to 1.02, seems to work
  better this way with most applications (THH).
- vdi/isin.c - removed. Did put functions to vdi/monout.c (MAD)
  vdi/cbssdefs.c - removed. Did put functions to vdi/vdimain.c (MAD)
  vdi/jmptbl.c - removed. Did put tables to vdi/vdimain.c (MAD)
  vdi/jmptbl.h - removed. Did put prototypes to vdi/vdimain.c (MAD)
- vdi/lisatabl.c - removed. Tables distributed to where they belong (MAD)
- vdi/screen.hlp - removed. Info put into vdi/vdiconf.h (MAD)
- vdi/attrib.h - moved to vdi/vdidef.h (MAD)
- vdi/fontdef.h - integrated in vdi/vdidef.h (MAD)

2002-06-15
- bios/memory.S - separated Falcon and ST stuff, still a memconfig bug? (MAD)

2002-06-16
- bios/detect.S - removed, put into processor.S and vector.S (MAD)
- bios/vectors.S - put exception stuff here in (mostly from startup.S). (MAD)

2002-06-22
- Makefile - factored out some code for building sized images (LVL)
- doc/changelog.txt - editorial changes back in the past (LVL)
- doc/authors.txt - a first attempt. Please don't feel offended if I forgot
  something. The idea is to be able in a second phase to remove the 'Authors'
  lines in our source file headers that IMHO are not truly meaningful (LVL)

2002-06-23
- include/config.h - Added TOS_VERSION define to switch TOS versions and
  to reduce size if compiling a 192kB image (THH)

2002-07-01
- doc/processor.h - added some documentation about processor handling (LVL)
- tools/bug.c
  - prints "entry" instead of "entries" when only one entry (LVL)
  - GEM Alert strings folded at vertical bars in po files (LVL)
  - experimental translation directly within C files (LVL)
- wrappers for (x)bios functions not present unless DBG_(X)BIOS is set; moved
  (x)bios function tables out of vectors.S into (x)bios.c (LVL)
- bdos/fs*.[ch] - renamed rwabs to longjmp_rwabs for clarity (LVL)
- */*_rsc.c
  - aes resource translation added, sharing code with desk/desk_rsc.c (LVL)
  - folded long strings: no source line longer than 80 chars (LVL)
- po/fr.po - full FR translation (LVL)
- Makefile
  - gmake black magic :-) shrinks down the size of build rules (LVL)
  - experimental building of a unique-country translated EmuTOS (LVL)
- removed some 'extern' from C source files (should go in .h files) (LVL)
- bios/version.c - removed, was commented out for some time now (LVL)
- po/de.po - some german translations done (MAD)

2002-07-09
- po/de.po - all german translations done (MAD)

2002-07-19
- bios/processor.S - added skeleton for privileged instruction handler (MAD)

2002-07-20
- bios/ikbd.[ch], bios/vectors.S - added key repeat (LVL)
- bios/bios.c - priviledge exception ignored (LVL)
- doc/authors.txt - updated and added email addresses (LVL)

2002-07-22
- po/de.po - two more german translations done (MAD)
- po/cs.po - did bug update cs.po for new translations (MAD)

2002-07-23
- bios/vector.S - implemented priv. instr. handler (MAD)
                - moved ill. and priv. instr. handlers here. (MAD)

2002-07-24
- bios/vector.S - changed priv. instr. handler (MAD)
- bios/bios.c - Now here all basic vector is done in vecs_init() (MAD)

2002-07-27
- desk/deskapp.c - Enabled/fixed loading and saving of DESKTOP.INF, but
  the file is now called EMUDESK.INF due to some incompatibilities with
  the original GEM's DESKTOP.INF. Added automatic drive scanning when there
  is no such file, too. (THH)
- aes/gemfmlib.c - Dialogs can now be left by pressing ENTER, too. (THH)

2002-07-29
- vdi/gsxvars.S - removed. Variables are in their related source (MAD)

2002-07-30
- vdi/gsxasm*.c - Fixed bug in VDI that sometimes wrote to ROM area (THH).
- aes/crysbind.h - Size of the addr_in array was not big enough for
  fsel_exinput(). Now this AES call should work, too. (THH)
- desk/deskapp.c - EMUDESK.INF is now always saved to the root directory of
  the start drive. (THH)
- bios/lineavars.S - unneeded _TEXT_BG, _COPYTRAN, _FILL_ABORT removed (MAD)
- vdi/* - some mouse cursor stuff implemented in C (MAD)
- vdi/vdimouse.S - removed rbp, used !vme10 instead (MAD)
- vdi/gsxdef.h - empty, deleted  (MAD)

2002-07-30
- vdi/vdiinput.c - fixed bug in vb_draw routine (MAD)

2002-09-01
- bios/blkdev.c - booting from harddisk enabled (PES)
- bios/disk.[ch] - ARANYM_NATIVE_DISK does not crash other machines now.
                   Also it makes use of new ARAnyM XHDI function XHREADWRITE.
                   Harddisk is now read/write (if enabled in ARAnyM).

2002-09-07
- po/cs.po - Bohdan's czech language translation of GEM (MAD)
- vdi/ecslisa - unused, just left for reference for now (MAD)
- vdi/vdiesc.c - implementation in C (MAD)

2002-09-09
- bios/startup.S - Filled the remaining empty ROM header entries (THH).
- aes/gemasm.S - Accessories are now working on CPUs >= 68010, too! (THH).
- bios/fntlat2_*.c - Czech language okay (make COUNTRY=cz) but file now is
  too big for 256k: comment out another country in po/LINGUAS to try out
  cz country on a <256k emulator; UNIQUE cz does not work yet (LVL)
- bios/startup.S - deleted unused function vidchng() (MAD)

2002-09-11
- bios/startup.S - added NatFeat detection code (PES)
- bios/bios.c - added 'int native_features' flag (please move elsewhere as
  appropriate - it's definitely not bios related but will be used mostly
  there) (PES)
- bios/disk.c - adapted to NatFeat. Finally clean XHDI interface that other
  emulators may follow. (PES)
- bios/machine.c - a very hackish code for reading NF_NAME in place
  of emulated machine name. Where to get a bit of free RAM? Please fix it.
  (PES)
- bios/initinfo.c - added 5 seconds delay so users can enjoy machine name.
  The waiting is not using CPU STOP insn yet. Also needs to be
  interruptable by a keypress. Would be nice if it was possible to jump
  to the EmuShell instead of booting the GEM by pressing a key. (PES)

2002-09-14
- desk/icons - removed unnecessary 48x24 icons, added sed scripts to help edit
  icons (LVL)
- desk/desk_rsc.c - menu items are automatically adjusted to the right size
  after translation; I don't think this hack would work in the general case
  but for the current desktop it works fine (no sub-menus, icons, ...) (LVL)

2002-09-16
- vdi/gsxasm1.S - fixed bug in CLC_FLIT (no regs was saved) (MAD)
- vdi/gsxasm1.S - also needed reg-save wrapper added for vec_len (MAD)

2002-09-17
- vdi/monout.c - smul_div now in C (part. from fVDI) (MAD)
               - pline optimized (from fVDI) (MAD)
               - vec_len implemented in C (MAD)

2002-09-18
- vdi/text.c - trnsfont implemented in C (MAD)

2002-09-20
- vdi/vdimain.c - precalculated shift offset shft_off for concat (MAD)
- Makefile, include/config.h, country.mk, bios/country.c - changed the way
  UNIQUE country EmuTOS are built. Now make unique 192 and 256k work for
  all languages (e.g. make allbin; rm obj/*.o; make all192) but there is
  some redundancy as I can't figure yet how to avoid duplication between
  country.mk and country.c (LVL)
- tools/bug.c - removed indent warning (LVL)
- include/version.c - set version to 0.5 (LVL)
- bios/clock.c - disabled nvram code for TOS1 192k ROMS (LVL)
- bios/bios.c bios/machine.[ch] bios/startup.S - int native_features
  renamed to int has_natfeats (LVL)
- bios/initinfo.c - changed wait time from 5 to 2 sec (MAD)

2002-09-21
- doc/announce.txt - updated for release 0.5 (MAD)

2002-09-27
- Makefile - replaced "-O2" by "-Os" for smaller size (MAD)

2002-09-01
- doc/status - updated a bit (MAD)

2002-09-03
- bdos/bdosmain.c - Removed unused Setvec/Getvec functions. (THH)
- vdi/monout.c - abline() in C part. implemented (commented out) (MAD)

2002-09-05
- vdi/monout.c - abline() in C compl. implemented (MAD)

2002-09-06
- vdi/monout.c - abline() in C optimized (MAD)

2002-09-09
- vdi/monout.c - abline() in C more optimized (MAD)

2002-09-12
- vdi/monout.c - abline() simplified (better for color) (MAD)
               - habline() initially implemented (MAD)

2002-09-15
- vdi/monout.c - abline() always starts with smaller x value (MAD)
               - habline() fully implemented in C (MAD)

2002-09-17
- vdi/monout.c - abline() new old algorithm and bug free (MAD)
               - abline() opt. (color now faster, than old asm) (MAD)
- bios/linea.S - made CLC_FLIT as linea_6 working. (MAD)

2002-09-18
- vdi/monout.c - put_pix() for linea reimplemented in C (MAD)
               - get_pix() for linea reimplemented in C (MAD)
               - rectfill() implemented in C (MAD)

2002-09-20
- vdi/monout.c - abline() bugs fixed. Thanks, Johan! (MAD)

2002-09-21
- vdi/tranfm.S - vr_trnfm() implemented in assembler (MAD)
- vdi/monout.c - rectfill() in C (MAD)
               - habline() uses same sub-routines as rectfill() (MAD)
- vdi/gsxasm1.S - concat() moved to gsxasm2.S, where it is used (MAD)

2002-09-22
- vdi/monout.c - replaced asm vr_trnfm() by Johan's impl. in C (MAD)
               - fixed bugs in horizontal line drawing modes (MAD)
- vdi/tranfm.S - removed from compile in Makefile (MAD)

2002-09-25
- vdi/monout.c - fixed bug in color setting (MAD)

2002-09-27
- vdi/monout.c - optimized horzline() and rectfill()  (MAD)

2002-09-29
- make etoscpr.img makes experimental compressed-RAM-inside-ROM (LVL)
- use make comprtest to test the compressor (LVL)
- bios/memory.s - debug messages optional (LVL)
- added -pedantic to $(NATIVECC) options, killed some warnings in tools (LVL)

2002-09-30
- tools/compr.c et al - added a header in the compressed data, for a cleaner
  handling of the destination address in ROM (LVL)
- Makefile - code factorisation, various optimisations, foo.dsm is
  desassembly for foo.img (LVL)
- util/comprtst.sh - changed . t into sh -f t for portability (LVL)
- doc/status.txt - changed the table of supported emulators, to include date
  of update of individual entries (LVL)
- doc/install.txt - documented some of the current makefile targets (LVL)

2002-10-05
- renamed _FOO_H into H_FOO_ for standard C compliance (I kept the script
  which did it in case anybody wants to change back or again) (LVL)
- bdos/time.[ch] - regrouped stuff here, and connected it to _evt_timer (LVL)
- bdos/rwa.S - removed some useless remnants, osinit now in C (LVL)
- vectors.S - unused vectors _int_timera, ... deleted; priv and illg now
  correctly jump to the default exception vector (LVL)
- tosvars.h, vdimain.c - etv_timer gets an int argument (LVL)
- bios.c - commented out illegal error setting, as I don't think it does the
  right thing [changing a move SR, to CCR, is done by the priv stuff] (LVL)

2002-10-12
- merged tools/keytbl2c and util/dumpkbd.c - now dumpkbd.prg directly
  generates keyb_xx.h (LVL)
- Makefile - fixed a bug in make depend (LVL)

2002-10-13
- renamed font files, to allow a systematic handling of fonts (LVL)
- bios/country.c - tables now generated from country.mk in bios/ctables.h (LVL)
- Makefile - introduced $(TOCLEAN) that gradually stores the name of files
  to be removed when doing make clean, to make it harder to forget files
  in make clean (LVL)
- doc/country.txt - updated, but still not entirely satisfactory (LVL)

2002-10-14
- Makefile - some more optimisations: removed tedious $(PBIOSCSRC) stuff;
  less sub-processes are launched (e.g. grep | sed | sort | sort replaced
  by the more logical sed | sort ... sometimes you just see when things
  were done (by me!) just using a trial and error method) (LVL)
- portab.h - removed commented-out and some seldom used macros. Ultimately
  I would like to replace NULL-used-to-mean-char-zero by '\0' and have
  NULL and NULLPTR be ((void*)0). Then we could replace NULLPTR by NULL and
  forget about NULLPTR... (LVL)

2002-10-18
- genctables.awk - portable awk, country names need not be 2 chars long (LVL)
- bios/processor.[hS] - 68040 instruction cache stuff (LVL)
- bdos/proc.c - instruction cache invalidation on pexec (LVL)
- bios/vectors.S - illegal instruction handler now changes move-from-CCR to
  move-from-SR (LVL)
- bios/bios.c - illegal instruction handler only called on a bare 68000 (LVL)
- Makefile - if a file local.mk is found, it will be included at the end just
  before targets clean and distclean, for optional individual targets (LVL)
- ikbd.[ch] - dead keys (see keyb_fr.h for an example of how to configure
  the keyboard to use it); ALT-keypad to enter chars by decimal numbers (LVL)
- added "%p" in printf format string to print pointers as 0x%08lx (LVL)
- changed again H_FOO_ to FOO_H (sorry about this, I won't change it
  a third time) (LVL)
- include/config.h - removed "i18nconf.h" from there, as it caused trouble
  with tools needing "string.h" but not "i18nconf.h" (LVL)

2002-10-19
- bios/bios.c - display initinfo before you start booting from a device
  so that users have time to press and hold the Alt key to skip the boot (PES)
- bios/blkdev.c - added check for the Alt key (PES)
- bios/initinfo.c - can't display the boot device - it's unknown ATM (PES)
- bios/bios.c - check for Ctrl key fixed (hold it to skip AUTO\*.PRG) (PES)
- bios/initinfo.c - delay can be interrupted by Shift/Ctrl/Alt keys (PES)
- bios/cookie.c - number of free slots corrected (PES)
- bios/machine.c - COOKIE_NATFEAT created (PES)
- bios/startup.S, bios/disk.c, bios/machine.c - NatFeat instruction codes
  changed to LineF $fe00/$fe01 (PES)

2002-10-20
- bios/startup.S, bios/disk.c, bios/machine.c - NatFeat instruction codes
  changed back to good old $7300/$7301. The LineF interface requires
  the $fe0x instructions to be long words and I am not ready to accept
  such change of NatFeat calling convention. Sorry. (PES)

2002-10-28
- bios/bios.c - loading of AUTO folder programs displayed on stderr console
  via new NF_STDERR (sorry for the mess in bios.c, the nf calling must be
  cleaned up somehow). (PES)

2002-10-31
- Makefile - changed, so that vdi/lisaesc.S is used again (MAD)
- aes/gemdosif.S - changed to lowercase and put _back after entry (MAD)

2002-11-02
- aes/geminit.c - held Ctrl key causes not loading the ACCs (PES)

2002-11-03
- bios/xhdi.[ch] - XHDI implemented - allows running FreeMiNT (PES)
- bios/disk.c - some functions moved to the xhdi.c (PES)
- bios/blkdev.c - initialization order changed (PES)
- bios/machine.c - add XHDI cookie to the jar (PES)
- bios/startup.S - XHDI entry point (PES)
- bios/initinfo.c - missing #include (PES)

2002-11-07
- util/intmath.c - central impl. of (s)mul_div()    (MAD)
- aes/gemdosif.h - change tikaddr and tiksav to void *  (MAD)

2002-11-09
- aes/gemgsxif.c - changed i_lptr1 to use just one argument (MAD)

2002-11-16
- aes/gemdisp.c - schedule() loop now sleeps with the STOP #2300 insn (PES)

2002-11-22
- vdi/vdimain.c - change timer vectors to be used as pointers (MAD)

2003-01-13
- bios/natfeat.[hS] - NatFeat stuff moved to separate files (PES)
- bios/startup.S, bios/machine.c - cleaned up (PES)
- "__NF" cookie now contains pointer to the NatFeat structure with
  function pointers (PES)

2003-01-14
- bios/vectors.S - the screenpt must be cleared after successful video
  registers update (PES)
- NatFeat calling cleaned up - uses function pointers now (PES)

2003-01-20
- bdos/fsdir.c - Fsfirst/Fsnext nesting fixed. This was a very important
  fix since without this the AUTO folder processing didn't work (Standa)
- bdos/proc.c - local or global variable referenced? Fixed by a wild
  guess (Standa)
- bios/bios.c - restore our DTA when processing the AUTO folder since
  the executed AUTO program could have changed it in the meantime (PES)
- bios/blkdev.c - TOS uses a different algorithm for detecting whether
  a FAT partition is 12-bit or 16-bit. From mtools I understood that
  anything with non-floppy-standard cluster number (probably 720/1440)
  is considered to be 16-bit FAT. Without this patch 4 MB disk image
  formatted with TOS could not be used under EmuTOS. Now fixed (PES)

2003-01-21
- bdos/fsfirst.c - yesterday's patch corrected (Standa)
- bios/bios.c - the Setdta() should not be needed (Standa)

2003-01-29
- bdos/kpgmld.c - cleaned interface with proc.c a little bit (LVL)
- bdos/proc.c - yet another cleanup of the xexec() implementation; there
  should be no memory leak any more in case of IO error, but of course this
  feature is untested as of now (LVL)

2003-02-01
- bios/ikbd.[ch] - dead keys fixed, backspace seems to work okay now (LVL)

2003-02-06
- bios/bios.c - natfeat printing changed back to kprintf (PES)
- bios/screen.[ch] - a routine for programming VIDEL to produce any of
  bitplane modes on VGA monitor with 640x480 res. added. Also proper VIDEL
  reset is now done on init. The last missing thing is to fetch the
  pre-selected boot resolution from the NVRAM and apply it. Until then
  the default boot resolution will be the 2-color mode (PES)

2003-02-07
- bios/natfeats.c, natfeat.h, natfeat.S - general cleanup, library of NF
  functions added (PES)
- bios/kprint.c, kprintasm.S - ARAnyM code removed, NF support added (PES)
- bios/machine.[ch], bios.c - updated for new NF library (PES)
- Makefile, doc/install.txt, include/config.h - updated to support NF (PES)

2003-02-07
- doc/announce.txt - updated for release 0.6 (MAD)

2003-02-08
- bios/natfeats.c - display the short emu name so that initinfo fits in
  40 columns screen resolution (PES)
- aes/geminit.c - check the Control key only once, not before loading each
  accessory. The harddrives are so fast that it doesn't make sense to try
  and skip only some accessories ;-) (PES)
- bios/initinfo.c - corrected displaying of free RAM so it fits in 40 cols.
  Also added a TOS like boot timeout with a little boot guide and a gfx
  effect of countdown :-) (PES)
- include/config.h - #define TIMEOUT_ON_BOOT here or in your localconf.h.
  This was added especially to make Thothy happy - he doesn't like long
  boot timeouts... (PES)
- po/cs.po - Czech translation updated (PES)
- bios/initinfo.c - moved up the time bar a few lines (MAD)
- vdi/esclisa.S - used this instead of buggy vdiesc.c  (MAD)
- bdos/console.c - better code style (MAD)
- vdi/vdiesc.c - used this again  (MAD)
- po/de.po - updated (MAD)

2003-02-09
- doc/annouce.txt - minor english language rewording (LVL)
- po/fr.po - updated (LVL)
- include/version.h - set to 0.6 (LVL)
- include/config.h - added DETECT_NATIVE_FEATURES (I assume it was only in
  Petr's localconf.h) and set it to 1 by default. I checked that it works on
  on both non-nf-enabled-yet STonX and on newly-nf-enabled STonC. I suggest
  to get rid of the STonX native print stuff as soon as I commit to STonX the
  quick natfeat implementation I just added to STonC (LVL)
- natfeat_init() called in memory.S, for earlier availability of kprintf (LVL)
- bios/bios.c - DBGAUTOBOOT added so that the AUTO crash is visible (PES)
- bios/ikbd.c - corrected debug typo (PES)

2003-02-10
- bios/bios.c - now using the reentrant trap1_pexec() to load programs (THH)

2003-02-11
- vdi/monout.c - bug in abline's C-implementation found (MAD)
- vdi/*.c - enabled line drawing in C again (MAD)

2003-02-12
- bios/ikbd.c - initial settings of conterm hopefully fixes the hotkeys
  in XaAES (PES)
- Fixed some bugs in EmuCON (for example the initial Mshrink was not working).
  Now it is also possible to quit it with "EXIT" again. (THH)
- EmuCON can now be compiled into EmuTOS together with the AES/Desktop and
  it can even be executed from the Desktop now! (THH)
- tools/bug.c - Added missing include file. (THH)
- util/intmath.c - fixed bug in mul_div, circles work again (MAD)
- po/de.po - updated (MAD)

2003-02-15
- desk/deskapp.c - Icon masks are working now (THH).
- po/fr.po - updated. I think we should put back the EmuCON strings in it,
  since we now have decided to put back the console in EmuTOS. The size will
  not be a problem for 512k images, and for other sizes UNIQUE is fine.
  However this will have to wait till I fix bug to bring back old entries
  into life. (LVL)
- bios/comprimg.S - added natfeat_init stub, converted debug print from STonX
  to NF_STDERR (LVL)
- Makefile - version string deduced from doc/changelog.txt (only partly
  done, the version in the desk info menu is still taken from version.h) (LVL)
- bios/bios.c, natfeat* - NF_SHUTDOWN tried before halting (LVL)

2003-02-18
- bios/screen.c - Falcon VIDEL better supported. Should allow boot in colors
  but there is still something wrong in the EmuTOS as it requires the rez_reg
  to be set (can't find out why) (PES)

2003-02-19
- bios/screen.c - cleaned up the getrez a bit (MAD)

2003-02-20
- bios/screen.[ch] - VIDEL color registers supported, EmuTOS can boot
  in 2, 4 or 16 colors now! (PES)
- bios/screen.[ch] - setphys() safeguard check (PES)
- bios/nvram.c - fixed wrong offset, added static buffer for nvram data (PES)
- bios/machine.c - early initialization of nvram (PES)
- bios/screen.c - make use of NVRAM boot resolution setting. Tested on
  ARAnyM (aranym -e -r <X>) and should work also on real Falcon030. (PES)
- doc/announce.txt - updated for 0.6 release (MAD)

2003-02-21
- bios/lineainit.c - quick patch to get 8x16 font in all resolutions with
  screen height >= 400 (PES)
- include/config.h - boot countdown time increased to 8 seconds (PES)
- po/cs.po - updated (PES)

2003-02-27
- vdi/* - found bug in C-pattern filling, enabled again (MAD)
- Makefile - EmuCON is compiled in by default now (MAD)

2003-03-03
- aes/geminit.c, gemshlib.c : Experimental support for #Z line in EMUDESK.INF
  to start another desktop instead of the ROM desktop. (THH)

2003-03-08
- vdi/mounout.c - fixed bug in clipbox() (MAD)

2003-03-10
- bdos/time.c - implemented Tgettime() and Tgetdate() (MAD)

2003-03-22
- bdos/bdosmain.c - ripped out unused oscnt variable (MAD)
- bdos/bdosmain.c - added two wrappers to avoid compiler warnings (MAD)
- include/bindbios.h - now use fully prototyped inline BIOS bindings (MAD)

2003-03-23
- include/xbindbios.h - now use fully prototyped inline XBIOS bindings (MAD)

2003-04-12
- bios/screen.c - some debug prints (LVL)
- bios/vectors.S - the new palette pointer to load during VBL now erased when
  loaded (previously it was loaded at every VBL!) (LVL)
- include/config.h, bios/kprint.c - kprintf() prints to MIDI out port when
  MIDI_DEBUG_PRINT flag activated (to get debug prints e.g. on Steem) (LVL)
- fixed some .cvsignore files (LVL)

2003-04-13
- bios/sound.c - Fixed a wrong byte in the system bell data. (THH)
- include/xbiosbind.h - Added binding for Dosound(). (THH)
- aes/optimize.c - sound() now really makes sound with Dosound()! (THH)
- bios/biosmem.c - explanatory comment about memtop and membot added (LVL)

2003-04-17
- util/boot.c - removed 192k size limitation in RAMTOS loader (LVL)

2003-04-19
- bdos/proc.c - proc_go() now better documented (LVL)
- tools/mkheader.awk - simpler and smaller replacement of mkheader.c (LVL)
- doc/country.txt - updated following removal of mkheader.c (LVL)
- bios/country.h bios/ctrycodes.h - country codes now in separate file (LVL)
- Makefile - make cvsready now also expands awk files (LVL)
- bios/sound.c - minor comment editing (LVL)
- include/asm.h - removed ints_off()/ints_on() macros as I really think their
  direct use of the stack for storage is unsafe/unportable in conjunction
  with a C compiler (LVL)
- vdi/*.c - replaced ints_off(); ... ints_on(); by the traditional way:
  WORD old_sr; ... old_sr = set_sr(2700); ... set_sr(old_sr); (LVL)
- util/miscasm.S - gratuitious optimisation (LVL)
- bdos/comprimg.S - fixed syntax error in debug stuff (LVL)
- */*.c - replaced GNU extension '\e' by the proper ANSI '\033' (LVL)
- cli/coma.S - fixed bug preventing EmuCON usage from the desktop (LVL)
- bios/vectors.S - stack restored before jumping in dopanic() (LVL)
- bios/panicasm.S - made panic message a little bit more robust (LVL)
- bios/kprint.c - fixed dopanic() (LVL)

2003-04-21
- bios/initinfo.c bios/bios.c - hitting 'C' during initinfo launches an early
  EmuCON, as a first step towards what Petr really wants (?) (LVL)
- Makefile - bug no longer unnecessarily built when making UNIQUE=us (LVL)
- cli/command.c - implemented prototypes for gemdos bindings (LVL)
- bdos/fs.h - fixed DTA.dt_fname: the correct size is 14 bytes, not 12 (LVL)

2003-04-22
- aes/gemshlib.c, aes/gemstart.S, aes/gemdos.c : Fixed problem with shel_write
  when parameter isover was 0. (shel_write on the Atari-GEM does not execute a
  program directly!). I also included a new dos_exec function that makes the
  handling of the rlr->p_uda->u_spsuper problem much more easier (the new
  dos_exec has basically been taken from the old Lisa-GEM). (THH)

2003-04-24
- aes/gemsuper.c, aes/crysbind.h, aes/gemwmlib.c : Added wind_new() function
  (called wm_new internally). TeraDesk seems now to be working fine. (THH)

2003-05-01
- doc/authors.txt - historic part fixed (LVL)

2003-05-05
- bdos/* - minor header cleaning (LVL)
- desk/desk_rsc.c bios/initinfo.h include/version.h - version consistently
  extracted from the changelog; EmuTOS URL added in about dialog (LVL)
- doc/changelog.txt - converted dates to ISO YYYY-MM-DD format (LVL)
- desk/desk_rsc.c - menu sizes adjusted so that they fit in the screen (LVL)

2003-05-11
- bdos/bdosmain.c : Changed the GEMDOS version to a more reasonable number
  since some programs might depend on this value. (THH)

2003-05-13
- bdos/proc.c : Registers are now initialized to 0 again in proc_go() since
  some programs need A0 = 0 to test if they are running as a normal program
  or as an accessory. (THH)

2003-05-21
- bios/lineainit.c vdi/vdimain.c : Moved initialization of shft_off to
  lineainit.c so that some line-a functions also work from AUTO folder. (THH)

2003-05-26
- aes/gemsuper.c, aes/gemevlib.c : Fixed a problem with the mouse buttons
  in certain programs (Thing, Pixart, etc.). (THH).

2003-05-29
- aes/gemrslib.c : Fixed the remaining bug with TeraDesk by using an extra
  buffer for a temporary string (Quitting QED caused a crash or error message
  when it was launched from TeraDesk) (THH).

2003-05-31
- aes/rectfunc.c : Function inside() did not work if one of the parameters
  x or y was negativ => Changed type from UWORD to WORD. (THH)

2003-06-03
- readme.txt : made ready for binary releases  (MAD)

* Release: 0.7

2003-06-26
- bios/bios.c: initialize unknown level interrupts to just RTE (not bombs)
  (PES)

2003-07-04
- bios/bios.c: also initialize level int 0x11 to just RTE, not
  date_time (needed by Diablo-Emulator for  LM-laserprinter (MAD)

2003-07-06
- aes/gemsclib.c : Return value of sc_read() is now compatible to Atari GEM
  again and sc_clear() now clears all scrap files in the clipboard. (THH)

2003-07-12
- po/es.po: added Spanish translation of EmuTOS, created by Gabriel Huertas
  <gabrielhuertas@terra.es> (PES)

2003-07-13
- bios/clock.c: NVRAM RTC year offset now detected from RTC_TOS_VER (PES)
- include/config.h: RTC_TOS_VER documented but not defined by default (PES)
- Makefile: new target 'aranym' added - it defines all required features.
  The 'falcon' target was removed (I don't believe current EmuTOS would
  work on real Falcon) (PES)
- doc/todo.txt: removed a couple of entries that I believe were done (PES)
- bios/disk.c: added debug kprintf's to partition detection code (PES)

2003-07-21
- aes/gemstart.S: _dos_exec() - jsr _dsptch removed on THH suggestion.
  This fixes the EmuDesk Shutdown crash I was experiencing (PES)
- vdi/blit.c: implemented vrt_cpyfm, vro_cpyfm and bit_blt in C  (MAD)

2003-07-25
- aes/gemstart.S: _dos_exec() still having problem. Had to increase
  the stack offset from 0x40 to 0x50 (PES)

2003-07-27
- desk/* : Fixed some of the "Desktop 1.2" patches and added three new menu
  entries in the file menu that are needed to use this desktop mode. (THH)

2003-07-29
- vdi/blit.c: reactivated assembler implementation of vrt_cpyfm,
              vro_cpyfm and bit_blt till C is bug free  (MAD)

2003-07-31
- doc/*: updated doc to clarify country-oriented misunderstandings (LVL)

2003-08-02
- po/fr.po: updated
- tools/bug.c Makefile: bug produces util/langs.c directly; bug no longer
  complains about unknown charsets. (LVL)

2003-08-11
- po/de.po: Added missing strings and adjusted some of the form_alert strings
  to the 40 characters per line limit. (THH)
- aes/gemrslib.c: rs_str() now uses gettext(), too. (THH)
- desk/deskmain.c desk/deskapp.c aes/gemsuper.c: More bugfixes for the
  "Desktop 1.2" patches: Solved problems with window sizes and menu bar! (THH)

2003-08-17
- aes/optimize.c : sound() can now be disabled. (THH)
- desk/deskact.c : Fixed drawing problems while dragging one icon on another
  one in the "Desktop 1.2" mode. (THH)

2003-08-28
- desk/desk_rsc.* desk/desk1.c desk/desksupp.c : Added some missing information
  and warning strings for the "Desktop 1.2" mode. (THH)
- Makefile : The "Desktop 1.2" mode is now enabled by default. (THH)

2003-08-29
- util/string.c : Added sprintf() function. (THH)
- desk/*.c aes/*.c : Replaced old merge_str() function by sprintf(). (THH)
- po/*.po : Replaced the old formating characters for merge_str() with the
  new formating characters for sprintf(). (THH)

2003-09-04
- desk/deskinf.c : Fixed a year-2k-bug and a buffer overflow when browsing a
  directory with huge files. (bugfixes based on John C. Elliott's FreeGEM
  desktop sources - thanks!). (THH)

2003-09-06
- desk/desksupp.c desk/desk1.c aes/gemgrlib.c aes/gemsuper.c :
  graf_shrinkbox() and graf_growbox() have been enabled again. (THH)

2003-09-25
- aes/gemfmalt.c aes/gem_rsc.c : The buttons in the form-alert boxes have now
  been placed at the bottom instead of the right of the box. fm_alert() also
  uses right clipping now, so there should be no more crashes when using a
  form-alert box in ST-LOW resolution. (THH)

2003-10-06
- desk/desk_rsc.c desk/deskinf.c po/*.po : Increased the size of some strings
  so that the desktop can also display the size information of huge files.
  Up to 4GB should be working now.  (THH)

2003-12-24
- Added George Nakos' greek translations. (THH)

2004-01-07
- bios/machine.c: _MCH cookie now contains 0x50000 on ARAnyM (PES)
- util/string.c,h: strncasecmp() added

2004-01-27
- desk/desk_rsc.c util/langs.h: preprocessor syntax fixed (LVL)
- include/asm.h include/biosbind.h include/xbiosbind.h: fixed embedded asm
  constructs (thanks to Patrice Mandin) (LVL)
- po/fr.po: french translation updated (LVL)

2004-02-02
- bios/cookie.c: cookie_add() was not checking jar size. Fixed. Also the jar
  size increased to 20 entries (since EmuTOS takes 11 entries for itself).

2004-06-19
- include/portab.h: BOOLEAN replaced by BOOL (changed all over the code) (MAD)
- vdi/blit.c: implementation of cpy_fm() in C. copyrfm.S no longer needed (MAD)

2004-06-21
- vdi/blit.c: implementation of bitblt() in C. (MAD)

2004-06-22
- vdi/blit.c: fixed bug with info.p_addr. (MAD)

2004-06-23
- vdi/blit.c: fixed bug with skew mask. (MAD)

2004-06-23
- vdi/blit.c: tuned. C-blit now just 6 times slower than asm version. (MAD)

2004-06-26
- doc/status.txt: updated to reflect successful run of recent EmuTOS on a
  MegaSTE (this is reported by Frédéric Pécourt who is curently testing EmuTOS
  on a extension board of his own for the MegaSTE) (LVL)

2004-07-07
- vdi/*: cleaned up unneeded assembler labels in VDI (MAD)

2004-07-14
- vdi/blit.c*: fixed vtr_cpyfm() and vro_cpyfm() and optimized clipping (MAD)

2004-07-18
- vdi/seedfill.c: implemented end_pts() in C, no gsxasm2.S anymore (MAD)
- vdi/monobj.c: fixed gdp_rbox() for correctly rounded corners (MAD)

2004-07-20
- vdi/gsxasm1.S: concat moved to textblt.S - just used here anymore (MAD)

2004-07-25
- vdi/monout.c: implemented clc_flit in C, no more gsxasm1.S (MAD)
- vdi/*.S:      removed files, that are no longer needed:
                copyrfm.S gsxasm1.S gsxasm2.S esclisa.S tranfm.S (MAD)
2004-07-27
- vdi/text.c: fixed the clc_dda function (MAD)

2004-07-31
- vdi/*: pass pointer to vwk to all VDI functions (MAD)
- vdi/*: refactored/renamed all VDI files (MAD)

2004-08-01
- vdi/*:           make more use of vwk struct's member variables (MAD)
- vdi/vdi_mouse.c: implemented xfm_crfm in C (MAD)

2004-08-02
- po/cs.po: translated missing strings (PES)

2004-08-03
- bios/cookie.h: _FDC cookie now uses correct "ATC" identification string (THH)

2004-08-04
- bios/tosvars.S: kbdvec added in order to satisfy FreeMiNT 1.16.1 that
                  relies on an undocumented TOS >= 2.0 feature (PES)
- bios/aciavecs.S: jump to ikbd.c via the kbdvec with scancode in d0 (PES)

2004-08-05
- vdi/vdi_main.c: eleminated most doubleing to Assembler variables (MAD)
- vdi/vdi_text:   isolated text specific stuff in vdi_text.c (MAD)
- vdi/vdi_defs.h: more cleaned up (MAD)

2004-08-12
- vdi/vdi_mouse.c: implemented cursor drawing in C (MAD)

2004-08-14
- vdi/*: eleminated use of global X1,Y1,X2,Y2 variables (MAD)
         introduced structures Rect, Line, Point (MAD)

2004-08-16
- vdi/vdi_line.c: optimized horizontal line drawing (MAD)
- vdi/vdi_fill.c: unified rectfill with the above (MAD)

2004-08-19
- vdi/vdi_bezier.c: implemented not filled bezier curves (MAD)
                    filled onces also, but not integrated (MAD)

2004-08-19
- bios/processor.S: added coldfire test in detect_cpu (MAD)

2004-08-26
- vdi/*.c: ripped off some more global variables (MAD)
- vdi/fill.c: fixed fills to use fill color, not line color (MAD)

2004-10-08
- vdi/vdi_mouse.c: implemented vex_wheelv() (MAD)

2004-10-09
- bios/ikbd.c: keyboard repetition respects 1st bit of conterm (PES)
               conterm initialized (we never did that before) (PES)
- doc/bios.txt: fixed description of conterm bits (PES)

2004-10-18
- bios/conout.S: removed from CVS (MAD)
- bios/conout.c: hardware dependent optimized console stuff (MAD)
- bios/vt52.c:   hardware independent rest of vt52 console (MAD)

2004-10-19
- bios/conout.c: some integer overflow bugs fixed (MAD)

2004-11-24
- Makefile: Replaced "-oformat" by "--oformat" (THH)

2004-11-29
- doc/coding.txt vdi/*.S: replaced all MOVEM.W by MOVEM.L as the MOVEM.W
  (memory to register) destroys the upper 16 bits of the registers :-( There
  was perhaps no real bug, but at least now there's no risk that someone
  not aware of this creates a bug by re-using a routine with MOVEM.W (LVL)
- Makefile: (hack) target '256' now builds a UNIQUE EmuTOS (LVL)
- bios/mfp.c: ACIA interrupts no longer enabled by mfp_init() (LVL)
- bios/bios.c: clarified order of ACIA initialization (LVL)
- bios/aciavecs.S: fixed bug with status packets; implemented ikbdstate and
  documented in some detail (the Compendium was wrong); also documented known
  remaining differences between EmuTOS and the original TOS (LVL)
- bios/tosvars.[Sh]: ACIA stuff updated in sync with aciavecs.S (LVL)
- bios/vectors.S, bios/*.c: glue functions protect_xxx() used to safely call
  external user-supplied routines (hooks, vectors, ...) even if those alter
  registers D2/A2. Done for: bell_hook, kcl_hook, hdv_rw, hdv_mediach,
  hdv_bpb, bcoxxx[]. In fact I was surprised to see that some vectors are
  never called (hdv_init, hdv_boot, etv_term, etv_critic). Is it a bug? (LVL)
- bios/ikbd.c, bios/sound.[ch]: keyclick() reportedly gets scancode as
  argument in register d0 (LVL)
- bios/vt52.c: bell() called depending of bit 3 of conterm (LVL)

2004-12-03
- bios/processor.S: TTRs registers setup on a 68040 (probably quite useless
  on our current emulators, but who knows...) (LVL)
- aes/gemgraf.c: removed the -1 pixel correction in gsx_tblt(); the AES text
  displays correctly now (used to be displayed one pixel up, which was
  annoying on small resolutions) (LVL)
- aes/gemgraf.c: improved display of window elements by ensuring that
  gl_wbox is wide enough to hold the character glyphs (LVL)
- bios/vectors.S: fixed bug in VBL interrupt routine (_vblsem is WORD) (LVL)
- aes/gem*.c: wider slidebars (grep "anemic slidebars" to see the previous
  code where the slide bars were not as wide as their containing box) (LVL)

2004-12-13
- bios/fontdef.h: removed (MAD)
- bios/font.c: now contains (nearly) all font related stuff (MAD)
- bios/font.h: headers for that (MAD)
- bios/lineainit.c: stripped down to pure screen setting (MAD)
- bios/lineavars.h: put font and vt52 related stuff in seperate files (MAD)
- bios/lineainit.c: ripped out color setting (MAD)

2004-12-15
-  aes/gem_rsc.c: Changed background color of the desktop to green. (THH)

2005-01-15
- bios/disk.c: added DOS PTBL recognition (primary partitions only) (PES)
- bios/xhdi.c: reformatted (PES)
- bios/blkdev.[ch]: added flag for byteswap (unused yet, TODO) (PES)

2005-01-25
- desk/deskmain.c, desk/deskwin.c: Fixed a bug that caused a crash when
  dragging icons on the desktop. (THH)

2005-04-11
- desk/desk_rsc.c: Changed the string and button sizes in the desktop dialogs
  so that the non-english versions of EmuTOS look much better. (THH)
- po/*.po: Slightly updated the language files. (THH)

2005-04-12
- vdi/vdi_fill.c vdi/vdi_misc.c vdi/vdi_fill.c desk/deskmain.c cli/command.c
  bios/vt52.h  bios/floppy.c aes/geminit.c: Applied patches from Markus
  Oberhumer that fix emutos compilation when using GCC 3.3.5. (THH)
- */*.c */*.h: Started to implement proper prototypes for all functions (to
  compile EmuTOS with -Wmissing-prototypes and -Wstrict-prototypes). (THH)

2005-04-13
- bios/nvram.c: Added patch from Gerhard Stoll that checks for valid parameters
  in the function nvmaccess(). (THH)
- po/es.po: Added up-to-date translations from Gabriel Huertas. (THH)
- bios/tosvars.*: Fixed annoying bug: The two system variables _bell_hook and
  _kcl_hook were linked at a wrong position due to a missing ".global" in the
  assembler file and a missing "extern" in the header file. (THH)

2005-04-14
- po/es.po: Some more updates from Gabriel Huertas. (THH)
- country.mk: Enabled spanish language. (THH)
- bios/blkdev.h: Fixed a signed/unsigned comparison problem that occured in
  the function blkdev_mediach() when it checks the serial number. (THH)

2005-04-18
- bios/bios.c bios/initinfo.c cli/command.c: Screen is now cleared after the
  boot splashscreen and cursor blinking is turned off. (THH)
- bios/screen.c: Fixed bug in Setscreen() - it must not use screenpt but it must
  set the new physical screen address immediatly. (THH)

2005-04-21
- bios/fnt_l9_*.c: Added the Latin-9 fonts. (THH)
- po/LINGUAS po/es.po bios/country.h country.mk: Now using the Latin-9 fonts
  for the Spanish translation. (THH)
- Fixed some linking errors when compiling with "-fno-common". (THH)

2005-04-25
- vdi/vdi_line.c: Changed draw_rect() a little bit (which is used for drawing
  filled polygons) so that the game "Ballerburg" now looks normal again. Well,
  I hope this change doesn't break anything else... (THH)

2005-04-26
- vdi_asm.S/vdi_mouse.c: Support for mouse wheel (vex_wheelv) via Eiffel
  style IKBD status packets. (JKL)

2005-04-27
- bios/fnt_l9_*.c: Fixed a problem with the Spanish fonts - added some missing
  characters. (THH)
- aes/geminit.c: The "#Z" line in EMUDESK.INF now also works if it is not the
  last line in that file. (THH)
- bios/screen.c: Added gap between screen ram and phys_top. (THH)

2005-04-28
- aes/gemwmlib.c: Default owner of the desktop window is now the current
  application, not the screen manager. This fixes the problem that some
  programs did not receive mouse button events. (THH)
- bios/linea.S vdi/vdi_mouse.c: Enabled the Line-A functions dis_cur & hide_cur
  again (they still seem to work fine and are needed for GFA Basic). (THH)

2005-04-29
- po/gr.po: Added George Nakos' update for the Greek translation. (THH)

2005-05-01
- aes/gemsuper.* aes/gemdosif.S: Slightly improved the super() function (the
  AES trap entry point function). (THH)
- aes/gemrslib.c: Menu dividers now look normal again. (THH)

2005-05-02
- bios/screen.c: Added screen resolution switching support to the Setscreen()
  XBIOS function (for ST screen modes only at the moment). (THH)

2005-05-09
- bios/linea.S: Line-A #9 must be v_show_c() and not dis_cur(). (THH)
- vdi/vdi_mouse.c: Mouse must not be displayed again if it is already visible.

2005-05-11
- aes/gemfmalt.c: Mouse pointer is now always turned on while displaying a
  "form_alert" alert box. (THH)

2005-05-12
- bios/tosvars.S aciavecs.S: Moved kbdvbase and iorec structures and buffers
  from tosvars.S to aciavecs.S since they are not officialially documented
  system variables. (THH)

2005-05-19
- bios/bios.c: Bconout() did not work correctly with characters >= 128. (THH)
- bios/startup.S: Changed the size of the initial stack from 16384 to 2048
  bytes - that is still more than enough, I hope. (THH)

2005-05-22
- aes/gemgsxif.c aes/geminput.*: Fixed the problem that the mouse was not
  moving in certain programs. (THH)

2005-05-23
- bios/screen.c: Setscreen() now also reinitializes the font settings when the
  resolution changes. (THH)
- bios/bios.c startup.S: Some code cleanup - renamed startup() to bios_init(),
  removed unused code, etc. (THH)

2005-05-30
- desk/desk_rsc.c: Increased the size of a string buffer so that Greek and
  Spanish translations don't cause a buffer overflow anymore.
- Updated the documentation for version 0.8

* Release: 0.8

2005-06-20
- cli/command.c: Fixed some typos (thanks to Eero Tamminen for the patch). (THH)
- po/fi.po: Added Finnish translation made by Eero Tamminen. (THH)

2005-07-05
- tools/tos-lang-change.c: Added Eero Tamminen's TOS language change program.
- country.mk bios/country.h bios/keyb_se.h: Added Swedish/Finnish keyboard
  table (THH).
- tools/mkheader.awk: Fixed OS_PAL to contain the right PAL/NTSC flag. (THH)
- desk/desk_rsc.c: Adjusted some dialog string positions so that the Finnish
  and French translation fit better into the dialogs. (THH)

2005-07-11
- aes/gemgrlib.c: Fixed stupid bug that prevented window dragging when EmuTOS
  was build with UNIQUE=xx option. (THH)

2005-07-12
- bios/startup.S: Changed size of initial stack back to > 8000 words. This is
  a work-around for some strange crashes with FreeMiNT and GFA-Basic. Someday,
  somebody with a lot of spare time should try to find the real cause for these
  crashes... (THH)

2005-07-22
- vdi/vdi_control.c: Implemented vs_color and vq_color (for ST/STe). (THH)

2005-07-24
- vdi/vdi_control.c vdi_col.c: Moved vs_color and vq_color to a new file and
  improved vq_color a little bit. (THH)
- desk/desksupp.c: Fixed do_format() so that the desktop can now load
  FORMAT.PRG to format floppy disks. (THH)

2005-08-08
- bios/keyb_se.h: Added bracket keys for Swedish/Finnish keyboards - thanks to
  Eero for the information about the right locations of the keys. (THH)

2005-08-30
- po/de.po: Fixed some form_alert strings that were too big. (THH)

2005-09-08
  Patches by Roger Crettol:
- bdos/proc.c bdos/rwa.S: Correctly pass register D0 to _gouser in processing
  gemdos xterm (0x4C) call - was broken
- bios/keyb_sg.h bios/country.h country.mk: Support for swiss german keyboard
- cli/command.c: Revised ECHO, suppressing extra newlines in batch mode

2005-09-18
- desk/desk_rsc.c: Removed some more unused strings. (THH)
- doc/authors.txt doc/announce.txt: Updates for version 0.8.1 (THH)

* Release: 0.8.1

2005-09-19
- vdi/vdi_asm.S: reversed mouse wheel direction, now Milan compatible (PES)

2005-10-04
- po/fi.po: Eero Tamminen has updated the Finnish translation. (THH)

2006-02-20
- bdos/kpgmld.c: kpgm_relocate() added (SOP)
- bdos/proc.h: PE_RELOCATE Pexec mode 50 defined (SOP)
- bdos/proc.c: PE_RELOCATE mode added - it gets raw TOS executable data
  (the complete mint.prg) and relocates it as if it was loaded normally. (SOP)
- bdos/{umem.c, iumem.c}: some conditional debugging added (SOP)
- bios/bios.c: bootstrap() added - loads and starts MiNT kernel from emulator
  via BOOTSTRAP NatFeat.
  Also added a safety call to Setdta() after loading an AUTO program. Fixes
  problem with loading programs after BETADOS.PRG (it probably scratched
  the DTA buffer upon starting thus the consequent Fsnext() didn't work) (SOP)
- bios/natfeat.[ch]: nf_bootstrap(), nf_getbootdrive() added (SOP)
- Makefile: dd in cygwin needs binary flags (SOP)
- po/fr.po: Patrice Mandin translated cli/command.c to French and says that
  NLS is broken since untranslated CLI crashes (instead of falling back
  to English as Laurent designed it) (PES)

2006-05-03
- bios/kprint.c: fix bus error register printout for MC68040 (PES)

2006-05-05
- bios/vectors.S: _int_hbl handler had incorrectly commented the internal
  logic. And then Andreas noticed the misplaced jump label that could cause
  system crash if IPL was 1 or 2. (PES)

2006-05-22
- bios/natfeat*: nf_getbootstrap_arg() added (SOP)
- bios/bios.c: bootstrap arguments added (SOP)

2006-11-03
- bios/bios.c: natfeat_init() called as the very first thing in bios_init()
  so that first kprintf() can make use of the NF output, if available (PES)
- bios/startup.S: do not set supervisor stack before meminit as you don't
  know yet if there is any RAM at all. Also RAM might be cleared in meminit()
  eventually so you can't rely on the stack, anyway. Also kprintf_init()
  is now called here (before it was hidden in meminit()). (PES)
- bios/memory.S: main new feature is that all RAM is now cleared upon cold
  boot (if memvalid flags are not set correctly). This should ensure that
  EmuTOS does not crash during boot when it copies color registers from
  (previously uninitialized) memory to HW regs in VBL routine.
  kprintf() is no longer used here since it's too early (stack is not set
  yet because it would be overwritten, also all variables would be cleared).
  New #define ST_MMU and FALCON_MMU introduced. We should IMHO separate
  these routines and not include them in one EmuTOS binary. I doubt anyone
  would want to run ST EmuTOS on Falcon or vice-versa. (PES)

2006-11-18
- bios/memory.S: don't clear non-existing FastRAM (PES, thanks to Milan)

2007-01-18
- bios/screen.c bios/xbios: Implemented XBIOS functions EsetShift() and
  EgetShift() for setting and getting TT shifter mode. (THH)

2007-02-13
- bios/mmory.S: Check wether machine can really handle 32 address bits before
  setting up the FastRAM. EmuTOS now works in Falcon mode on Hatari again (THH)

2007-02-14
- bios/acsi.c: Fixed ACSI driver to also work with Hatari (THH)

2007-02-16
- bios/screen.c: Added sanity check - EmuTOS only supports up to 16 colors, so
  do not set 256 or 16-bit color mode during boot! (THH)
- bios/nvram.c: NVRAM checksum calculation was wrong - fixed now. (THH)

2007-02-22
- bios/screen.c bios/xbios.c: Experimental implementation of vsetmode (for VGA
  only at the moment). (THH)

2007-04-05
- desk/desk_rsc.c po/*.po: Updated the year in the copyright statement. (THH)

* Release: 0.8.2

2007-07-17
- bios/blkdev.[ch]: PUN_INFO structure added to satisfy FreeMiNT that wants
  to know the max sector size for setting up disk buffer. (PES)
- tosvars.[Sh]: export pun_ptr for setting up the PUN_INFO struct. (PES)

2007-07-24
- util/nlsasm.S: beware, movea.l does NOT set flags! Caused crashes.. (PES)
- util/nlsasm.S: empty string was not translated correctly and that was
  causing scary crashes. Fixed by explicit check for empty string.
  Intentionally not cached in the RAM cache since the empty strings are
  often replaced with something else at runtime. The cache can be rather
  dangerous in this respect... (PES)

2007-11-06
- vdi/vdi_control.c: Fixed v_clrwk() - the function now calculates the screen
  size in a proper way. (THH)
- vdi/vdi_defs.h cli/command.c: Fixes for compiling EmuTOS with GCC 4.2. (THH)
- include/nls.h util/nlsasm.S: Small size optimization - Do not use gettext()
  at all anymore when CONF_NO_NLS is set during "make UNIQUE=xx" (THH)
- util/nlsasm.S aes/optimopt.S: Hack for compiling EmuTOS with GCC 4.2.
  This compiler sometimes expects return values for pointers to be passed back
  in A0 instead of D0. So gettext() and scasb() have now been changed to
  satisfy this requirement. (THH)

2007-11-08
- util/memmove.S include/string.h: Removed the deprecated and unused function
  bcopy. (THH)
- util/stringasm.S: Patched strchr() for GCC 4.2. (THH)
- vdi/vdi_control.c: Now using memset() in v_clrwk() to clear the screen - this
  is hopefully a little bit faster than the former dumb loop. (THH)

2007-11-15
- aes/geminit.c aes/gemshlib.* aes/gemstart.S desk/desk_rsc.c desk/deskmain.c:
  Added the possibility to change the resolution between ST-low and ST-medium
  resolution (highly experimental!). (THH)

2007-11-19
- vdi/vdi_col.c: Palette is now initialized during v_opnwk() and added color
  mapping for 4 color mode (ST medium resolution). (THH)
- util/nlsasm.S util/stringasm.S: Removed A0-return-value hacks since there
  is a version of of GCC 4.2 (ported by Olivier Landemarre) which does not
  suffer from this annoying A0 "bug". (THH)
- desk/desk_rsc.c: Disable menu entry for changing resolution again - it is
  still way too incomplete for the public. (THH)

2008-01-05
- bios/screen.c: Since we only support VGA resolutions by now, toggle the
  double-scan bit in vsetmode when a RGB mode is requested. (THH)
- include/asm.h util/miscasm.S: Changed macros for swapping the endianess of
  a variable to use inline assembler - that's faster and less code. (THH)

2008-01-06
- include/config.h: STOP instruction will now be used by default when a
  TOS version >= 2.00 is compiled. (THH)
- bios/clock.c: Got rid of RTC_TOS_VER - the year offset in the NVRAM is now
  autodetected. (THH)
- vdi/vdi_mouse.c: Fixed off-by-one bug in VDI mouse driver. (THH)

2008-01-21
- include/biosbind.h bdos/fs.h: Added support for the extended Rwabs call,
  with lrecno parameter. (THH)

2008-02-07
- bdos/time.c bios/clock.c: Cleaned up and fixed BIOS and GEMDOS time and
  date functions, IKBD clock basically works now, too. (THH)

* Release: 0.8.3

2008-03-26
- bios/clock.c: EmuTOS did not work on STonX anymore due to a bug in the RTC
  detection. (THH)

2008-06-11
- bdos/fsmain.c: Dsetdrv returned an error code in case the specified drive
  number was invalid. However, it must return the drive mask of the available
  drives instead. (THH)
- bdos/floppy.c bdos/acsi.c: According to the Profibuch and Scheibenkleister,
  the DMA address registers must be written in a certain order. (THH)

2008-06-13
- bios/chardev.c bios/kprint.c bios/mfp.c: Added experimental support for the
  MFP UART input and output. (THH)
- bios/floppy.c bios/acsi.c: The timeout_gpip() function was declared twice,
  in acsi.c and floppy.c. Merged them now into one function only. Thanks to
  Jens Caroll for the hint! (THH)

2008-09-17
- bios/machine.c: Fixed cookies setup: _SWI cookie was never initilized, and
  in the _SND cookie the DMA sound bit was never set. (THH)

2008-09-29
- cli/command.c: Check for valid drive when running the SHOW command. (THH)

2008-10-03
- cli/command.c:
   -> Declared local functions and variables as static. (patch by E. Tamminen)
   -> Reworked the help texts. (patch by E. Tamminen)
   -> Removed command aliases ERA and INIT. (THH)

2008-10-29
- bios/parport.c: Fixed return value of bcostat0 (thanks to David Savinkoff
  for the hint) (THH)

2008-11-03
- bios/parport.c: Fixed bconout0 so that printing should be working now
  (thanks to David Savinkoff for the patch) (THH)

2008-11-14
- cli/command.c: Disabled the moldy commands FORMAT, GETBOOT and PUTBOOT (THH)
- cli/command.c: Removed the global 10k big buffer. (THH)
- cli/coma.S: Increased the stack size a little bit. (THH)

* Release: 0.8.4

2008-11-23
- bios/initinfo.c: timeout on boot removed - hold <Shift> if you miss it (PES)

2008-11-24
- bios/memory.S: memvalid setting moved to BIOS (PES)
- bios/bios.c: check for cold/warm start, show initinfo on coldstart only (PES)

2008-12-13
- bios/initinfo.c: global variable early_cli must not be initialized or it
  gets to DATA area in ROM space where you can't change its value later (PES)

2009-06-11
- bdos/bdosmain.c: GEMDOS function dispatcher now handles the amount of
  parameters on the stack correctly. No more accesses beyond the TPA. (THH)

2009-06-25
- desk/deskfpd.c: Fixed empty desktop windows with GCC 4.x.
  (patch by Vincent Rivière)

2009-06-27
- vdi/vdi_blit.S: Fixed crash in bit_blt() at desktop startup when compiled
  without -fomit-frame-pointer. (patch by Vincent Rivière)

2009-08-14
- bios/screen.c: Fixed Getrez() for TT shifter resolutions. (THH)

2009-09-05
- Makefile: Added a CPUFLAGS variable to allow easy compilation for a specific
  CPU on the make command line. For example, use "make CPUFLAGS=-m68020-60 512"
  to build an EmuTOS version optimized for 68020 CPUs and higher.
  (patch by Vincent Rivière)

2010-01-01
- vdi/vdi_mouse.c: Fixed completely wrong Initmous() parameter that was
  causing an interrupt storm on real IKBD STe hardware.
  (patch by Vincent Rivière)

2010-01-02
- bios/floppy.c: Fixed writing to floppy on real STe hardware (added
  missing DMA_WRBIT). Fixed Flopver() (Compendium is a misleading
  source of information, use tos.hyp wherever possible). Fixed Flopfmt()
  by aligning the buffer address and correcting the sector header byte.
  (patch by Vincent Rivière)

2010-01-19
- bdos/fsdir.c: Fixed Dcreate(). The new directory had a second "." entry
  instead of "..". (VRI)

2010-01-20
- bios/floppy.c bios/floppy.h bios/xbios.c: The XBIOS floppy functions now
  return errors codes in the full 32 bits of d0 like TOS. (VRI)

2010-02-21
- cli/command.c: In EmuCON, removed the volume label from the list of files
  displayed by the DIR command. (VRI)

2010-05-03
- bdos/fsdrive.c: Renamed log() to log_media() so that it can not be confused
  with the logarithmic function. (THH)

2010-05-07
- bdos/fsmain.c, bdos/fsglob.c: Changed code to support up to 32 drives instead
  of only 16 drives. (THH)
- bdos/*: Added a lot of hacks to get bigger partitions running. It's not
  working stable yet, so the code is still disabled by default. (THH)

2010-05-08
- vdi/vdi_text.c: Fixed infinite loop in act_siz(). (VRI)
- vdi/vdi_tblit.S: Fixed bit_blt() which was copying garbage when the source
  rectangle had infortunate alignement, like the background of most TeraDesk
  dialogs. (VRI)

* Release: 0.8.5

2010-05-13
- bios/linea.S: Fixed crash in Line A $a00f stub. (VRI)

2010-05-17
- Change name of internal VDI functions in conflict with standard VDI name
  (to be able use gem library if needed). (olandemarre)

2010-05-24
- include/config.h: USE_STOP_INSN_TO_FREE_HOST_CPU must be defined after
  TOS_VERSION since its definition depends on TOS_VERSION. (THH)

2010-05-25
- bios/memory.S: Improved memory detection which should now also work on a
  real STe (patch by Jean-François DEL NERO)

2010-05-27
- vdi/vdi_defs.h, vdi/vdi_tblit.S, vdi/vdi_text.c: Added a Vwk* parameter
  to text_blt() in order to be able to transmit it to act_siz(). Also fixed
  text_blt() for backuping the scratch registers when calling act_siz().
  (patch by Jean-François DEL NERO + VRI)

2010-05-31
- Makefile: (VRI)
   -> Replaced recursive calls to make by $(MAKE). Replaced -Xlinker by -Wl.
   -> Removed useless command chainings with the shell's ';'.
   -> Added UNIQUE initialization to avoid warnings when
      --warn-undefined-variables is used.
   -> Disabled the useless "Entering directory" messages, since the current
      directory is never changed.

2010-06-06
- desk/deskmain.c aes/gemdisp.c aes/geminit.c: Added some debug messages
  and the defines DBG_DESKMAIN, DBG_GEMDISP and DBG_GEMINIT. (VRI)

2010-06-06
- aes/gemasm.S aes/gemdosif.S aes/gemstart.S aes/gsx2.S aes/large.S
  bdos/rwa.S bios/aciavecs.S bios/bios.c bios/cookie.h bios/initinfo.c
  bios/kprint.c bios/kprintasm.S bios/linea.S bios/machine.c
  bios/memory.S bios/natfeat.S bios/panicasm.S bios/processor.S
  bios/startup.S bios/tosvars.S bios/vectors.S cli/coma.S include/asm.h
  include/config.h util/memmove.S util/memset.S util/miscasm.S
  util/nlsasm.S util/stringasm.S vdi/vdi_asm.S vdi/vdi_raster.c
  vdi/vdi_tblit.S: Added ColdFire V4e CPU support. (VRI)
- Makefile: Added the COLDFIRE variable. Set it to 1 to build a ROM version
  compatible only with ColdFire V4e processors. (VRI)

2010-06-13
- bios/bios.c bios/initinfo.c bios/initinfo.h:
  Clear the screen on reboot. (VRI)

2010-06-13
- bios/gemasm.S: Changed the dsptch/switchto implementation to switch the
  AES tasks using a standard RTS rather than a CPU dependent RTE. (VRI)

2010-06-15
- bdos/proc.c: Start new processes in the standard IPL 3. (VRI)

2010-06-15
- desk/deskstart.S: Run the desktop in user mode. (VRI)

2010-06-15
- desk/deskact.c: Fixed crash when moving icons. (VRI)

2010-06-19
- bios/processor.S: Implemented invalidate_icache() for ColdFire. (VRI)

2010-06-19
- cli/coma.S: Run EmuCON in user mode. (VRI)

2010-08-02
- bios/conout.c: Fixed crash on reverse scrolling. (VRI)
- bdos/fs.h bdos/fsdir.c: VFAT long file names are now totally ignored
  and are no longer displayed as invalid files. (VRI)
- bdos/fsopnclo.c: Removed the characters '^`~ from the list of forbidden
  characters in filenames to match MS-DOS rules. (VRI)

2010-09-15
- tools/tos-lang-change.c: Added missing languages. (patch by Dima Sobolev
  + VRI)
- country.mk bios/country.h bios/ctrycodes.h bios/fnt_ru_6x6.c
  bios/fnt_ru_8x16.c bios/fnt_ru_8x8.c bios/keyb_ru.h po/LINGUAS
  po/ru.po tools/tos-lang-change.c: Added Russian language. (patch by
  Dima Sobolev)

2010-09-25
- bios/iorec.h: Added a workaround for GCC 4.5.x bug 45052. Because of that,
  the keyboard didn't work when USE_STOP_INSN_TO_FREE_HOST_CPU=0. If unsure,
  compile with -fno-ipa-pure-const as full workaround. That bug will be
  fixed in GCC 4.5.2. (VRI)

2010-09-29
- bios/ikbd.c: Added key click on key repeat. (VRI)

2010-10-02
- bdos/bdosmain.c bdos/console.c cli/command.c: Fixed BDOS and EmuCON to
  allow the usage of the full 8-bit character set on console I/O. (VRI)
- bios/xhdi.c: For unimplemented XHDI opcodes, return EINVFN instead of ERR.
  Patch contributed by David Gálvez. (VRI)

2010-10-25
- bios/natfeat.S bios/xhdi.c bios/xhdi.h: Reimplemented the XHDI stub to
  backup all the registers to conform to the XHDI specification. (VRI)

2010-10-26
- bdos/umem.c: Fixed Malloc() and Mxalloc() to return blocks aligned on
  multiple of 4 bytes. Long alignment improves speed in FastRam. (VRI)

2010-11-02
- bdos/iumem.c bdos/umem.c: Improved traces on memory management. (VRI)
- bdos/iumem.c bdos/umem.c bios/biosmem.c: Really fix Malloc() and others
  for 4-byte alignment. The previous patch was not enough. (VRI)

2010-11-06
- bios/bios.c: Fixed a small memory leak when there is no bootstrap program.
  (VRI)
- bdos/proc.c bios/bios.c: Fixed a memory leak and a crash when the
  relocation of the bootstrap program fails. (VRI)
- bios/bios.c: Fixed a memory leak when the bootstrap program finishes
  successfully. (VRI)
- tools/mkflop.c: Added a check for the size of ramtos.img when doing
  "make flop". (VRI)
- bios/bios.c: Show the init screen when EmuTOS is loaded from RAM. (VRI)

2010-11-07
- bios/memory.S bios/screen.c bios/tosvars.S vdi/vdi_raster.c:
  Use 0xffffxxxx instead of 0x00ffxxxx to access I/O registers. (VRI)
- aes/gemsuper.c desk/deskmain.c: Moved desktop traces into the AES,
  since kprintf() is not always available from user mode. (VRI)

2010-11-22
- Makefile: Use full 32-bit addresses, including in disassembly. This is
  necessary when the ROM is located at a nonstandard place. (VRI)
- bios/biosmem.c: Cleaned-up bmem_init() for 32-bit addresses. (VRI)
- bios/kprint.c: Improved dopanic() output. Better support for ColdFire
  stack frames. Each line must be printed with a single kcprintf() to be
  well displayed when the debug traces go to the console. (VRI)

2010-11-29
- desk/desk_rsc.c desk/desk_rsc.h desk/desksupp.c: Moved the strings
  FORMAT.PRG and FORMAT.TTP from the resource file to desksupp.c to make
  room. (VRI)

2010-12-26
- bios/conout.c: Fixed console line wrap in high resolutions. (VRI)
- cli/command.c: Fixed crash in EmuCON when typing a command name longer
  than 100 characters. (VRI)
- bios/conout.c: Fixed the BIOS console to support 256 color modes. (VRI)
- bios/conout.c: In EmuCON, keep the cursor enabled when running textmmode
  programs. (VRI)
- bios/conout.c: Do not flash the cursor when it moves. (VRI)

2010-12-28
- aes/funcdef.h aes/gemdosif.S aes/gemdosif.h aes/gemgsxif.c
  aes/gemgsxif.h aes/geminput.c: Added minimal support for mouse wheel in
  the AES. (VRI)
- desk/deskwin.c: Fixed clipping when a non-top window is scrolled. (VRI)

2010-12-29
- bios/aciavecs.S bios/ikbd.c bios/tosvars.h vdi/vdi_asm.S
  vdi/vdi_mouse.c: Added BIOS and VDI support for extended mouse buttons
  3, 4 and 5. (VRI)
- desk/deskmain.c: Added scrolling on desktop windows using arrow keys. (VRI)

2011-01-02
- desk/deskpro.c: Removed useless space in front of the command line of
  textmode programs. (VRI)
- desk/desk_rsc.c desk/desk_rsc.h desk/deskapp.c: Added desktop support for
  GTP executables. (VRI)

2011-01-08
- vdi/vdi_mouse.c: Call user_but() only if the state of the extended buttons
  has really changed. (VRI)
- bios/ikbd.c vdi/vdi_asm.S vdi/vdi_mouse.c: Added support for the Eiffel
  mouse wheel using simple scancodes instead of status frames. (VRI)
- aes/geminput.c: Disabled mouse wheel until we find a solution to send
  WM_ARROWED from forker(). (VRI)

2011-02-12
- bios/clock.c: Fixed wrong seconds in Gettime() on machines having NVRAM. (VRI)

2011-04-15
- bios/conout.c: invert_cell(): use the x and y parameters. (VRI)
- bios/conout.c: Fixed cursor blink when moving backwards. (VRI)

2011-04-18
- aes/gemgraf.c aes/gemfmlib.c aes/gemfmlib.h aes/gemrslib.c: Fixed warnings
  with GCC 4.5.2. (VRI)
- bios/screen.c: Fixed wrong return value for vsetmode(). (VRI)
- aes/gemfslib.c aes/geminput.c aes/gemobed.c aes/gemoblib.c aes/gemshlib.c
  bios/machine.c cli/command.c desk/deskapp.c desk/desksupp.c vdi/vdi_gdp.c
  vdi/vdi_mouse.c vdi/vdi_text.c: Fixed warnings with GCC 4.6.0. (VRI)
- bios/clock.c: Fixed IKBD Y2K issues by using a pivot year at 80. (VRI)

2011-04-20
- bios/kprint.c: Fixed dopanic() for all the processors. (VRI)
- bios/clock.c: Fixed seconds when reading the Mega ST clock. (VRI)

2011-04-22
- bios/clock.c bios/clock.h: Removed dead code. (VRI)
- bios/clock.c: Added debug traces. (VRI)
- bios/clock.c: Enabled setting the date on NVRAM machines. (VRI)
- bios/clock.c: Fixed setting the date on MegaRTC machines. (VRI)
- bios/clock.c: Fixed Y2K issues when setting the IKBD date. (VRI)

2011-04-27
- bios/initinfo.c: Fixed the displayed startup date on Steem. (VRI)
- tools/mkheader.awk: Fixed the BCD build date in the ROM header to match the
  MMDDYYYY format used in Atari ROMs. (VRI)

2011-04-29
- cli/command.c: Display EmuCON build year on 4 digits. (VRI)

2011-07-26
- country.mk Makefile bios/country.h bios/keyb_it.h po/it.po po/LINGUAS:
  Added Italian translation stubs. (VRI)

2011-07-29
- desk/desk_rsc.c po/ru.po: Fixed the menu separator lines length in the
  Russian translation. Contributed by Dima Sobolev. (VRI)
- po/gr.po: Converted to LF line endings. (VRI)
- po/cs.po po/de.po po/es.po po/fi.po po/fr.po po/gr.po po/it.po: Updated
  from new sources. (VRI)
- desk/desk_rsc.c po/de.po po/es.po po/fi.po po/gr.po po/ru.po: Fixed all
  the menu separator lines length (some of them were still wrong). (VRI)

2011-08-05
- desk/icons/*.icn desk/icons/iconhi.h desk/icons/iconlo.h
  desk/icons/read.me: Converted to LF line endings. (VRI)
- desk/icons/*.icn desk/icons.c: Fixed icon data ordering for GCC 4.6. (VRI)
- desk/deskins.c desk/icons.c desk/icons.h: Added constness. (VRI)
- Makefile desk/icons.c: Removed the icons dir from system include path. (VRI)

2011-08-05
- desk/icons/deskhi.icn desk/icons/desklo.icn: Set as binary in CVS. (VRI)
- util/bootasm.S util/bootsect.S: Added ColdFire support. (VRI)
- util/boot.c: Fixed warnings with GCC 4.6.1. (VRI)

2011-08-12
- .cvsignore Makefile: Added the firebee target. (VRI)
- Makefile: Compile the aranym target with -m68040. (VRI)
- Makefile: Added the defines MACHINE_ARANYM and MACHINE_FIREBEE to identify the
  machine-specific ROMs from inside the sources. (VRI)
- bios/bios.c include/config.h: Added new define ALWAYS_SHOW_INITINFO to show
  the welcome screen on every boot. Enabled by default on the FireBee. (VRI)
- bios/bios.c bios/initinfo.c include/config.h: Added new define
  INITINFO_DURATION to set the welcome screen duration. (VRI)
- bios/machine.c: Fixed machine_name() for the FireBee. (VRI)
- desk/desk_rsc.c: Reworked some dialogs for French texts. (THH)
- po/fr.po: Changed "Pas de clic" to "Auto" to fit the button. (VRI)
- Makefile include/config.h: Moved machine-specific defines to config.h. (VRI)
- bios/memory.S: Added another sanity check for emulators that do not emulate
  the mirroring of memory banks. (THH)

2011-08-13
- Makefile bios/bios.c bios/biosmem.c bios/startup.S include/config.h:
  Replaced the is_ramtos variable by the EMUTOS_RAM define to determine if
  EmuTOS is running in RAM. (VRI)

2011-08-14
- bios/comprimg.S bios/memory.S bios/startup.S: Fixed the ecpr256k.img target
  compilation (but still not functional). (VRI)

2011-08-15
- Makefile: Allow to build the shared sources with different preprocessor
  defines. (VRI)
- bios/memory.S: Fixed the compressed image targets (ecpr256k.img and
  ecpr192k.img). (VRI)
- bios/tosvars.S: Removed useless globals. (VRI)
- desk/deskmain.c: Removed dead DBG_DESKMAIN. (VRI)
- Makefile bios/comprimg.S: Use tosvars.S instead of redefining the
  variables. (VRI)
- bios/comprimg.S util/uncompr.S: Added ColdFire support. (VRI)
- Makefile: Added missing PHONY targets. (VRI)
- Makefile: Added a rule to build .s19 files. (VRI)
- Makefile: Added easily overridable VMA variable. (VRI)

2011-08-16
- Makefile: Disabled special .exe handling no more useful on Cygwin. (VRI)
- *.S: Replaced .xdef by .extern. (VRI)
- bios/screen.c bios/screen.h: Fixed the STe default palette. (VRI)
- Makefile bios/bios.c bios/dmasound.c bios/dmasound.h bios/machine.c
  bios/machine.h: Added LMC1992 initialization. (VRI)
- bios/dmasound.c bios/machine.c bios/machine.h: Moved DMA sound detection
  to the right place. (VRI)

2011-08-17
- bdos/fs.h bdos/fsfat.c bdos/fsio.c bdos/fsopnclo.c: Big partition support
  part 1. Remove the test for negative cluster numbers. Contributed by Roger
  Burrows. (VRI)
- bios/memory.S: Fix the stack after calling check_read_byte() to avoid
  potential stack overflow. (VRI)
- bios/memory.S: Added support for up to 14 MB ST-RAM on cold boot. (VRI)
- aes/gemstart.S bios/memory.S: Replaced bsr by jsr to call externals. (VRI)
- desk/desksupp.c: Run FORMAT.TTP in text mode. (VRI)
- desk/desk_rsc.c po/*.po: Changed the message when the format program is not
  found. It was too long in the french translation and crashed. (VRI)

2011-08-18
- bios/dmasound.c bios/machine.h: Improved Microwire detection. (VRI)
- bios/machine.c bios/cookie.h: Added Falcon DMA sound to _SND cookie. (VRI)
- bdos/fs.h bdos/fsfat.c bdos/fsio.c: Big partition support part 2.
  Change the types of variables used in cluster handling. Contributed by Roger
  Burrows. (VRI)
- vdi/vdi_raster.c: Fixed the C implementation of bit_blt() when the destination
  width is spanning a single word (usually width <= 16 pixels). This was visible
  when moving a window slightly on the right over an icon. (VRI)

2011-08-19
- desk/deskmain.c: Fixed wrong reloading of large windows. (VRI)
- desk/deskmain.c: Reposition the windows saved outside the screen into the
  current desktop area. (VRI)
- aes/gemmnlib.c: Added support for accessory menu separator line customized
  using a USERDEF (ex: CF-Lib, QED).

2011-08-20
- Makefile bios/ide.c bios/ide.h bios/xhdi.c include/config.h: Added very
  minimalistic IDE support. Currently enabled only on the FireBee. (VRI)

2011-08-21
- bios/blkdev.c bios/blkdev.h: Better FAT12/FAT16 detection. (VRI)

2011-08-22
- bios/initinfo.c: Save CPU time during the welcome screen. (VRI)
- po/ru.po: Added missing translations. Contributed by Dima Sobolev. (VRI)
- desk/desk_rsc.c desk/desk_rsc.h desk/deskmain.c po/fr.po: Enabled the
  Change Resolution menu item on ST resolutions. (VRI)
- desk/deskmain.c: Disable Erase on drives and trash (was crashing). (VRI)

2011-08-23
- po/ru.po: Added missing translations. Contributed by Dima Sobolev. (VRI)

2011-08-24
- vdi/vdi_col.c: Fixed the default VDI palette. (VRI)

2011-08-26
- aes/geminit.c aes/gempd.c aes/gempd.h aes/gemshlib.c aes/struct.h:
  Improved rsrc_load() and shel_find() to search also in the application
  directory and the root directory. This fixes the Nethack game. (VRI)

2011-08-30
- bdos/bios.h bios/blkdev.h cli/command.c include/bpb.h: Centralize
  definition of BPB. Contributed by Roger Burrows. (VRI)
- bdos/fs.h bdos/fsbuf.c bdos/fsdir.c bdos/fsdrive.c bdos/fsfat.c
  bdos/fsio.c: Big partition support part 2. Eliminate the usage of negative
  cluster numbers and enable big partitions. Contributed by Roger Burrows. (VRI)
- vdi/vdi_tblit.S vdi/vdi_tblit_cf.S: Minor addq.w fix. (VRI)
- Makefile vdi/vdi_tblit_cf.S: Fixed missed optimization by gas on ColdFire
  from 0(sp) to simply (sp). (VRI)
- Makefile: More genericity to rebuild the ColdFire PortAsm sources. (VRI)

2011-08-31
- bdos/fsfat.c: Fixed freespace calculation. Contributed by Roger Burrows. (VRI)
- bdos/blkdev.c: Fixed Getbpb() number of clusters on MS-DOS-style partitions
  > 32MB. Contributed by Roger Burrows. (VRI)

2011-09-04
- vdi/vdi_bezier.c vdi/vdi_col.c vdi/vdi_control.c vdi/vdi_defs.h
  vdi/vdi_esc.c vdi/vdi_fill.c vdi/vdi_gdp.c vdi/vdi_line.c vdi/vdi_main.c
  vdi/vdi_mouse.c vdi/vdi_text.c: Added static and const where relevant.
  Contributed by Eero Tamminen. (VRI)
- desk/deskdir.c: Make EmuTOS check the "Confirm overwrites" option when copying
  a file from one directory to another. Contributed by Roger Burrows. (VRI)
- vdi/vdi_defs.h vdi/vdi_line.c: Faster arrow drawing. Contributed by Eero
  Tamminen. (VRI)
- vdi/vdi_mouse.c: Fixed potential strict aliasing issue. Suggested by Eero
  Tamminen. (VRI)
- vdi/vdi_control.c vdi/vdi_defs.h vdi/vdi_fill.c vdi/vdi_line.c
  vdi/vdi_marker.c vdi/vdi_mouse.c vdi/vdi_tblit.S vdi/vdi_tblit_cf.S: Added
  more constness. (VRI)

2011-09-05
- bdos/kpgmld.c: Make Pexec() return EPLFMT (-66) for non-executable files.
  Submitted by Roger Burrows. (VRI)
- cli/command.c: Fix output display of EmuCON "show" command to handle 10-digit
  numbers correctly. Submitted by Roger Burrows. (VRI)

2011-09-06
- bios/initinfo.c: Allow EmuTOS startup screen to display drives up to Z: rather
  than just P:. Submitted by Roger Burrows. (VRI)
- bios/blkdev.c: Fix add_partition() to set _drvbits correctly for 16 or more
  drives. Submitted by Roger Burrows. (VRI)
- desk/deskapp.c: Include all drives in the default desktop. Submitted by Roger
  Burrows. (VRI)

2011-09-07
- desk/deskpro.c: Fix erroneous test of DOS_ERR after dos_sdrv() call. Submitted
  by Roger Burrows. (VRI)
- bdos/bdosmain.c bdos/console.c bdos/fsio.c bdos/proc.c bdos/proc.h
  bdos/time.c: Added more static and const. Contributed by Eero Tamminen. (VRI)
- vdi/vdi_defs.h vdi_vdi_line.c vdi/vdi_misc.c: Isqrt() is used only from the
  arrow code, so it can be in the same file. Contributed by Eero Tamminen. (VRI)

2011-09-08
- aes/gem_rsc.c: Changed the alert issued when there is a problem launching an
  application, to include the possibility of a damaged application. Submitted by
  Roger Burrows. (VRI)

2011-09-10
- po/ru.po: Added missing strings. Contributed by Dima Sobolev. (VRI)
- bios/keyb_it.h po/it.po: Added Italian translation. Contributed by Lodovico
  Zanier. (VRI)
- bdos/fsfat.c: Fixes bug: the last two clusters on a drive could not be
  allocated. Submitted by Roger Burrows. (VRI)
- bios/biosmem.c bios/blkdev.c bios/blkdev.h bios/chardev.c bios/clock.c
  bios/ikbd.c bios/kprint.c bios/mfp.c bios/midi.c bios/mouse.c: Remove
  unnecessary includes for bios.h in files in the bios subdirectory. Submitted
  by Roger Burrows. (VRI)
- bios/bios.c bios/biosmem.h include/pd.h: Create centralized pd.h to define
  the Process Descriptor, and update files in the bios directory to use it
  where appropriate. The bios/bios.h file is removed. Submitted by Roger
  Burrows. (VRI)
- po/de.po: Added missing German translations. (THH)
- bios/atari_rootsec.h: Removed the __packed__ attribute on the rootsector
  structure. This is useless in the current m68k-atari-mint GCC because the
  maximal alignment is 2 bytes. And most of all it forces all accesses to word
  and long members with move.b on 68000 to avoid potential address errors,
  causing bad performance. Suggested by Eero Tamminen. (VRI)
- bios/disk.c: Fixed sect and sect2 with an union to avoid alignment suspicion
  and inefficient access to short and long members on 68000. (VRI)
- aes/gemdosif.S aes/gemstart.S bios/aciavecs.S bios/country.c
  bios/contry.h bios/font.h bios/fnt_*.c bios/ikbd.c bios/ikbd.h
  bios/keyb_*.h cli/coma.S tools/bug.c util/langs.h utils/nls.c: Added more
  constness. (VRI)
- bios/bios.c bios/machine.c bios/natfeat.S bios/natfeats.c bios/xhdi.c
  include/config.h: Disable Native Features for TOS 1.xx / 192kB ROMs (THH)
- bios/machine.c bios/natfeat.S bios/xhdi.c include/config.h: Added another
  compile-time switch to disable XHDI on TOS 1.xx to save some more space (THH)
- bios/memory.S: Disable Falcon memory controller support for TOS 1.xx (THH)

2011-09-11
- bios/lineainit.c bios/machine.c bios/screen.c bios/xbios.c include/config.h:
  Added new configuration switch to disable support for Falcon hardware (THH)
- Makefile: Added new flag WITH_DESK1 that can be used to enable the desktop
  with fixed window mode (which does not use icons and needs less memory) (THH)
- bios/clock.c bios/nvram.c bios/screen.c bios/xbios.c include/config.h:
  Added configuration flags for disabling support for TT and NVRAM (THH)
- bdos/bdosmain.c bdos/fs.h bdos/fsdir.c bdos/fsdrive.c: Change variable drvsel
  to LONG to properly support more than 16 drives. This avoids an unnecessary
  bootsector read every time a drive above P: is accessed. Submitted by Roger
  Burrows. (VRI)
- bdos/bios.h bdos/fs.h: Replaces individual definitions of the Process
  Descriptor with include of centralized version (in headers within bdos
  directory only). Submitted by Rober Burrows. (VRI)
- desk/desk_rsc.c desk/deskact.c desk/deskmain.c desk/deskmain.h
  desk/desksupp.c: Static cleanup. Contributed by Eero Tamminen. (VRI)
- Makefile: Display the amount of extra bytes when the sized images are too
  big. (VRI)

2011-09-12
- bdos/bios.h bdos/mem.h: Remove unused items from bdos/bios.h, and move
  definitions of MPB & MD to mem.h. Submitted by Roger Burrows. (VRI)
- include/funcdef.h include/gsxdefs.h include/obdefs.h include/taddr.h: Several
  headers are duplicated between the aes & desk directories. This patch moves
  funcdef.h, gsxdefs.h, obdefs.h, and taddr.h from aes/ to include/, and removes
  the corresponding headers from desk/. Submitted by Roger Burrows. (VRI)
- doc/bios.txt: Converted line endings to LF format. (VRI)
- bios/screen.c desk/deskact.c: Fixed warnings. (VRI)
- bios/lineainit.c bios/machine.c bios/machine.h bios/memory.S bios/screen.c
  bios/xbios.c desk/deskmain.c include/config.h vdi/vdi_col.c: Splitted
  CONF_WITH_FALCON into CONF_WITH_FALCON_MMU and CONF_WITH_VIDEL and added
  tests systematically. (VRI)
- bios/machine.c bios/machine.h bios/screen.c bios/xbios.c desk/deskmain.c
  include/config.h vdi/vdi_col.c: Renamed CONF_WITH_TT to CONF_WITH_TT_SHIFTER
  and added tests systematically. (VRI)
- bios/bios.c bios/clock.c bios/country.c bios/machine.h bios/nvram.c
  bios/nvram.h bios/screen.c bios/xbios.c: Use CONF_WITH_NVRAM
  systematically. (VRI)
- bios/machine.c bios/machine.h bios/screen.c bios/vectors.S include/config.h
  vdi/vdi_col.c: Added the CONF_WITH_STE_SHIFTER define. (VRI)
- bios/bios.c bios/dmasound.c bios/dmasound.h bios/machine.c bios/machine.h:
  Added the CONF_WITH_DMASOUND define. (VRI)
- bios/machine.c bios/machine.h include/config.h: Added the CONF_WITH_VME
  define. (VRI)
- bios/machine.c bios/machine.h include/config.h: Added the
  CONF_WITH_DIP_SWITCHES define. (VRI)
- bios/kprint.c bios/kprint.h include/config.h: Added the CONF_WITH_ASSERT
  define to enable/disable the assert() function. (VRI)
- Makefile: Display the amount of bytes free when building a ROM. (VRI)
- bdos/bdosmain.c bdos/bios.h bdos/console.c bdos/fs.h bdos/fsbuf.c bdos/fsdir.c
  bdos/fsdrive.c bdos/fsfat.c bdos/fsglob.c bdos/fshand.c bdos/fsio.c
  bdos/fsmain.c bdos/fsopnclo.c bdos/iumem.c bdos/kpgmld.c bdos/osmem.c
  bdos/proc.c bdos/umem.c: Add includes for bpb.h to fs.h, fsdrive.c
  bdosmain.c. Remove all references to bios.h in bdos/ source & delete
  bdos/bios.h. Submitted by Roger Burrows. (VRI)
- bios/blkdev.h bios/initinfo.c: Fix the maximum number of drives at 26 (A: thru
  Z:). Note that bdos/fsglob.c still allows up to 32, which means we're wasting
  24 bytes. Submitted by Roger Burrows. (VRI)

2011-09-13
- vdi/vdi_line.c: Fix the minimal width of arrow heads. Contributed by Eero
  Tamminen. (VRI)
- aes/gemgraf.c aes/gemgraf.h desk/aesbind.h desk/desk1.c desk/deskapp.c
  desk/deskapp.h desk/deskdir.c desk/deskfpd.c desk/deskfun.c desk/deskgraf.c
  desk/deskgraf.h desk/deskgsx.c desk/deskinf.c desk/deskinf.h desk/deskins.c
  desk/deskobj.c desk/deskpro.c desk/deskwin.c desk/gembind.c desk/taddr.c
  include/taddr.h: Static cleanup. Contributed by Eero Tamminen. (VRI)

2011-09-16
- bios/bios.c bios/lineainit.c bios/lineavars.h bios/screen.c vdi/vdi_defs.h:
  Declare Line A stuff in lineavars.h header instead of in several C-files.
  Contributed by Eero Tamminen. (VRI)
- aes/gemasync.c aes/gemflag.c aes/struct.h: Fix EVB structure e_pd member type.
  Contributed by Eero Tamminen. (VRI)
- bios/kprint.c include/doprintf.h include/string.h util/date.c util/doprintf.c
  util/dumpkbd.c util/string.c: Add a new include/doprintf.h header for
  util/doprintf.c. Contributed by Eero Tamminen. (VRI)

2011-09-19
- aes/gemwmlib.c: Fixed array out of bounds. (VRI)
- bdos/fsdir.c: Fixed crash when calling Ddelete() or Fattrib() with an invalid
  drive. (VRI)
- bdos/fsdir.c: Fixed potential uninitialized variable. (VRI)
- bios/mfp.c bios/screen.c bios/sound.c tools/genctables.awk: Use static const
  instead of const static for standard complicance. (VRI)
- cli/command.c: Fixed no-op in rename command when the destination file is the
  same as the source file. (VRI)
- vdi/vdi_fill.c: Use static void instead of void static for standard
  complicance. (VRI)

2011-09-20
- bdos/console.c: Fixed backspace key in EmuCON with 8-bit characters. (VRI)
- vdi/vdi_line.c: Fast, full precision square root. Contributed by David
  Savinkoff. (VRI)

2011-09-22
- Makefile: Renamed the ARAnyM ROM to emutos-aranym.img. (VRI)
- Makefile: Changed the default target to "help". (VRI)
- Makefile: Use the VMA_T* variables in the help message. (VRI)
- Makefile: Renamed the FireBee ROM to emutosfb.s19. (VRI)
- include/config.h: Set the FireBee initinfo duration to 8 seconds. (VRI)

2011-09-24
- include/config.h: Added missing initialization of CONF_WITH_DMASOUND. Reported
  by David Savinkoff. (VRI)
- Makefile: Initialize VMA with default value and LMA with VMA. (VRI)
- bios/machine.c: Added DBG_MACHINE. (VRI)
- bios/clock.c: Fix warning when NO_IKBD_CLOCK is not defined. (VRI)
- Makefile: Merge LDFLAGS_VMA to LDFLAGS. (VRI)
- Makefile: Avoid breaking linker lines. (VRI)
- Makefile: Move additional linker options to the end of the command line. (VRI)
- Makefile: Added padding message. (VRI)
- Makefile: Added the # character in front of the output messages. (VRI)
- Makefile: Replaced in by into. (VRI)
- bios/screen.c: Added missing volatile. (VRI)

2011-09-26
- po/de.po: Updated German translation. (THH)
- po/cs.po: Updated Czech translation. Contributed by Pavel Salač. (VRI)
- po/fi.po: Updated Finnish translation. Contributed by Eero Tamminen. (VRI)
- vdi/vdi_line.c: Fixed missing lines whan drawing arrows. Contributed by David
  Savinkoff. (VRI)
- vdi/vdi_line.c: Removed an unused ptr++ in wideline(). Contributed by David
  Savinkoff. (VRI)

2011-09-27
- vdi/vdi_line.c: Fixed random arrow sizes caused by WORD overflow. Contributed
  by David Savinkoff. (VRI)

2011-09-28
- bios/clock.c: Fixed wrong minutes in NVRAM's ndosettime(). (VRI)

2011-09-30
- cli/command.c: Fixed random crash when starting a program in EmuCON. (VRI)

2011-10-01
- bios/screen.c: Added debug trace on vsetmode(). (VRI)
- bios/nvram.c: The NVRAM checksum was checked only on the first call to
  nvmaccess(). Fixed. (VRI)
- bios/machine.c: Added debug traces for AKP and IDT cookies. (VRI)
- bios/screen.c: Always use the default video mode on the FireBee, until the
  VIDEL and vsetmode() are reliable. (VRI)

2011-10-03
- bios/machine.c bios/screen.c: Minor adjustments to ease next conditional
  compilation. (VRI)
- util/intmath.c include/intmath.h vdi_vdi_line.c: Moved Isqrt() to intmath.c
  since it is the right place for integer math. (VRI)
- doc/bugs.txt doc/todo.txt: Update to reflect current status. Contributed by
  Roger Burrows. (VRI)
- bdos/fs.h bdos/fsdir.h bdos/fsopnclo.c: Replace magic numbers for file
  attributes with #defines. Contributed by Roger Burrows. (VRI)

2011-10-05
- doc/fat16.txt: Add documentation for FAT16 filesystem code. Contributed by
  Roger Burrows. (VRI)
- bdos/gemerror.h bios/gemerror.h include/gemerror.h: Move gemerror.h from
  bios/ to include/ and remove gemerror.h from bdos/. Contributed by Roger
  Burrows. (VRI)
- po/es.po: Updated Spanish translation. Contributed by David Gálvez. (VRI)

2011-10-06
- tools/bug.c: Removed unused variable. (VRI)
- Makefile: Fixed problems when switching between UNIQUE builds. (THH)

2011-10-08
- Makefile: The needcountry.tmp hack caused trouble on some build systems, such
  as Ubuntu. Replaced by a more robust phony target. (VRI)
- Makefile: Introduced the ROM_256 variable to specify the name of the 256 kB
  ROM and produce more meaningful message with make allbin. (VRI)
- Makefile: Introduced the ROM_192 variable to specify the name of the 192 kB
  ROM and produce more meaningful message with make all192. (VRI)
- desk/deskact.c: Fixed warnings with make 192. (VRI)
- Makefile: allbin target now builds the 192 Kb images, too. (THH)

2011-10-09
- doc/bugs.txt: Updated the bug list. Contributed by Eero Tamminen. (VRI)

2011-10-10
- po/gr.po: Updated Greek translation. Contributed by Christos Tziotzis. (VRI)

2011-10-14
- bdos/*: Removed all unnecessary #includes from all files within the bdos
  directory. Contributed by Roger Burrows. (THH)
- desk/deskdir.c: Fixed bug that the cursor is sometimes left in the hourglass
  shape after copying a file. Contributed by Roger Burrows. (THH)

2011-10-15
- bdos/fs.h bdos/fsbuf.c: Fix the type of the b_dm field in the BCB, allowing
  casts in fsbuf.c to be removed. Contributed by Roger Burrows. (VRI)
- desk/deskapp.c: Tidy up default desktop arrangement of disk/trash icons.
  Contributed by Roger Burrows. (VRI)
- desk/deskapp.c: Keep the trash icon on the bottom right even if there are
  more icon lines than the current screen. (VRI)
- util/doprintf.c: Fixed wrong %X implementation in doprintf(). (VRI)
- desk/deskapp.c: Fixed default icon positionning in big resolutions when the
  desktop has more than 10 columns or lines of icons. (VRI)
- desk/deskapp.c: Fixed the desktop to display only drives from A to Z. (VRI)
- desk/deskapp.c: Fixed wrong calcluation of number of icons on a line. (VRI)
- util/doprintf.c: Fixed %p regression introduced in my earlier change. (VRI)
- util/doprintf.c: Removed the nonstandard %O, %U and %D. (VRI)
- desk/deskapp.c: Pack the drive icons when some drives are missing. (VRI)

2011-10-16
- Makefile: Make all256 randomly did not recompile some files such as command.c
  on some build hosts (such as Ubuntu). Reported by David Savinkoff. Added a
  sleep in the obj/country recipe as a workaround. (VRI)
- Makefile: Avoid rebuilding makefile.dep when doing "make clean" and some other
  targets. (VRI)
- Makefile: Better make message when emutos-aranym.img is up to date. (VRI)
- Makefile: Update obj/country in a more reliable way using a simply expanded
  variable and the $(shell) function. (VRI)
- Makefile: Removed unnecessary dependencies already in makefile.dep. (VRI)
- Makefile: Always generate a full util/langs.c to avoid trouble. (VRI)
- bios/natfeat.S: Removed useless includes. (VRI)
- Makefile: Reintroduced the sleep workaround since "make all256" still does not
  correctly work on Ubuntu. (VRI)

2011-10-17
- Makefile: Cleanly fix the all256 and all192 targets on ext2 and ext3
  partitions. The sleep command is required because of low resolution
  filesystems limitations. (VRI)
- Makefile: Rollback to the always-execute-recipe method to update obj/country,
  since finally it is perfectly valid and more flexible. (VRI)
- Makefile: Improved build messages. (VRI)
- Makefile: Removed unnecessary removal of obj/country.o include/i18nconf.h.
  They are automatically rebuilt when necessary through dependencies. (VRI)

2011-10-18
- aes/gemaplib.c aes/gemasync.c aes/gemctrl.c aes/gemdisp.c aes/gemdos.c
  aes/gemevlib.c aes/gemflag.c aes/gemfmalt.c aes/gemfmlib.c aes/gemfslib.c
  aes/gemgraf.c aes/gemgrlib.c aes/gemgsxif.c aes/geminit.c aes/geminput.c
  aes/gemmnlib.c aes/gemobed.c aes/gemobjop.c aes/gemoblib.c aes/gempd.c
  aes/gemqueue.c aes/gemrslib.c aes/gemsclib.c aes/gemshlib.c aes/gemsuper.c
  aes/gemwmlib.c aes/gemwrect.c aes/machine.h aes/optimize.c desk/desk1.c
  desk/deskact.c desk/deskapp.c desk/deskdir.c desk/deskfpd.c desk/deskfun.c
  desk/deskglob.c desk/deskgraf.c desk/deskgsx.c desk/deskinf.c desk/deskins.c
  desk/deskmain.c desk/deskobj.c desk/deskpro.c desk/deskrsrc.c desk/desksupp.c
  desk/deskwin.c desk/gembind.c desk/icons.c desk/machine.h include/compat.h:
  Merge aes/machine.h and desk/machine.h into include/compat.h. Contributed by
  Roger Burrows. (VRI)
- aes/dos.h desk/deskfpd.h desk/dos.h include/dos.h: Merge aes/dos.h and
  desk/dos.h into include/dos.h. Contributed by Roger Burrows. (VRI)
- aes/gemasync.c: Fixed potential strict alising bug. (VRI)

2011-10-19
- doc/bugs.txt: Updated the bug list. Contributed by Eero Tamminen. (VRI)

2011-10-20
- bios/initinfo.c include/config.h: Added the configuration define FULL_INITINFO
  to display the full welcome screen at startup or a minimalistic line of text.
  The full initinfo is displayed again with 192k ROMs. (VRI)
- desk/desk_rsc.c desk/desk_rsc.h: Fixed crash when changing resolution from
  the old desktop. (VRI)
- doc/bugs.txt: Desk accessories don't open after changing the resolution. (VRI)
- bios/initinfo.c include/portab.h: Added the UNUSED() macro to fix a warning
  when EmuCON is disabled. (VRI)

2011-10-22
- Makefile: Define NODEP as goal accumulator. (VRI)
- Makefile release.mk: Added "make release" to build the release archives. (VRI)
- Makefile: Removed the obsolete "make tgz". (VRI)
- doc/bugs.txt: The "accessories doesn't open after changing the resolution" bug
  only affects PROCALC.ACC. (VRI)
- doc/bugs.txt: Updated the bug list. Contributed by Eero Tamminen. (VRI)

2011-10-25
- doc/announce.txt: Updated for next release. (VRI)

2011-10-26
- doc/authors.txt: Updated for next release. (VRI)

2011-10-27
- doc/bugs.txt: Removed EmuTOS crash on Steem floppies, as non reproduced. (VRI)
- doc/bugs.txt: Added 7UP hangs on exit. (VRI)
- doc/coding.txt: Updated for next release. (VRI)
- doc/country.txt: Updated for next release. (VRI)
- doc/install.txt: Updated for next release. (VRI)
- Makefile: Fixed typo. (VRI)
- doc/nls.txt: Updated for next release. (VRI)
- doc/old_code.txt: Updated for next release. (VRI)
- doc/status.txt: Updated for next release. (VRI)
- doc/todo.txt: Updated for next release. (VRI)
- readme.txt: Updated for next release. (VRI)

2011-10-31
- readme.txt: Cleaned up. (VRI)
- release.mk doc/changelog.txt doc/readme-192k.txt doc/readme-256k.txt
  doc/readme-512k.txt doc/readme-aranym.txt doc/readme-firebee.txt
  doc/readme-floppy.txt doc/readme-ram.txt: Added specific text which will be
  inserted at the top of the readme file of every binary archive. (VRI)
- release.mk: Converted all .txt files in the binary archives into Windows LF
  line endings. (VRI)
- readme.txt: Added compiler information. (VRI)
- po/es.po: Converted all lines to UNIX LF format. (VRI)
- po/*.po: Fixed line numbers. (VRI)
- bios/fnt_ru_6x6.c bios/fnt_ru_8x16.c bios/fnt_ru_8x8.c bios/memory.S
  bios/processor.S bios/screen.c include/compat.h vdi/vdi_blit.S:
  make cvsready. (VRI)
- Makefile: Added vdi/vdi_tblit_cf.S to "make expand" exceptions. (VRI)
- doc/status.txt: Changed the description of the Mega STe test. (VRI)
- doc/readme-192k.txt doc/readme-256k.txt doc/readme-512k.txt: Added specific
  notes for Hatari. (VRI)

2011-11-06
- bios/blkdev.c: Handle FAT12/16 filesystems correctly when the 'reserved
  sectors' field contains a value other than 1. Contributed by Roger Burrows.
- doc/readme-192k.txt: Changed Hatari note. Contributed by Eero Tamminen. (VRI)
- doc/authors.txt: Added credit to Didier Méquignon. (VRI)
- doc/authors.txt: Added credit to Fredi Aschwanden and the ACP team. (VRI)
- doc/readme-floppy.txt: Fixed make command line. (VRI)
- bdos/fsdir.c: Allow removing a directory containing long file names. (VRI)

2011-11-07
- bdos/bdosmain.c bdos/fs.h bdos/fsdir.c: Fixed Fdatime() random return value.
  This caused EmuDesk to randomly and silently stop when copying a folder. (VRI)
- bdos/fs.h bdos/fsio.c bdos/fsopnclo.c: Fixed creating a read-only file and
  copying a read-only file with EmuDesk. Contributed by Roger Burrows. (VRI)

2011-11-08
- doc/announce.txt: Updated the release date. (VRI)

* Release: 0.8.6

2011-11-10
- aes/gemgsxif.c: Fixed calculation of size of menu/alert screen buffer, and
  added/updated comments. (RFB)
- cli/command.c desk/desk1.c desk/deskapp.h desk/deskmain.c desk/desksupp.c
  include/config.h: Replaced "magic numbers" for sizes of filename/pathname/etc
  with centralised #defines. (RFB)

2011-11-11
- aes/gem_rsc.c aes/gem_rsc.h aes/gemctrl.c aes/gemctrl.h aes/gemevlib.c
  aes/gemevlib.h aes/gemfmalt.c aes/gemfmalt.h aes/gemfslib.c aes/gemfslib.h
  aes/gemmnlib.c aes/gemmnlib.h aes/gemsclib.c aes/gemwmlib.c aes/gemwmlib.h
  bdos/fs.h bdos/fsdir.c bdos/fsopnclo.c bios/disk.c bios/fnt_st_8x8.c
  bios/screen.c bios/vt52.c cli/command.c desk/desk_rsc.c desk/deskmain.c
  desk/deskobj.c include/compat.h include/version.h tools/version.sed: Added
  the const attribute to constant arrays so they moved to the TEXT segment. The
  DATA segment (which is still incorrectly read-only) is now empty. (VRI)
- desk/desksupp.c: Fixed desktop crash when opening a folder that has a
  pathname exactly (LEN_ZPATH-LEN_ZFNAME) bytes long. (RFB)
- desk/deskfpd.c desk/desksupp.c: Fixed incorrect pathname length check
  that caused some valid pathnames to be disallowed. (RFB)
- aes/gemfslib.c bdos/fsdir.c: Replaced more occurrences of "magic numbers"
  for maximum pathname length with centralised #defines. (RFB)

2011-11-12
- Makefile bios/bios.c bios/startup.S include/config.h: New target "make cart"
  to build a diagnostic cartridge into etoscart.img. (VRI)
- bios/bios.c bios/startup.S: Renamed cartscan() to run_cartridge_applications()
  and improved application cartridge comments. (VRI)

2011-11-14
- Makefile: Now "make 192" and "make 256" get the right compile options and
  produce the expected filename. Override the language with UNIQUE=xx. (VRI)

2011-11-19
- bios/asmdefs.h: Moved to include/. (VRI)
- */*.c */*.S: Included config.h at the top of every .c file and asmdefs.h at
  the top of every .S file. (VRI)
- Makefile: Simplified building the dirs list according to the features. (VRI)
- bios/bios.c bios/startup.S cli/coma.S: Added the ability to compile with both
  WITH_AES=0 and WITH_CLI=0. Such ROM is still able to run AUTO and bootstrap
  programs. (VRI)
- Makefile: Removed now useless ROMSIZE autodetection. (VRI)
- Makefile: Beautified the compile command line. (VRI)
- Makefile: Added the ROMSIZE define, in kilobytes. (VRI)
- Makefile desk/desk1.c include/config.h: Moved the definition of DESK1 to
  config.h. (VRI)
- Makefile include/config.h: Moved the special TOS_VERSION for 192 kB ROMs into
  config.h. (VRI)
- desk/desk_rsc.c desk/deskapp.c desk/deskins.c desk/deskmain.c desk/icons.c
  include/config.h: Added the new defines CONF_WITH_DESKTOP_ICONS and
  CONF_WITH_EASTER_EGG instead of testing the TOS version. (VRI)
- Makefile include/config.h: Removed the ROMSIZE define as it broke the non-ROM
  targets. Added TARGET_192, TARGET_256 and TARGET_512 instead. (VRI)
- Makefile doc/readme-floppy.txt: Fixed "make flop" to implicitly use UNIQUE=us.
 (VRI)
- desk/deskinf.c: Fixed random character after am/pm in EmuDesk windows in
  "view as text" mode.
- desk/deskapp.h desk/deskconf.h desk/deskfpd.h desk/deskwin.h: Allow up to 7
  windows on the standard (not fixed window) desktop. (RFB)

2011-11-21
- bios/lineainit.c bios/screen.c bios/screen.h: Set up Videl chip correctly for
  all valid Falcon video modes. (RFB)
- aes/gemgsxif.c: Menu/alert screen buffer is now always 25% of screen memory
  size. (RFB)

2011-11-22
- bios/screen.c bios/screen.h bios/xbios.c: Add support for Falcon video
  syscalls. (RFB)

2011-11-27
- bios/lineainit.c bios/screen.c bios/screen.h: Set PAL/50Hz or NTSC/60Hz
  correctly during boot. (RFB)
- bios/screen.c: Set full 256-colour Falcon default palette. (RFB)
- bios/screen.c bios/screen.h: Add boot support for TT shifter. (RFB)

2011-11-29
- bios/screen.c: Fix crash during boot due to unrecognised video mode. (RFB)

2011-11-30
- bios/screen.c bios/screen.h: Change sequence of initialisation of Videl
  registers. (RFB)

2011-12-03
- bios/screen.c: Correctly convert the NVRAM video mode to actual monitor. (VRI)

2011-12-04
- bios/screen.c bios/screen.h: Fixed the default boot video mode and added
  accurate traces. (VRI)
- bios/acsi.c bios/dma.c bios/dma.h bios/floppy.c: Moved common DMA stuff to
  the new dma.c. (VRI)
- bios/blkdev.c bios/floppy.c bios/floppy.h: Moved getiword() to blkdev.c. (VRI)
- bios/blkdev.c bios/floppy.c bios/floppy.h bios/machine.c bios/machine.h
  bios/vectors.S bios/xbios.c include/config.h: Added the CONF_WITH_FLOPPY
  define to allow disabling floppy support. (VRI)
- bios/screen.c: Improved conditional compilation. (VRI)

2011-12-05
- bios/screen.c: Change default ST video boot mode to ST Low when colour
  monitor is attached. (RFB)
- bios/screen.c: Add VGA/50Hz modes to table of valid Falcon video modes. (RFB)
- aes/basepage.h aes/gemaplib.c aes/geminit.c aes/gemlib.h aes/struct.h
  desk/deskapp.h desk/deskins.c include/compat.h: Remove I8086 #define
  and all code conditional upon it. (RFB)
- aes/gemaplib.c aes/geminit.c aes/gemoblib.c aes/struct.h desk/deskglob.c
  include/compat.h: Remove MC68K #define and ensure that code previously
  conditional on MC68K is now always compiled. (RFB)

2011-12-07
- bios/lineainit.c: Fix crash when booting in TT High resolution. (RFB)

2011-12-10
- bios/bios.c bios/kprint.c bios/kprint.h: Fix crash when kprintf() was
  called from user mode to write to RS232 or MIDI. (RFB)

2011-12-11
- bios/bios.c bios/clock.c bios/clock.h bios/machine.c bios/machine.h
  include/config.h: Added the CONF_WITH_MEGARTC define to allow disabling MegaST
  real-time clock support. (VRI)

2011-12-12
- bios/aciavecs.S bios/midi.c include/config.h: Added the CONF_WITH_MIDI_ACIA
  define to allow disabling MIDI ACIA support. (VRI)
- bios/chardev.c bios/mfp.c include/config.h: Added the CONF_WITH_MFP_RS232
  define to allow disabling MFP RS-232 support. (VRI)

2011-12-14
- bios/screen.c bios/screen.h bios/xbios.c: Added TT video syscalls. (RFB)
- bios/aciavecs.S bios/clock.c include/config.h: Added the CONF_WITH_IKBD_CLOCK
  define to allow disabling IKBD clock support. (VRI)

2011-12-15
- bios/acia.h bios/aciavecs.S bios/ikbd.c include/config.h: Added the
  CONF_WITH_IKBD_ACIA define to allow disabling IKBD ACIA support. (VRI)
- bios/aciavec.S include/config.h: Use midivec even when CONF_WITH_MIDI_ACIA
  is defined. (VRI)
- bios/ikbd.c: Improved debug traces. (VRI)
- bios/ikbd.h: Removed prototypes of nonexistent functions. (VRI)

2011-12-19
- bios/parport.c include/config.h: Added the CONF_WITH_PRINTER_PORT define to
  allow disabling Parallel Printer Port support. (VRI)
- bios/machine.c bios/sound.c bios/sound.h bios/vectors.S include/config.h:
  Added the CONF_WITH_YM2149 define to allow disabling YM2149 soundchip
  support. (VRI)

2011-12-21
- bdos/fsglob.c bios/blkdev.h include/config.h: Moved BLKDEVNUM define to
  config.h; changed number of drvtbl[] entries to BLKDEVNUM. (RFB)
- bdos/proc.c: Changed a hardcoded constant to NUMCURDIR. (RFB)
- include/pd.h: Fixed latent bug: NUMCURDIR now equals BLKDEVNUM. (RFB)
- aes/gemgsxif.c aes/gemgsxif.h: Changed variables that are only used
  locally from GLOBAL to static. (RFB)

2011-12-22
- aes/gemgsxif.c: Fixed memory overwrite in ST Low due to a too-small
  menu/alert backup buffer. (RFB)
- desk/deskapp.c: Use "View as icons" by default for a more Atari feeling. (VRI)

2011-12-23
- bios/blkdev.c bios/floppy.c bios/floppy.h bios/machine.c bios/machine.h
  bios/vectors.S bios/xbios.c doc/changelog.txt include/config.h: Replaced
  CONF_WITH_FLOPPY by a better CONF_WITH_FDC. (VRI)
- bios/bios.c bios/startup.S include/config.h: Added the CONF_WITH_CARTRIDGE
  define to allow disabling the ROM port cartridge support. (VRI)
- bios/blkdev.c bios/floppy.c: Removed floppy_init() as the job is already done
  in flop_hdv_init(). (VRI)
- bios/xhdi.c: Added a trace for the result of acsi_rw() and ide_rw(). (VRI)
- bios/acsi.c bios/acsi.h bios/xhdi.c: Harmonized CONF_WITH_ACSI and
  CONF_WITH_IDE. (VRI)
- bios/floppy.c: Added a timeout debug message in flopini(). (VRI)

2011-12-24
- bios/tosvars.h: Declare flock as volatile for safety. (VRI)
- bios/floppy.c: Do not set the FDC track register when cur_track is -1. (VRI)
- bios/floppy.c: Removed the global variable cur_track. (VRI)
- bios/floppy.c: Removed the flopunlk() dev parameter and the set_track() rate
  parameter. (VRI)
- bios/floppy.c: Clean up stepping rate usage. (VRI)
- bios/floppy.c: Better handling for invalid floppy devices. (VRI)

2011-12-25
- bios/floppy.c: Safer cur_track handling. (VRI)
- bios/bios.c bios/memory.S include/config.h: Added the CONF_WITH_FASTRAM define
  to allow detection and usage of FastRAM (TT-RAM). (VRI)
- bdos/iumem.c bdos/mem.h bdos/proc.c bdosm/umem.c: Renamed has_ttram to
  has_alt_ram and pmdtt to pmdalt. (VRI)
- bdos/bdosmain.c bdos/iumem.c bdos/mem.h bdos/proc.c bdos/umem.c bios/acsi.c
  bios/bios.c bios/floppy.c bios/machine.c bios/machine.h include/config.h:
  Added the CONF_WITH_ALT_RAM define to allow disabling support for alternate
  RAM. (VRI)

2011-12-26
- *.S: Replaced .global by .globl. (VRI)
- bios/memory.S: Set 0xffff8007 even when compiling for Falcon MMU only. (VRI)
- bios/memory.S include/config.h: Added the CONF_WITH_ST_MMU define to allow
  disabling ST MMU support. (VRI)
- bios/memory.S: Allow FastRAM detection even without Falcon MMU. (VRI)
- bios/memory.S include/config.h: Added the CONF_FASTRAM_SIZE define to allow
  disabling autodetection of the FastRAM size. (VRI)
- bios/memory.S: Factorize ST-RAM setup. (VRI)
- bios/memory.S include/config.h: Added the CONF_STRAM_SIZE define to allow
  disabling autodetection of the ST-RAM size. (VRI)

2011-12-27
- bios/bios.c bios/dma.c bios/dma.h bios/mfp.c bios/mfp.h bios/xbios.c
  include/config.h: Added the CONF_WITH_MFP define to allow disabling MFP
  support. (VRI)
- bios/xbios.c: Fixed DBG_XBIOS. (VRI)
- bios/xbios.c bios/xbios.h: Removed obsolete xbiosinit(). (VRI)
- bios/xbios.c bios/xbios.h: Make all XBIOS functions extern. (VRI)
- bios/bios.c bios/xbios.c: Make debug wrappers static. (VRI)
- bios/bios.h: Added prototypes for misc BIOS functions. (VRI)

2011-12-28
- bios/screen.c bios/screen.h bios/vectors.S include/config.h: Added the
  CONF_WITH_SHIFTER define to allow disabling Shifter support. (VRI)
- bios/vectors.S: Added the DBG_CHECK_READ_BYTE define to allow tracing
  check_read_byte() calls. (VRI)
- bios/biosmem.c bios/screen.c include/config.h: Added the CONF_VRAM_ADDRESS
  define to use a fixed video ram area out of the ST-RAM. (VRI)
- include/config.h: Moved target specific defaults to a separate section. (VRI)
- include/config.h: Added the CONF_WITH_DESK1 define to simplify the conditional
  definition of DESK1. (VRI)
- bios/cookie.h bios/machine.c include/config.h: Added the CONF_ATARI_HARDWARE
  define to allow disabling support for all Atari hardware. (VRI)

2011-12-29
- aes/gemgsxif.c aes/gemobjop.c bdos/bdosmain.c bdos/fsdir.c bdos/fsdrive.c
  bdos/fsio.c bdos/iumem.c bdos/kpgmld.c bdos/proc.c bdos/umem.c
  bios/kprint.h include/kprint.h: Moved kprint.h from bios/ to include/,
  its logical place. (RFB)
- aes/geminit.c aes/gemstart.S: Call C routine to init stack pointer, rather
  than relying on 'magic number'. (RFB)
- include/compat.h: Removed obsolete, unused, defines. (RFB)

2012-01-01
- bios/floppy.c: Increased the FDC timeout to 3 seconds. (VRI)
- include/config.h: Set CONF_WITH_FASTRAM=0 when !CONF_ATARI_HARDWARE. (VRI)
- bios/panicasm.S: Minor optimization of halt(). (VRI)
- bios/config.h: Added a sanity check for USE_STOP_INSN_TO_FREE_HOST_CPU. (VRI)
- bdos/fsopnclo.c: Allow '+' character in filenames. (RFB)
- bdos/fs.h bdos/fsdir.c bdos/fsopnclo.c: Disallow invalid filename characters
  when renaming a file or folder. (RFB)

2012-01-03
- aes/gemdisp.c bios/ikbd.c bios/initinfo.c bios/screen.c include/asm.h
  util/miscasm.S: New stop_until_interrupt() wrapper around STOP. (VRI)
- include/config.h: Allow CONF_WITH_XHDI with !CONF_ATARI_HARDWARE. (VRI)

2012-01-04
- bios/screen.c: Fixed Vsync() when !CONF_WITH_SHIFTER. (VRI)
- bios/vectors.S: Fixed int_hbl() on ColdFire. (VRI)
- aes/gemodosif.h aes/gemdosif.S bios/geminit.c: Removed hcli() and hsti(). They
  forced IPL0 instead of restoring the old IPL. (VRI)
- bdos/proc.c: Inherit IPL in child process. (VRI)
- bios/bios.c bios/vectors.h vios/vectors.S: Disable IPL hacking on non-Atari
  hardware. (VRI)
- bios/bios.c: Tidy interrupt vectors initialization. (VRI)

2012-01-06
- aes/gemlib.h: Replaced magic number for path length with #define. (RFB)
- aes/gemgsxif.c: Optimize calculation of menu/alert buffer size. (RFB)
- doc/todo.txt: Show that duplicate header names have been fixed. (RFB)
- aes/gemlib.h bdos/fsdir.c desk/deskdir.c desk/deskfun.c desk/deskinf.c
  desk/deskins.c: Replaced magic number for filename length with #define. (RFB)

2012-01-07
- aes/geminit.c: Removed unused code in 'load accessories' routines. (RFB)

2012-01-09
- bios/vectors.h: Define the exception vectors as volatile for safety. (VRI)
- bios/bios.c bios/vectors.h: Clean up exception vector names. (VRI)

2012-01-12
- bios/screen.c: Workaround to get some working video mode on the FireBee. (VRI)

2012-01-17
- bios/screen.c bios/vectors.S: Fix VsetRGB() to update the STe palette
  where appropriate, and to use the VBL handler to update palettes. (RFB)

2012-01-18
- aes/crysbind.h aes/gemaplib.c aes/gemctrl.c aes/gemdisp.c aes/gemevlib.c
  aes/gemfslib.c aes/geminit.c aes/gemlib.h aes/gemmnlib.c aes/gemshlib.c
  aes/gemsuper.c aes/gemwmlib.c aes/optimize.c desk/deskapp.c desk/deskapp.h
  desk/deskdir.c desk/deskins.c desk/deskmain.c desk/deskpro.c desk/desksupp.c
  desk/gembind.h include/compat.h: Removed MULTIAPP #define and code dependent
  on it. (RFB)
- desk/deskbind.h include/compat.h: Finished removal of MULTIAPP. (RFB)

2012-01-19
- include/compat.h aes/gemmnlib.c: Increased allowed number of desk
  accessories from 3 to 6. (RFB)
- aes/gemsuper.c aes/gemsuper.h: Removed gl_mnpds[] (never initialised) and
  fixed associated code. (RFB)
- aes/gemmnlib.c aes/gemmnlib.h: Fixed potential memory overwrite when title
  for menu_register() exceeds 21 bytes. (RFB)
- aes/gemctrl.c aes/gemmnlib.c aes/gemmnlib.h: Fixed implementation of
  menu_unregister() to avoid it changing existing menu ids. (RFB)

2012-01-20
- aes/crysbind.h aes/gemaplib.c aes/gemctrl.c aes/gemevlib.c aes/gemfslib.c
  aes/geminit.c aes/gemmnlib.c aes/gemshlib.c aes/gemsuper.c aes/gemwmlib.c
  desk/gembind.h include/compat.h: Removed SINGLAPP #define and made code
  dependent on it always compile. (RFB)

2012-01-26
- aes/deskmain.c aes/desk_rsc.c aes/desk_rsc.h aes/gembind.c: Reorganised
  desktop resource files in preparation for upcoming changes. (RFB)

2012-01-31
- bios/xhdi.c: Added XHNewCookie() support. Contributed by David Gálvez. (VRI)
- bios/xhdi.c: Fixed chaining XHNewCookie(). (VRI)
- desk/deskmain.c: Fixed 'make 192', broken by previous changes to
  deskmain.c. (RFB)

2012-02-03
- bios/floppy.c: Fixed floprw() to be able to read multiple sectors.
  Thanks to James Boulton for the patch! (THH)
- bios/kprint.c: Added SuperToUser() macro, required for compilation with
  RS232 or MIDI debug print enabled. (RFB)

2012-02-05
- desk/deskmain.c desk/desk_rsc.h: Renamed & moved two resource-related
  #defines into resource header. (RFB)
- desk/deskbind.h: Get number of trees in resource from resource header. (RFB)
- desk/aesbind.h desk/deskmain.c desk/gembind.c: Replace menu_text() with
  macro to avoid problems when original object string is in ROM. (RFB)
- desk/deskmain.c: Fixed latent bug when menu isn't first tree in
  resource. (RFB)

2012-02-08
- bios/xhdi.c: Better XHNewCookie() support. Contributed by David Gálvez. (VRI)
- bios/xhdi.c: Fixed when not CONF_WITH_XHDI. (VRI)

2012-02-09
- desk/desktop.dfn desk/desktop.rsc: Updated raw resource files to correspond
  to the current C code in desk_rsc.c/desk_rsc.h. (RFB)
- doc/resource.txt tools/erd.c: Added documentation & source for resource
  decompilation tool. (RFB)

2012-02-10
- doc/resource.txt tools/erd.c: Changed tabs to spaces, crlf to lf. (RFB)
- desk/desk_rsc.c po/cs.po po/de.po po/es.po po/fi.po po/fr.po po/gr.po
  po/it.po po/ru.po: Removed trailing spaces from 'Desktop info...' string
  for compatibility with erd. (RFB)
- tools/erd.c: Fixed ctype warnings on Cygwin. (VRI)
- .cvsignore Makefile: Build the erd tool using "make erd". (VRI)
- desk/deskbind.h desk/deskmain.c: Code cleanup: removed unused FCB
  structures from GLOBES. (RFB)

2012-02-11
- desk/*: Removed all unnecessary #includes from all files within the desk
  directory. (RFB)
- desk/deskapp.c desk/deskfpd.c desk/deskmain.c desk/desksupp.c
  desk/deskwin.c: Restored some #includes required for 'make 192'. (RFB)
- desk/deskact.c desk/deskbind.h desk/deskconf.h: Code cleanup: centralised
  #define for MAX_OBS. (RFB)
- desk/deskbind.h desk/deskconf.h: Code cleanup: centralised #define for
  MAX_LEVEL. (RFB)
- desk/infodef.h: Code cleanup: removed unused #defines. (RFB)

2012-02-12
- doc/status.txt: Updated to reflect implementation of TT & Falcon xbios
  video calls. (RFB)
- desk/deskact.c desk/deskconf.h desk/deskwin.c: Code cleanup: centralised
  #define for LEN_FNODE. (RFB)

2012-02-14
- Makefile: Do not build makefile.dep when building the tools. (VRI)
- Makefile: Replaced the obsolete -W option by the new -Wextra. (VRI)
- Makefile: Removed desk/desk_rsc.[ch] and enabled the ERD tool. (VRI)
- tools/erd.c: Made *_rs_trees and *_rs_fstr const to move them to the TEXT
  segment. (VRI)

2012-02-16
- bios/screen.c bios/screen.h: Created new function to be called by
  screen resolution change processing. (RFB)
- Makefile aes/geminit.c desk/deskmain.c desk/deskrez.c desk/deskrez.h
  desk/desktop.dfn desk/desktop.rsc: Allow desktop resolution switching
  for TT. (RFB)

2012-02-19
- bios/machine.c: In the _SND cookie, remove SND_16BIT and SND_MATRIX until
  the Falcon XBIOS sound functions are implemented. (VRI)

2012-02-20
- bios/screen.c bios/screen.h: Improve calculation of Falcon VRAM size in
  preparation for Falcon resolution switching. (RFB)

2012-02-21
- po/fr.po: Fixed leading capital letter in menus sort items. (VRI)
- bios/initinfo.c: Allow the user to bypass the welcome screen by quickly
  tapping the Shift key. (VRI)

2012-02-23
- bios/screen.c bios/screen.h: Made code that fixes up Falcon video modes
  into a function. (RFB)
- bios/screen.h: Restore correct mode code for Falcon ST High. (RFB)

2012-02-24
- bios/screen.c: Falcon fix: STe palette was not always updated when it
  should have been. (RFB)

2012-02-29
- bios/screen.c: Fixed bugs in set_videl_vga() including using the wrong
  palette. (RFB)
- aes/geminit.c desk/deskmain.c desk/deskrez.c desk/desktop.dfn
  desk/desktop.rsc include/xbiosbind.h: Allow desktop resolution switching
  for Falcon. (RFB)
- doc/reschange.txt: Added documentation on resolution change. (RFB)
- aes/gemobed.c: Fixed form_center() to accurately centre the form, as
  per Atari TOS. (RFB)

2012-03-01
- bios/machine.c bios/machine.h bios/xbios.c include/config.h: Add minimal
  support for Blitmode(). (RFB)
- bios/screen.c: Removed specific kludges for the FireBee's VIDEL since
  the standard VsetMode() routines work fine now. (VRI)
- tools/erd.c: Added comments to generated .c file to identify trees,
  objects, and free strings by name. (RFB)
- tools/erd.c: Added strings to 'no-translate' table. (RFB)

2012-03-04
- aes/gemfmalt.c: Added validity checks to form_alert() to prevent crash
  due to badly-formed alert string. (RFB)
- bios/bios.c bios/xbios.c: Return function number rather than zero for
  unimplemented (x)bios calls, as per Atari TOS. (RFB)

2012-03-07
- bios/screen.c: Improved calculation of value for videl register $82c0. (RFB)
- bios/screen.c: Replace table lookup of scanline width & vctl with
  direct calculation. (RFB)

2012-03-08
- bios/screen.c: Modified videomode lookup table to support multiple
  entries for the same mode on different monitor types. (RFB)
- desk/deskdir.c desk/deskfpd.c desk/deskfpd.h desk/deskfun.c
  desk/deskinf.c: Ensure F_FAKE/F_DESKTOP #defines are only used if DESK1
  is not #defined. (RFB)

2012-03-15
- vdi/vdi_fill.c: Fixed crash in GemAmigo due to stack overflow. Contributed
  by David Savinkoff. (RFB)

2012-03-17
- aes/asmstruct.h aes/gemasm.S: Move #defines to separate header file for
  inclusion by other .S files. (RFB)
- aes/gemdosif.S aes/gemstart.S: Replaced hard-coded offsets with #defines. (RFB)
- aes/struct.h: Fix UDA definition to include field used by trapaes. (RFB)

2012-03-20
- desk/deskapp.c desk/deskapp.h desk/deskmain.c desk/desktop.dfn
  desk/desktop.rsc: Removed unused STNOFILE alert from desktop resource. (RFB)

2012-03-22
- vdi/vdi_fill.c: Code cleanup: moved declaration to start of block.
  Contributed by David Savinkoff. (RFB)
- bios/startup.S: Reduced startup stack size to 1024 words. (RFB)
- vdi/vdi_fill.c: Improved polygon fill by rounding calculation of edge
  intersections. Contributed by David Savinkoff. (RFB)

2012-03-24
- vdi/vdi_line.c: Reorganised code to simplify future changes. (RFB)

2012-03-25
- bios/ikbd.c bios/tosvars.S: Moved _shifty to first 32K of memory to
  circumvent GFA crash. (RFB)

2012-03-26
- doc/bugs.txt vdi/vdi_line.c: Fixed line drawing in transparent mode. (RFB)
- vdi/vdi_text.c: Improved text scaling by vst_height(). Contributed by
  David Savinkoff. (RFB)
- vdi/vdi_text.c: Code cleanup: simplified code. Contributed by David
  Savinkoff. (RFB)

2012-03-29
- vdi/vdi_line.c: Code cleanup: all drawing modes for draw_rect() now
  use the same code structure. (RFB)

2012-03-30
- vdi/vdi_line.c: Code cleanup: simplified draw_rect(). (RFB)

2012-04-05
- vdi/vdi_line.c: Rewrote draw_rect() again to restore performance. (RFB)
- vdi/vdi_bezier.c vdi/vdi_defs.h vdi/vdi_fill.c vdi/vdi_gdp.c
  vdi/vdi_line.c vdi/vdi_text.c: Fixed GDP functions to draw text
  underlines & perimeters in the correct colour. (RFB)

2012-04-09
- vdi/vdi_text.c: Restored earlier vst_height() code that searches all
  font chains, not just the first. (RFB)
- vdi/vdi_defs.h vdi/vdi_text.c: Code cleanup: changed values used in text
  scaling from WORD to UWORD, as per actual usage. (RFB)
- vdi/vdi_text.c: Fixed text scaling in vst_height().  Based on contribution
  by David Savinkoff. (RFB)

2012-04-10
- bios/xhdi.c: XHDI functions that are unsupported by EmuTOS are passed to the
  next handler (if any). Contributed by David Gálvez. (VRI)
- bios/xhdi.c: Correct typo in struct's name. Contributed by David Gálvez. (VRI)

2012-04-11
- include/config.h vdi/vdi_text.c: Added CONF_WITH_GDOS to allow disabling
  GDOS support code. (RFB)
- release.mk doc/xhdi.txt: Added documentation about the current XHDI status.
  Contributed by David Gálvez. (VRI)
- release.mk: Added missing unix2dos for 192k targets. (VRI)
- desk/deskrez.c desk/desktop.dfn desk/desktop.rsc: Display correct sizes in
  Falcon resolution change dialog for non-VGA monitors. (RFB)

2012-04-12
- bdos/fsdrive.c: Fix possible memory leak in log_media().  (RFB)
- bdos/fsio.c: Code cleanup in xrw(): eliminate two GOTOs & add explanatory
  comments. (RFB)

2012-04-13
- include/config.h: For TARGET_192, disable CONF_WITH_MEGARTC by default. (RFB)

2012-04-14
- doc/bugs.txt: Removed games that now run from list of problems. Contributed
  by Eero Tamminen. (RFB)
- desk/deskfun.c: Issue more informative alert if trying to create a folder
  with a too-long name. (RFB)

2012-04-16
- desk/desktop.rsc: Changed alerts to conform to standard TOS limit of 30
  characters per line. (RFB)
- aes/geminit.c aes/geminit.h aes/gemshlib.c: Code cleanup: eliminated some
  unnecessary globals. (RFB)
- aes/gemshlib.c aes/gemshlib.h: Code cleanup: make sh_apdir[] local, and
  use #define for its length. (RFB)
- aes/geminit.c aes/gemwmlib.c aes/gemwmlib.h: Code cleanup: eliminate
  ad_windspb. (RFB)
- aes/geminit.c aes/gemoblib.c aes/gemoblib.h: Code cleanup: eliminate
  ad_edblk, ad_bi, ad_ib. (RFB)
- aes/geminit.c aes/gemshlib.c: Code cleanup: really make some variables
  local. (RFB)
- aes/gemctrl.c aes/gemgsxif.c aes/geminit.c aes/geminit.h: Code cleanup:
  eliminate ad_mouse. (RFB)
- aes/gemshlib.c desk/deskapp.c desk/deskapp.h desk/deskins.c desk/desksupp.c:
  Removed AF_ISFMEM, since it has no meaning when the AES is ROMmed. (RFB)
- desk/deskins.c desk/desktop.dfn desk/desktop.rsc: Removed 'use full memory'
  objects from 'Configure application' dialog. (RFB)
- desk/deskapp.c: Code cleanup: use sprintf() instead of local routines. (RFB)

2012-04-18
- po/de.po: Updated german translations. (THH)
- aes/gemfmalt.c: Changed form_alert so that dialog boxes with only one line
  of text and without icon should be formatted fine, too. (THH)
- bios/screen.c bios/screen.h bios/xbios.c: Added VsetSync(). (RFB)
- bios/screen.c bios/screen.h desk/deskapp.c: Save current rez / video mode
  to EMUDESK.INF. (RFB)

2012-04-19
- desk/deskapp.c: Fix compilation errors caused by previous update. (RFB)

2012-04-20
- aes/geminit.c: Code cleanup: fix comments, remove unused #define. (RFB)
- aes/geminit.c: Code cleanup: eliminate compatibility macros. (RFB)

2012-04-21
- aes/crysbind.h aes/gemsuper.c desk/gembind.c desk/gembind.h: Remove
  appl_bvset() [never used & not Atari TOS]. (RFB)
- aes/gemfslib.c aes/gemfslib.h: Code cleanup: made some globals local. (RFB)
- aes/gemfslib.c: Fix file selector to display complete drive list. (RFB)
- aes/gemfslib.c aes/geminit.c aes/gemsuper.c aes/gemsuper.h: Eliminate
  gl_bvdisk & gl_bvhard globals. (RFB)
- desk/desktop.rsc: Re-enabled Easter Egg (accidentally disabled when
  resource was recreated). (RFB)
- aes/geminit.c aes/deskapp.c: Move initialisation of gl_mnclick to
  app_start(), where it belongs. (RFB)
- aes/geminit.c: Code cleanup: remove no-longer-used code. (RFB)
- aes/geminit.c aes/geminit.h: Code cleanup: make sh_rdinf() local. (RFB)

2012-04-23
- aes/geminit.c: Fix bug: sh_addpath() did not create PATH environment
  variable correctly if it was missing. (RFB)
- aes/gemstart.S: Fix bug: restore original environment ptr on AES
  restart. (RFB)
- aes/geminit.c: Give sh_rdinf() its own buffer to avoid overwriting the
  AES shell buffer during restart. (RFB)

2012-04-24
- aes/geminit.c: Create separate buffer for desktop environment (avoid
  sharing AES shell buffer). (RFB)

2012-04-25
- aes/gemgsxif.c aes/gemgsxif.h aes/geminit.c bios/screen.c bios/screen.h
  desk/deskapp.c doc/reschange.txt: Allow desktop resolution/mode to be
  saved in / restored from EMUDESK.INF. (RFB)
- desk/deskapp.c: Fix crash on ST/TT due to accessing I/O memory in user
  mode. (RFB)
- aes/gemgsxif.c aes/gemshlib.c include/compat.h: Code cleanup: removed
  GEMDOS #define and made code dependent on it always compile. (RFB)
- desk/deskapp.c desk/deskapp.h desk/deskins.c include/compat.h: Code
  cleanup: removed ALCYON #define and made code dependent on it always
  compile. (RFB)
- aes/gemobjop.c: Code cleanup: eliminated LBYTE2 & LBYTE3 compatibility
  macros. (RFB)
- include/compat.h: Code cleanup: removed unused compatibility macros
  and externs. (RFB)

2012-04-30
- doc/resource.txt tools/erd.c: Reworked ERD to save more space when
  compiling the 192K ROMS. (RFB)
- desk/deskapp.c: Fix bad desktop display after resolution change in
  192k ROMs (bug introduced by changes of 2012-04-16). (RFB)
- desk/deskinf.c: Added some warning comments re SFCB. (RFB)
- desk/deskapp.c: Eliminated duplicate desktop data that already exists
  in the built-in resource. (RFB)

2012-05-01
- vdi/vdi_defs.h vdi/vdi_gdp.c vdi/vdi_line.c: Fix bug: arrows are now
  drawn correctly for thin line arcs/ellarcs. (RFB)
- vdi/vdi_defs.h vdi/vdi_gdp.c vdi/vdi_line.c: Replace common code to
  set LN_MASK with subroutine. (RFB)
- vdi/vdi_gdp.c: Fix bug: line styles are now used for thin line arcs
  and ellarcs. (RFB)

2012-05-02
- vdi/vdi_line.c: Fix bug: arrows are now drawn correctly for all arcs
  and ellarcs. (RFB)

2012-05-03
- vdi/vdi_col.c vdi/vdi_fill.c: Fix bug: v_get_pixel() did not return the
  VDI colour index correctly in all cases. (RFB)

2012-05-08
- bios/country.c: Fix wrong keyboard layout read from the NVRAM. (VRI)
- country.mk bios/country.h bios/keyb_uk.h: New UK country and keyboard layout.
  Contributed by David Savinkoff. (VRI)
- bios/screen.c: Fix bug: can't change to ST resolutions after booting
  with videl in VGA 50Hz mode. (RFB)

2012-05-09
- country.mk: Fix UK date format. Contributed by David Savinkoff. (VRI)
- Makefile: Remove useless #ifdef in include/i18nconf.h. (VRI)
- country.mk tools/mkheader.awk: Move COUNTRY existence test. (VRI)
- country.mk Makefile: Move country configuration sanity checks. (VRI)
- Makefile: Add correct echo quoting. (VRI)
- country.mk Makefile bios/country.c: Use the country-specific IDT settings in
  UNIQUE builds. (VRI)
- Makefile include/nls.h tools/bug.c util/nls.c util/nlsasm.S: Replaced
  CONF_NO_NLS by !CONF_WITH_NLS. (VRI)
- bios/bios.c include/nls.h util/nls.c: Removed all NLS functions when
  !CONF_WITH_NLS. (VRI)
- bios/country.c bios/country.h bios/machine.c: Rework the AKP/IDT detection
  algorithm. (VRI)

2012-05-10
- bios/country.h desk/deskapp.c desk/deskinf.c: Use the IDT date ordering in
  the default desktop. (VRI)
- desk/deskapp.c: Use the IDT time format in the default desktop. (VRI)

2012-05-13
- bios/screen.c: Fix bug: Falcon ST compatibility colour modes were wrong
  height on VGA monitor. (RFB)

2012-05-18
- bios/comprimg.S bios/screen.c bios/startup.S bios/tosvars.h
  tools/mkheader.awk: Renamed os_pal to os_conf. (VRI)
- bios/country.c: [3527804] Use the os_conf variable from the OS header as
  default language. This allows again the usage of tos-lang-change. (VRI)
- bios/comprimg.S bios/startup.S tools/mkheader.awk: Remove the OS_CONF define.
  Use the os_conf variable instead. (VRI)
- aes/geminit.c bios/screen.c desk/deskapp.c desk/deskmain.c desk/deskrez.c:
  Fixed compilation for non-Atari hardware. (VRI)
- include/intmath.h util/intmath.c: Implement mul_div() using muls/divs. (VRI)

2012-05-19
- po/fr.po: Update. (VRI)

2012-05-20
- po/fi.po: Update. Contributed by Eero Tamminen. (VRI)
- po/es.po: Update. Contributed by David Gálvez. (VRI)

2012-05-21
- bios/screen.c: Fixed check_moderez() when CONF_WITH_VIDEL was not
  defined. (RFB)

2012-05-22
- po/it.po: Update. Contributed by Lodovico Zanier. (VRI)

2012-05-23
- po/ru.po: Update. Contributed by Dima Sobolev. (VRI)
- bios/bios.c bios/bios.h bios/chardev.c bios/chardev.h bios/ikbd.c
  bios/ikbd.h bios/midi.c bios/midi.h bios/parport.c bios/parport.h:
  Fix Bconout() to return long rather than void. (RFB)
- bdos/bdosmain.c: Fix Fwrite() for AUX: or PRN:. (RFB)

2012-05-28
- doc/readme-cartridge.txt release.mk: New emutos-cartridge binary archive
  built by make release. (VRI)

2012-05-29
- bios/country.c: Use the default country from the ROM header if the NVRAM
  language is not supported. (VRI)
- util/nls.c: Remove the unused the_lang and num_of_langs variables. (VRI)
- tools/bug.c: Remove the translations administrative entries from the final
  binaries. (VRI)

2012-05-31
- tools/tos-lang-change.c: Change the PAL/NTSC bit according to the new country.
  Contributed by Eero Tamminen. (VRI)
- bios/bios.c bios/screen.c bios/screen.h desk/deskmain.c: Restore support
  for Hatari extended VDI resolutions. (RFB)

2012-06-03
- po/gr.po: Update. Contributed by Christos Tziotzis. (VRI)
- Makefile tools/mkrom.c: New mkrom tool to build custom ROM images. (VRI)
- .cvsignore Makefile release.mk doc/readme-cartridge.txt tools/mkrom.c: Added
  support to build Steem Engine cartridge image. (VRI)
- bios/screen.c bios/screen.h: Fixed compilation for non-Atari hardware. (VRI)

2012-06-05
- aes/gemdosif.S bios/vectors.S util/miscasm.S: Remove useless globals. (VRI)
- bios/kprint.c: Remove ugly MIT assembled syntax. (VRI)
- include/portab.h bios/kprint.c: Remove dependencies to the MiNTLib. (VRI)
- doc/*: Update the documentation. (VRI)

2012-06-15
- tools/bug.c: report which file is missing (PES)
- po/cs.po: updated Czech translation (PES)

2012-06-17
- tools/bug.c: Fixed memory allocation problem. (THH)
- desk/desktop.rsc: Fixed button widths in change resolution dialog. (RFB)

2012-06-18
- include/compat.h include/portab.h: Fix strict-aliasing warnings with GCC 4.7.1
  and potential issues. (VRI)
- *: Converted text files to UTF-8. Suggested by David Savinkoff. (VRI)
- Makefile: Added "make charset" to check the sources charset. (VRI)

2012-06-19
- desk/deskmain.c: Fixed about box version in translated UNIQUE builds. (VRI)
- util/bootsect.S: Fixed emutos.st to avoid trashing the startup screen when
  running on 512 MB machines. (VRI)
- doc/announce.txt: Updated the release date. (VRI)

* Release: 0.8.7

2012-06-20
- desk/deskmain.c desk/desktop.dfn: Added labels to About box tree to
  avoid hardcoded object numbers. (RFB)

2012-06-22
- bios/screen.c: Split vmode table for clarity & future refactoring. (RFB)
- bios/screen.c: Save space & time by eliminating entries with duplicate
  data in vga vmode table. (RFB)
- bios/screen.c bios/screen.h: Use default videl boot resolution if VDI
  does not support NVRAM value. (RFB)
- bios/vectors.S: Clean up for __mcoldfire__ and CONF_ATARI_HARDWARE. (VRI)
- bios/ide.c: Reorganization for future changes. (VRI)
- bios/screen.c: Update comments to reflect recent changes. (RFB)
- bdos/bdosmain.c: Remove function wrappers (no longer needed). (RFB)
- bdos/time.c: Avoid theoretical race condition in time_init(). (RFB)
- aes/gemfmalt.c: Use #defines to convert icon number to icon image for
  form_alert(). (RFB)
- aes/gemfmalt.c: Use gem_rsc.h #defines instead of local #defines. (RFB)

2012-06-23
- aes/gemsuper.c: Use #defines to convert from mouse number to mouse
  image for graf_mouse(). (RFB)
- bios/tosvars.h bios/tosvars.S: Mark vblsem as volatile for safety. (VRI)
- bios/bios.c bios/screen.c: Cleaned up bios_init() initialization order. (VRI)
- bios/bios.c: Initialized the BIOS console early to see debug messages. (VRI)
- Makefile release.mk bios/aciavecs.S bios/amiga.c bios/amiga.h bios/amiga2.S
  bios/bios.c bios/ide.c bios/machine.c bios/memory.S bios/screen.c
  bios/startup.S doc/readme-amiga.txt include/config.h tools/mkrom.c: Added
  support for Amiga hardware. (VRI)
- aes/gemfmalt.c: Issue debug msg if lines or buttons in form_alert()
  exceed standard TOS lengths. (RFB)

2012-06-24
- bios/screen.c bios/screen.h vdi/vdi_control.c: Fix bug: vq_extnd(mode 1)
  always returned 0 for LUT support. (RFB)
- aes/geminit.c: Use gem_rsc.h #defines instead of local #defines. (RFB)

2012-06-25
- bios/floppy.c bios/nvram.c: Added debug traces. (VRI)
- vdi/vdi_control.c: Fixed compilation for non-Atari hardware. (VRI)
- bios/ide.c: Changed struct IDE conditional compilation. (VRI)

2012-06-26
- Makefile aes/geminit.c bios/screen.c bios/screen.h bios/videl.c bios/videl.h
  desk/deskmain.c desk/deskrez.c: Rough split of screen.c into videl.c. (VRI)
- tools/erd.c: Fix bug when tree specified by 'tree_start' is not found. (RFB)

2012-06-27
- bios/screen.c: Quick compilation fix for make 192. (VRI)
- aes/gem_rsc.c: Reorganised to correspond to desk_rsc.c layout. (RFB)

2012-06-28
- tools/erd.c: Fix bug in comments in generated .c file. (RFB)
- aes/gem_rsc.c aes/gem_rsc.h: More reorganisation for standard layout. (RFB)

2012-06-29
- aes/gemfmalt.c aes/gem_rsc.c aes/gem_rsc.h: Replace hardcoded numbers
  with #defines for alert msg/button sizes. (RFB)
- aes/gem_rsc.c: Set up ptrs to alert msg/button buffers dynamically. (RFB)
- aes/geminit.c: Code cleanup: use #define for tree number of desktop. (RFB)
- aes/gem_rsc.c: Standardise contents of last object. (RFB)
- aes/geminit.c aes/gem_rsc.c aes/gem_rsc.h aes/gemfmalt.c aes/gemsuper.c:
  Renamed GEM resource bitblks for future ERD compatibility. (RFB)
- bios/screen.h bios/videl.c bios/videl.h bios/xbios.c: Fixed the return value
  of VIDEL XBIOS functions when there is no VIDEL. (VRI)
- bios/lineainit.c bios/screen.h bios/videl.h desk/deskapp.c: Moved VIDEL
  functions declarations to videl.h.
- bios/screen.c vdi/vdi_control.c: Cleaned up get_monitor_type(). (VRI)

2012-06-30
- desk/desktop.rsc tools/erd.c: Fix handling of backslash in strings. (RFB)
- aes/gemfmalt.c aes/geminit.c aes/gem_rsc.c aes/gem_rsc.h: Renamed trees
  array for (future) ERD compatibility. (RFB)
- tools/erd.c: New version of ERD that also handles the GEM resource. (RFB)
- tools/erd.c: Handle free strings/alerts more than 200 bytes long. (RFB)
- aes/gem.def aes/gem.rsc: Add recreated GEM resource files. (RFB)
- aes/gem_rsc.c aes/gem_rsc.h: Removed (now generated by erd). (RFB)
- .cvsignore Makefile: Added support for building aes/gem_rsc.*. (RFB)
- doc/resource.txt: Updated to include info about GRD. (RFB)

2012-07-02
- aes/.cvsignore: Added missing gem_rsc.c gem_rsc.h. (VRI)
- bios/screen.c: Refactored rez_changeable(). (VRI)
- bios/screen.c: Refactored get_monitor_type(). (VRI)
- bios/screen.c: Refactored initial_vram_size(). (VRI)

2012-07-03
- bios/screen.c bios/videl.c bios/videl.h: Refactored check_moderez(). (VRI)
- bios/lineainit.c bios/screen.c bios/screen.h bios/videl.c bios/videl.h:
  Added screen_get_current_mode_info(). (VRI)
- bios/screen.c: Refactored vram_size(). (VRI)
- aes/gemaplib.c aes/gemfmalt.c aes/geminit.c aes/gemrslib.c aes/gemsuper.c:
  Remove obsolete code only generated when USE_GEM_RSC is #defined. (RFB)
- aes/geminit.c: Code cleanup: remove previously-disabled code. (RFB)

2012-07-04
- aes/gem.def aes/gem.rsc: Removed unused free strings from resource. (RFB)

2012-07-05
- aes/gem.def aes/gem.rsc: Changed alerts to conform to standard TOS
  alert line length. (RFB)
- aes/crysbind.h aes/gemsuper.c desk/gembind.h: Removed non-Atari AES
  functions XGRF_xxx. (RFB)
- aes/gem.rsc aes/gemsuper.c: Display function number for unsupported
  AES calls. (RFB)
- doc/bugs.txt doc/status.txt doc/todo.txt: Miscellaneous documentation
  updates. (RFB)
- bios/startup.S: Added Amiga ROM size marker. (VRI)
- aes/gemfmlib.c aes/geminit.c aes/gemlib.h aes/gemrslib.c: Made two
  strings local rather than global. (RFB)
- vdi/vdi_text.c: Code cleanup: save space & simplify. (RFB)
- doc/status.txt: Updated status of VDI calls and AES calls. (RFB)

2012-07-06
- aes/crysbind.h aes/gemsuper.c: Differentiate between TOS and PC-GEM AES
  functions with the same opcode. (RFB)

2012-07-07
- aes/gemsuper.c: Fixed crysbind() warning about control signedness. (VRI)
- tools/mkrom.c: Added Amiga ROM checksum fixup. (VRI)
- bios/processor.S: Changed 68060 detection for buggy WinUAE. (VRI)
- .cvsignore, Makefile, doc/readme-amiga.txt: Renamed the Amiga ROM to
  emutos-amiga.rom. (VRI)
- .cvsignore Makefile release.mk doc/readme-amiga.txt tools/mkrom.c: Added
  support for EmuTOS as an Amiga 1000 Kickstart disk. (VRI)
- bios/ide.c: Quick hack to avoid infinite loop on Amiga 1000 hardware. (VRI)

2012-07-08
- aes/gemmnlib.c aes/gemsclib.c aes/gemshlib.c aes/gemsuper.c
  include/config.h: Added CONF_WITH_PCGEM to enable PC-GEM-only AES
  calls. (RFB)
- Makefile desk/desktop.def desk/desktop.dfn: Replaced .dfn file with
  equivalent .def file. (RFB)
- bios/startup.S: Fixed entry point address for BlizKick compatibility. (VRI)

2012-07-09
- tools/erd.c: Fix EmuTOS compile error when TARGET_192 and DESK1 are
  defined at the same time. (RFB)
- bios/amiga.c bios/amiga.h bios/clock.c: Added support for Amiga real-time
  clocks. (VRI)

2012-07-10
- desk/deskapp.c: Removed unnecessary parsing of lines from desktop
  resource while processing emudesk.inf. (RFB)
- desk/deskapp.c: Validate icon number when reading EMUDESK.INF. (RFB)
- bios/amiga.c bios/amiga.h bios/bios.c bios/kprint.c include/config.h:
  Added kprintf() support for UAE. (VRI)
- bios/amiga.c bios/amiga.h bios/bios.c: Added shutdown support for UAE. (VRI)

2012-07-16
- bios/amiga.c: Added support for Zorro II / Zorro III Fast RAM. (VRI)

2012-07-17
- bios/amiga.c bios/amiga.h bios/amiga2.S: Added support for A3000/A4000
  motherboard RAM. (VRI)
- bios/amiga.c: Added check for 32-bit address bus. (VRI)
- bios/initinfo.c bios/machine.c bios/machine.h: Removed duplicate declaration
  of mcpu and fputype. (VRI)
- bios/amiga.c bios/amiga.h bios/amiga2.S bios/machine.c: Added support for
  Slow RAM. (VRI)
- bios/amiga.c: Fixed crash when there is no expansion board. (VRI)
- bios/ide.c: Cleaned up Amiga IDE autodetection. (VRI)
- bios/amiga.c: Fixed crash on shutdown when uaelib is not available. (VRI)

2012-07-18
- bdos/umem.c: Shrink alternate RAM blocks to multiples of 4 bytes. (VRI)
- bdos/umem.c: Fixed overlap test beween alt RAM blocks and ST-RAM. (VRI)
- bdos/umem.c: Merge contiguous alt RAM blocks. (VRI)

2012-07-19
- bios/amiga.c: Added keyboard acknowledges required for real Amiga hardware
  and WinUAE 2.4.0 or higher. (VRI)

2012-07-22
- bios/amiga.c bios/amiga.h bios/amiga2.S bios/screen.c: Added setphys() and
 Getphys() support for Amiga(). (VRI)

2012-07-23
- include/config.h bios/processor.S: Added CONF_WITH_SFP004 (Mega ST 68881 FPU
  board) to avoid testing 0xfffffa40 on non-Atari hardware. (VRI)

2012-07-30
- .cvsignore Makefile release.mk tools/map2sym.sh doc/readme-512k.txt: Make
  512 now generates debug symbols for Hatari in etos512.sym. Contributed by Eero
  Tamminen. (VRI)

2012-08-01
- bios/ikbd.c: Slightly optimized ikbdws() to work around a stack problem in
  the Falcon demo "Blue" by "New Beat". (THH)
- bios/xbios.c: Fixed compilation with DBG_XBIOS. (VRI)
- desk/deskapp.c desk/deskbind.h: Changed three globals into locals. (RFB)

2012-08-03
- bios/floppy.c bios/machine.c: Added _FRB cookie on Amiga. (VRI)

2012-08-04
- desk/deskapp.c desk/icons.c: ICONBLKs in icons.c now use ptrs to data/mask
  instead of non-standard index numbers. (RFB)
- desk/deskapp.c desk/deskins.c desk/icons.c desk/icons.h: Clean up icon name
  stuff prior to implementing icons in a .RSC file. (RFB)

2012-08-05
- desk/deskact.c desk/deskapp.c desk/deskbind.h: Save ~2K RAM by replacing one
  of the global ICONBLK arrays with an array of pointers. (RFB)

2012-08-08
- bios/kprint.c: Fix bug in Super() expansion, introduced in rev 1.43. (RFB)
- desk/deskapp.c: Code cleanup: eliminate 'unused variable' warning
  messages. (RFB)

2012-08-09
- bios/amiga.c: Fixed clock year on real hardware. (VRI)
- bios/amiga.c: Fixed keyboard acknowledge bug. (VRI)
- desk/deskins.c: Fix desktop crash when doing 'Configure application' and
  no icons are available (eg 192K ROMs). (RFB)
- desk/deskwin.c: Change initial desktop display for 192K ROMs to standard
  text format (was strange 'text-as-icons' display). (RFB)

2012-08-10
- aes/gemobed.c: Code cleanup: removed compatibility macros & made local
  function static. (RFB)

2012-08-11
- bios/floppy.c: Renamed flopini() to flop_add_drive(). (VRI)
- bios/blkdev.c: Fixed Mediach() return value when there is no floppy. (VRI)

2012-08-13
- bios/amiga.c bios/amiga.h bios/floppy.c: Added support for reading ST floppies
  on Amiga. (VRI)
- tools/erd.c: Improve handling of ICONBLKs and TEDINFOs prior to upcoming
  icon resource decompiler. (RFB)
- desk/deskapp.c desk/icons.c desk/icons.h: Rename gl_ilist[] to
  icon_rs_iconblk[] for upcoming icon resource decompiler. (RFB)

2012-08-15
- bios/machine.c: Disabled currently useless 64 kB _FRB buffer on Amiga. (VRI)
- aes/* desk/*: Changed file selector string parameter types to BYTE*. (VRI)
- aes/*: Changed scrap functions string parameter types to BYTE*. (VRI)
- aes/*: Changed shell functions string parameter types to BYTE*. (VRI)
- aes/*: Removed global variables ad_scdir, ad_path, ad_scrap and ad_scmd. (VRI)
- aes/gemfslib.c: Fixed the file selector for deeply nested directories. (VRI)
- tools/erd.c: Add support for icon resource decompilation. (RFB)
- desk/icon.def desk/icon.rsc: Added icon resource. (RFB)

2012-08-16
- desk/icons.c po/POTFILES.in: Make icon descriptions translatable. (RFB)
- tools/erd.c: Fix bug in code generated by icon resource decompilation. (RFB)
- Makefile .cvsignore desk/.cvsignore: Add support for building icons.*
  from icon resource. (RFB)
- desk/icons.c desk/icons.h: Removed from CVS, now generated by ird. (RFB)
- doc/resource.txt: Updated to include information about ird. (RFB)
- desk/icons/*: Removed all files in directory from CVS, no longer used. (RFB)
- desk/deskapp.c desk/desktop.def desk/desktop.rsc include/config.h
  tools/erd.c: Code cleanup: move non-displayed/untranslated strings from
  desktop resource to C code. (RFB)

2012-08-17
- aes/gem.def aes/gem.rsc aes/gemaplib.c aes/geminit.c aes/geminit.h
  aes/gemobed.c aes/gemsclib.h aes/gemshlib.c tools/erd.c: Code cleanup:
  move non-displayed/untranslated strings from GEM resource to C code. (RFB)
- desk/deskapp.c desk/deskapp.h desk/icon.def desk/icon.rsc: Provide copies
  of generic app/doc icons for future use. (RFB)

2012-08-18
- desk/deskapp.h desk/deskins.c: Allow for future usage of only some of
  desktop icons. (RFB)

2012-08-19
- desk/deskapp.c desk/deskins.c: Allow ICONBLKs for 'Configure application'
  to be omitted. (RFB)
- desk/desktop.def desk/desktop.rsc desk/deskins.c: Move string to resource
  and make it translatable. (RFB)

2012-08-20
- desk/deskins.c desk/deskrsrc.c desk/deskrsrc.h: Code cleanup: simplify
  code & eliminate a global. (RFB)
- aes/gemfslib.c: Code cleanup: removed compatibility & OB_ macros. (RFB)

2012-08-21
- aes/gemctrl.c: Code cleanup: removed compatibility & OB_ macros. (RFB)

2012-08-22
- aes/gemrslib.c: Code cleanup: removed OB_ & related macros. (RFB)
- aes/optimize.c: Code cleanup: removed OB_ & compatibility macros. (RFB)
- aes/gemfslib.c aes/optimize.c aes/optimize.h: Code cleanup: eliminate
  some global functions. (RFB)

2012-08-23
- aes/gem.def aes/gem.rsc aes/gemfslib.c: Fixed regression in file selector
  and cleaned up code. (RFB)

2012-08-24
- aes/gem.def aes/gem.rsc aes/gemfslib.c aes/gemlib.h: Made the file
  selector more Atari-like. (RFB)
- aes/gemfslib.c aes/gemfslib.h aes/geminit.c aes/geminit.h aes/gemsclib.c
  aes/gemshlib.c aes/gemshlib.h: Code cleanup: eliminate some superfluous
  and confusing global variables. (RFB)

2012-08-25
- aes/gemfmlib.c aes/gemwmlib.c: Code cleanup: removed OB_ & related
  macros. (RFB)

2012-08-28
- aes/gemrslib.c: Reverted most recent changes which caused crashes in many
  programs including QED & TeraDesk. (RFB)

2012-08-29
- bios/kprint.c bios/vt52.c bios/vt52.h: Fixed crash when dopanic() is called
  before vt52 is initialized. (VRI)
- include/kprint.h: Safer dopanic() prototype. (VRI)
- bios/screen.c: Initialize the VBL interrupt handler before using vsync().
- aes/gemfslib.c: Fix regression in handling paths longer than the directory
  line. (RFB)
- aes/gemfslib.c: Code cleanup: eliminate compatibility macros. (RFB)
- aes/gemfslib.c: Do not try to maintain slider position between file
  selector calls (simpler & more Atari-like). (RFB)
- aes/gemfslib.c: Code cleanup: eliminate LEN_FTITLE and remove unneeded
  arguments to fs_newdir(). (RFB)
- bios/screen.c bios/startup.S: Workaround for Hatari which does not disable the
  MFP interrupts after a RESET instruction. This fixes the RAM versions. (VRI)
- aes/gemfslib.c: Speed up redraw of file selector drive buttons. (RFB)
- aes/gemlib.h: Code cleanup: deleted some macros that were duplicates of
  macros in crysbind.h. (RFB)

2012-08-30
- bios/bios.c: Fixed memory leak after running the early console. (VRI)
- aes/crysbind.h aes/gem.def aes/gem.rsc aes/gemfslib.c aes/gemfslib.h
  aes/gemsuper.c: Implemented fsel_exinput() function. (RFB)
- aes/gemsuper.c include/config.h: Make appl_init() return AES version as
  1.40 since we now support fsel_exinput(). (RFB)

2012-08-31
- aes/gemshlib.c: Factorized aes_run_rom_program(). (VRI)
- aes/gemfslib.c: Code cleanup: simplify & eliminate variables. (RFB)
- aes/gemfslib.c util/string.c: Fix bug: allow file selector mask to be
  lengthened. (RFB)

2012-09-01
- bios/screen.c bios/videl.c: Added vsync() to avoid the plane shift bug when
  changing the resolution on ST. (VRI)
- bios/ikbd.c bios/panicasm.S include/kprint.h: Now cold reset always reboot
  to the ROM OS, even with EmuTOS RAM versions.
- aes/gemfslib.c: Fix loop in file selector when mask is too long. (RFB)
- aes/gemfslib.c: Cosmetic improvement to file selector. (RFB)

2012-09-02
- aes/gemfslib.c: Code cleanup: replace static variables with dynamic. (RFB)
- aes/gemfmalt.c aes/gemfmalt: Code cleanup: eliminate unnecessary globals,
  OB_ macros, compatibility macros. (RFB)

2012-09-03
- aes/gemobjop.c: Code cleanup: eliminated OB_ & compatibility macros,
  rewrote get_par(). (RFB)
- aes/gem.def aes/gem.rsc: Changed FSTITLE marker from X to _ to avoid
  unnecessary translation requirement. (RFB)
- aes/gemlib.h aes/gemmnlib.c: Code cleanup: eliminate OB_ & compatibility
  macros. (RFB)

2012-09-05
- bios/*: Use 0x00ffxxxx instead of 0xffffxxxx to access I/O registers. (VRI)

2012-09-06
- bios/videl.c: Fix Falcon hardware palette initialisation for real Falcon
  hardware. (RFB)

2012-09-12
- bios/screen.c bios/videl.c: Fixed vsync() startup trouble. (VRI)

2012-09-13
- doc/status.txt: Updated. Contributed by Eero Tamminen. (VRI)
- vdi/vdi_defs.h vdi/vdi_text.c: Replaced copy_name() by memcpy(). Contributed
  by Eero Tamminen. (VRI)

2012-09-26
- desk/deskmain.c: Fixed buffer overflow in xlate_fix_tedinfo(). (VRI)

2012-10-01
- vdi/vdi_col.c: Quick hack to see something in TosWin2 on Falcon. (VRI)

2012-10-07
- Makefile bios/aciavecs.S bios/bios.c bios/chardev.c bios/iorec.h
  bios/mfp.c bios/mfp.h bios/serport.c bios/serport.h bios/xbios.c:
  Reorganised serial i/o code prior to adding Falcon serial i/o support. (RFB)

2012-10-09
- bios/serport.c bios/serport.h: Reformat & tidy up code. (RFB)

2012-10-10
- bios/serport.c bios/serport.h bios/xbios.c: Fix Rsconf() to return
  ULONG instead of void. (RFB)

2012-10-11
- bios/machine.c bios/machine.h bios/screen.h: Replaced hard-coded
  values with #defines in feature detection code. (RFB)

2012-10-12
- bios/machine.c bios/machine.h include/config.h: Added detection of
  additional serial ports: Falcon SCC and TT second MFP. (RFB)

2012-10-13
- bios/bios.c bios/chardev.c bios/chardev.h bios/ikbd.c bios/ikbd.h
  bios/kprint.c bios/midi.c bios/midi.h bios/parport.c bios/parport.h
  bios/serport.c: Code cleanup: remove unnecessary argument passed
  in Bconout() processing. (RFB)
- bios/bios.c bios/chardev.c bios/chardev.h bios/parport.c
  bios/tosvars.h: Code cleanup: save ROM space & fix swapping of Bcostat()
  for ikbd & midi. (RFB)

2012-10-15
- bios/bios.c bios/chardev.c bios/chardev.h bios/iorec.h bios/serport.c
  bios/serport.h bios/xbios.c bios/xbios.h: Added Bconmap() support. (RFB)
- doc/status.txt: Small corrections to lists of implemented functions. (RFB)

2012-10-18
- bios/ide.c: Fixed and enabled support for IDE slave device. Contributed by
  Stephen Leary. (VRI)
- bios/ide.c bios/ide.h bios/machine.c include/config.h: Enabled the internal
  IDE driver by default. (VRI)

2012-10-26
- bios/bios.c bios/chardev.c bios/chardev.h bios/ikbd.c bios/ikbd.h
  bios/kprint.c bios/midi.c bios/midi.h bios/parport.c bios/parport.h
  bios/serport.c bios/serport.h bios/tosvars.h : Fix args passed to xconout
  vectors (regression introduced 2012-10-13). (RFB)

2012-10-27
- aes/gemsuper.c aes/crysbind.h: Fix overwrite of local AES arrays if
  originals are longer than expected. (RFB)
- aes/gemsuper.c: Fix warning msg introduced by previous update. (RFB)
- aes/gemfslib.c: Allow empty string in path passed to file selector. (RFB)

2012-11-06
- bios/bios.c bios/delay.c bios/delay.h bios/delayasm.S include/asm.h
  Makefile: Add calibrated delay loop. (RFB)
- bios/machine.c bios/machine.h: Rename SCC_PORTA_CTL to SCC_BASE for
  clarity. (RFB)

2012-11-08
- bios/serport.c bios/serport.h: Add Falcon serial I/O support (supports
  SCC chip on Falcon & TT). (RFB)

2012-11-10
- bios/bios.c bios/kprint.c include/config.h include/kprint.h: Add new
  debug option SCC_DEBUG_PRINT to route kprintf() to SCC (Falcon serial
  port). (RFB)

2012-11-15
- bios/startup.S include/asmdefs.h: Fix startup so that EmuTOS RAM works
  on real Falcon. (RFB)

2012-11-23
- bios/startup.S: Disable data & instruction caches at beginning of boot. (RFB)
- bios/startup.S include/asmdefs.h: Disable MMU at beginning of boot. (RFB)

2012-11-25
- bios/processor.h bios/processor.S bios/vectors.S include/asmdefs.h:
  Enable instruction cache on 68030. (RFB)
- bios/serport.c: Insert required delays for SCC chip access. (RFB)

2012-11-27
- bios/bios.c bios/machine.c bios/machine.h: Code cleanup: rename
  machine_init() to fill_cookie_jar(). (RFB)
- bios/bios.c bios/machine.c bios/machine.h: Initialise Falcon bus control
  register (sets cpu speed to 16MHz). (RFB)

2012-11-28
- bios/serport.c bios/serport.h: Code cleanup: make functions static. (RFB)

2012-12-02
- bios/machine.c: Fix _SWI cookie to set high order bytes to zeros. (RFB)
- bios/machine.c: Set correct value in _FDC cookie. (RFB)
- bios/floppy.c include/asm.h: Use calibrated delay loop for floppy register
  access. (RFB)
- bios/floppy.c: Code cleanup: update comments re floppy track format. (RFB)

2012-12-03
- bios/blkdev.c bios/blkdev.h bios/floppy.c bios/floppy.h: Code cleanup:
  reorganise media change handling for floppies. (RFB)

2012-12-06
- bios/blkdev.c bios/blkdev.h bios/floppy.c: Protobt(): add new disk types
  and fix checksum & serial number. (RFB)

2012-12-10
- bios/blkdev.c bios/dma.h bios/floppy.c: Add support for HD floppy disks
  as indicated by _FDC cookie. (RFB)

2012-12-11
- bios/floppy.c bios/floppy.h bios/xbios.c: Flopfmt() now supports the
  skew array introduced in TOS 1.04. (RFB)
- bios/floppy.c: Flopfmt() now supports interleave. (RFB)

2012-12-13
- bios/acsi.c bios/blkdev.c bios/blkdev.h bios/disk.c bios/floppy.c
  bios/ide.c bios/xhdi.c: Code cleanup: #define physical sector size in
  one place. (RFB)
- bios/floppy.c: Fix compile errors when MACHINE_AMIGA is defined. (RFB)
- bios/disk.c bios/disk.h: Tidy up code format, variable names etc. (RFB)

2012-12-15
- bios/blkdev.c bios/blkdev.h bios/disk.c bios/floppy.c bios/xhdi.c:
  Code cleanup: replace magic number 2 with NUMFLOPPIES. (RFB)

2012-12-18
- bios/bios.c: Fixed wrong charset in multilanguage builds when the _AKP
  cookie is initialized from the NVRAM (ex: wrong Spanish accents). (VRI)
- bios/serport.c: Fixed compilation warnings with "make aranym". (VRI)

2012-12-19
- bios/delay.c: Use __mcoldfire__ instead of MACHINE_FIREBEE. (RFB)
- bios/bios.c: Fixed regression on default interrupt handlers. At least
  ARAnyM's network and fVDI driver requires INT3 handler to be initialized
  with a simple RTE, otherwise they crashes with "Exception number 27". (VRI)
- bios/*: Use again 0xffffxxxx instead of 0x00ffxxxx to access I/O registers.
  The hardware supports both, but 0xffffxxxx allows the .w optimization. (VRI)
- bios/blkdev.c: Fixed latent bug in blkdev_rwabs() when transferring
  >32767 sectors. (RFB)
- bios/floppy.c: Fixed compilation for non-Atari hardware. (VRI)
- bios/serport.c: Fixed test on wrong define in rsconfTT(). (VRI)
- bios/serport.c: Fixed warning about rsconfTT() with "make aranym". (VRI)
- bios/serport.c bios/startup.S: Moved read-only data to TEXT segment. (VRI)
- bios/machine.c: Set the Falcon Bus Control Register on the FireBee. (VRI)
- bios/machine.c: Added guess_machine_name(). (VRI)
- *: Added the MAYBE_UNUSED() macro. (VRI)

2012-12-20
- bios/serport.c bios/serport.h bios/xbios.c: Refactored serial port support
  for better readability with conditional compilation. (VRI)

2012-12-23
- bios/chardev.c bios/serport.c bios/serport.h xbios.c: Reverted previous
  update because EmuTOS RAM did not work on real Falcon. (RFB)

2012-12-25
- bios/chardev.c: Added const to vector initialisation arrays. (RFB)

2012-12-30
- bios/ctrycodes.h: Fixed Slovakia, Greece and Russia country codes. (VRI)
- bios/ikbd.c: Fixed welcome screen key repeat bug with FreeMiNT. (VRI)

2012-12-31
- bios/serport.c bios/serport.h: Refactored serial port support, based on
  previous patch by Vincent Riviere. (RFB)

2013-01-01
- bios/blkdev.c bios/blkdev.h bios/disk.c bios/floppy.c bios/xhdi.c:
  Minor code refactor / clean up prior to IDE changes. (RFB)
- util/string.c util/string.h: Added strlcpy() for use by IDE code. (RFB)
- bios/psg.h: Fix typo in #define. (RFB)

2013-01-03
- bios/ctrycodes.h tools/tos-lang-change.c: Removed Slovak Republic country code
  as it is currently unused. (VRI)

2013-01-07
- bios/bios.c bios/vectors.S bios/xbios.c: Fixed crash when BIOS or XBIOS are
  called with a function number greater than 32767. Bug reported by Olivier
  Landemarre. (VRI)

2013-01-15
- bios/serport.c: Fix bug: SCC serial I/O routines do not always delay after
  accessing SCC. (RFB)

2013-01-17
- bdos/mem.h bios/biosmem.h include/memdefs.h: Code cleanup: eliminate
  duplicate definitions of MD & MPB. (RFB)

2013-01-18
- bios/iorec.h bios/mfp.c tools/bug.c tools/compr.c tools/tounix.c
  tools/uncompr.c util/nlsasm.S: Changed the copyright owner from "Laurent
  Vogel" to "EmuTOS development team". (VRI)
- bios/ctrycodes.h tools/tos-lang-change.c: Reverted Russia country code to 19,
  as FreeMiNT people agreed to keep it as the official standard. (VRI)

2013-01-19
- bdos/mem.h bdos/osmem.c: Issue error message & halt when internal OS memory
  is exhausted. (RFB)
- doc/osmemory.txt: Add documentation on internal OS memory. (RFB)

2013-01-20
- bios/scc.h bios/serport.c: Moved struct for SCC chip to new header. (RFB)
- bios/bios.c bios/machine.c bios/startup.s include/config.h: Do not use
  reset instruction if compiling for EmuTOS RAM. (RFB)
- po/POTFILES.in: Add osmem.c to list of files with _(...) macro. (RFB)

2013-01-21
- cli/command.c: Minor improvements to displayed text strings. (RFB)
- cli/command.c: Fix MV command to move rather than copy. (RFB)
- bios/disk.c bios/disk.h bios/ide.c: Add support for not-byteswapped
  disk partitions. (RFB)

2013-01-23
- Makefile bios/startup.S include/asmdefs.h: Added support for the m68k-elf
  toolchain. Use with "make 512 ELF=1". (VRI)
- aes/gemdosif.S aes/gemstart.S bios/aciavecs.S bios/comprimg.S bios/linea.S
  bios/natfeat.S cli/coma.S include/asmdefs.h: Added support for section .rodata
  with ELF toolchain. (VRI)
- include/xbiosbind.h vdi/vdi_col.c: Fix vq_color() & vs_color() for systems
  with videl. (RFB)
- vdi/vdi_col.c: Remove debugging statements. (RFB)

2013-01-24
- bios/blkdev.c bios/blkdev.h bios/floppy.c: Removed useless byteswap member in
  BLKDEV structure. (VRI)
- bios/ide.c bios/ide.h bios/xhdi.c: Fixed recent regression on byteswapped IDE
  disks. (VRI)

2013-01-25
- Makefile bios/clock.c bios/serport.c cli/command.c include/config.h: Added
  the -Wundef option to avoid using undefined preprocessor identifiers. (VRI)
- vdi/vdi_col.c: Minor changes to initial ST/Falcon VDI palettes to agree
  with TOS. (RFB)

2013-01-27
- bios/processor.S include/asmdefs.h: Detect 68ec030 processor subtype. (RFB)
- bios/68030_pmmu.S bios/processor.S bios/tosvars.S include/asmdefs.h
  include/config.h Makefile: Add PMMU tree & enable data caching for
  68030 processors. (RFB)
- aes/geminit.c bios/bios.c bios/blkdev.c bios/ikbd.c bios/ikbd.h
  bios/initinfo.c: Use #defines instead of magic numbers for mode keys. (RFB)

2013-01-28
- bios/blkdev.c: Disable boot sector execution when Control is held
  down. (RFB)
- bios/68030_pmmu.S: Moved read-only data to SECTION_RODATA. (VRI)
- po/fr.po: Added missing translations. (VRI)
- desk/deskapp.c desk/desktop.def desk/desktop.rsc: Added "DISK" and
  "TRASH" from the desktop to the translatable strings. (RFB)
- bios/disk.c: Support DOS hard disk with no MBR. (RFB)

2013-01-29
- po/fi.po: Updated. Contributed by Eero Tamminen. (VRI)
- Makefile bios/amiga.c bios/amiga.h bios/amiga2.S bios/aros.c bios/aros.h
  bios/aros2.S: Split amiga.c to aros.c due to license issues. (VRI)

2013-01-30
- aes/gemsuper.c: Code cleanup: eliminate OB_ macros. (RFB)
- desk/deskapp.c: Handle internationalization of desktop DISK & TRASH
  names just like TOS. (RFB)
- bios/acsi.c bios/floppy.c bios/machine.c bios/machine.h include/config.h:
  Proper _FRB handing to fix floppy routines on Amiga with Alt Ram. (VRI)
- po/de.po: Updated German translations. (THH)
- bios/acsi.c: Code cleanup: removed GOTOs & simplified do_acsi_rw(). (RFB)

2013-01-31
- vdi/vdi_fill.c: Fixed v_contourfill() with negative index. (VRI)
- Makefile bios/68040_pmmu.S bios/processor.S include/config.h: Added
  experimental support for 68040 PMMU initialization. This does the same as
  set_mmu.prg, which is now useless. Contributed by Miro Kropáček. (VRI)

2013-02-01
- aes/gemobed.c: Always center dialogs, even with high resolutions. (VRI)
- desk/desktop.rsc po/*.po: Display doc\license.txt with \ in about box. (VRI)
- bios/initinfo.c: Center the initinfo screen vertically. (VRI)
- bios/acsi.c bios/floppy.c bios/processor.h bios/processor.S
  include/asmdefs.h: Fix bug: caches were not flushed/invalidated when
  DMA was used. (RFB)
- bios/lineainit.c bios/lineavars.h vdi/vdi_misc.c vdi/vdi_tblit.S
  vdi/vdi_tblit_cf.S: Fixed Hatari extended VDI screens in ST mode. (VRI)

2013-02-02
- po/it.po: Updated. Contributed by Lodovico Zanier. (VRI)
- bios/startup.S: Removed Hatari workaround, since the RESET instruction is not
  used anymore in emutos-ram. (VRI)
- bios/ikbd.c bios/panicasm.S bios/screen.c include/kprint.h: Added
  warm_reset() to restart the current OS. (VRI)

2013-02-03
- bios/bios.c bios/panicasm.S bios/tosvars.h bios/tosvars.S include/config.h:
  Added proper warm boot detection on the FireBee and in emutos-ram.
- po/ru.po: Updated. Contributed by Dima Sobolev. (VRI)
- bios/machine.c: Fixed crash of emutos-ram on machines without SCC. (VRI)
- bios/vt52.c: Fixed vt52_init() and Setscreen() to clear the screen. (VRI)
- bios/bios.c bios/initinfo.c bios/initinfo.h: Removed initscreen(). (VRI)
- bdos/proc.c bios/acsi.c bios/floppy.c bios/processor.h bios/processor.S:
  Renamed the CPU cache management functions(). (VRI)
- bios/processor.S: Implemented data cache functions for ColdFire. (VRI)
- bios/initinfo.S: Remove useless initinfo scroll on RGB monitors. (VRI)
- bios/floppy.c: Added cache management for loading bootsector. (VRI)
- bios/disk.c: Limited byteswap support to IDE devices. (VRI)

2013-02-05
- po/es.po: Updated. Contributed by David Gálvez. (VRI)

2013-02-06
- Makefile release.mk: Renamed amiga-kickdisk target to amigakd. (VRI)
- include/config.h: Enabled again IDE on Amiga (was disabled by mistake). (VRI)
- bios/amiga.c bios/aros.c bios/aros2.S include/config.h: Added CONF_WITH_AROS
  to enable compilation with AROS sources. This is disabled by default due to
  license issues. (VRI)
- bios/aros.c bios/aros2.S doc/license_aros.txt: Added AROS APL license. (VRI)

2013-02-07
- bios/bios.c bios/tosvars.h bios/tosvars.S util/bootsect.S: In emutos-floppy,
  do not ask to remove the floppy on every warm boot. (VRI)
- bios/pmmu030.c bios/processor.S bios/tosvars.S include/config.h Makefile:
  Refactored 68030 PMMU support. (RFB)
- bios/68030_pmmu.S: Removed file, no longer used. (RFB)

2013-02-10
- po/cs.po: Updated. Contributed by Pavel Salač. (VRI)

2013-02-11
- bios/ikbd.c: Fixed Hatari hang on cold boot. (VRI)
- bios/blkdev.c: Changed blkdev_rwabs() to call XHReadWrite() directly
  rather than via DMAread()/DMAwrite(). (RFB)

2013-02-12
- bios/acsi.c bios/blkdev.c bios/disk.c bios/floppy.c: Cache flush &
  invalidation now take place at Bios/Xbios level. (RFB)
- bios/ikbd.c: Use delay_loop() to implement IKBD timeout. (VRI)
- bios/processor.S: For TOS compatibility, both caches are now
  invalidated after a read on a 68030. (RFB)

2013-02-13
- readme.txt doc/announce.txt doc/install.txt: Updated. (VRI)

2013-02-14
- bios/acsi.c bios/blkdev.c bios/disk.c bios/floppy.c: Revert changes to
  cache flush & invalidation. (RFB)

2013-02-15
- include/config.h: Enabled again Mega ST clock support in 192 kB ROMs. (VRI)
- include/config.h: Enabled again the easter egg in 192 kB ROMs. (VRI)
- include/config.h: Enabled USE_STOP_INSN_TO_FREE_HOST_CPU in 192 kB ROMs. (VRI)

2013-02-16
- doc/*: Updated. (VRI)
- *: Removed trailing spaces. (VRI)
- Makefile bios/initinfo.c doc/readme-amiga.txt: AROS support can be enabled
  with "make amiga AROS=1". Warning message added. (VRI)
- doc/status.txt: A few minor changes. (RFB)

2013-02-17
- bios/blkdev.c: Fix obscure latent bug in blkdev_rwabs(). (RFB)
- desk/desktop.def desk/desktop.rsc: Change Easter Egg object size to fix
  regression in 0.8.7. (RFB)
- bios/blkdev.c bios/disk.c bios/processor.h bios/processor.S: Move
  TOS-compatibility i-cache invalidation to Rwabs() & DMAread(). (RFB)

2013-02-18
- *: Updated copyright year for files modified since last release. (VRI)
- bios/ide.c: Fixed return value of ide_read_sector(). (VRI)
- *: Removed empty lines at end of file. (VRI)
- *.S: Removed useless .end directive at end of file. (VRI)
- doc/bugs.txt doc/coding.txt: Minor updates. (RFB)

2013-02-19
- doc/bugs.txt: Updated. Contributed by Eero Tamminen. (VRI)
- *.c: Removed useless inline on static functions. (VRI)
- bios/blkdev.c bios/disk.c bios/processor.h bios/processor.S: I-cache
  invalidation kludge now applies to all 680x0. (RFB)
- Makefile util/boot.c: Fixed pseudo-cold boot when EmuTOS loads itself. (VRI)
- bios/blkdev.c: Initialize drvbits to avoid bogus drives in EmuTOS-RAM. (VRI)
- bios/acsi.c bios/floppy.c: Minor reordering between caches and locks. (VRI)

2013-02-20
- bios/startup.S: Fixed startup regression in emutos-cartridge. (VRI)

2013-02-21
- bios/startup.S: Disable the interrupts at startup even on cartridge. (VRI)
- bios/startup.S include/config.h: Fixed reset for non-Atari hardware. (VRI)
- bios/panicasm.S: Better cold boot on the FireBee. (VRI)

2013-02-22
- po/gr.po: Updated Greek translation. Contributed by Christos Tziotzis. (VRI)

2013-02-23
- aes/gemfslib.c: Initialize newdrive.  Thanks to David Savinkoff. (RFB)

2013-02-25
- util/boot.c util/bootasm.S: Add i-cache invalidation (68030 only). (RFB)

2013-02-26
- bios/floppy.c: Fix bug: floppy auto-detect did not work properly on
  real hardware. (RFB)
- bios/floppy.c: Floppy i/o failed when i/o accesses were more than
  0.5secs apart. (RFB)

2013-02-27
- bios/blkdev.c bios/blkdev.h bios/floppy.c: Flop_mediach() now checks
  for either TOS or MSDOS serial number change. (RFB)

* Release: 0.9.0

2013-03-01
- bios/dmasound.* bios/xbios.c: Added the core XBIOS DMA sound functions. (THH)
- aes/gemrslib.c: Code cleanup: eliminate OB_ macros. (RFB)
- aes/gemoblib.c: Code cleanup: eliminate OB_ macros. (RFB)
- desk/deskact.c: Code cleanup: eliminate OB_ macros. (RFB)
- bdos/fs.h bdos/fsdrive.c bdos/fsio.c: Performance: replaced divmod()
  with shift/mask. (RFB)
- bdos/fsfat.c: Performance: replace multiply with shift. (RFB)
- desk/deskdir.c: Code cleanup: eliminate OB_ macros. (RFB)
- doc/*: Updated. Contributed by Eero Tamminen. (VRI)

2013-03-02
- bios/xbios.c: Fixed GCC warning messages. (RFB)
- desk/desksupp.c: Code cleanup: eliminate OB_ macros. (RFB)
- desk/deskmain.c: Code cleanup: eliminate OB_ macros. (RFB)
- desk/deskinf.c: Code cleanup: eliminate OB_ macros. (RFB)
- desk/deskins.c: Code cleanup: eliminate OB_ macros. (RFB)
- aes/gemobjop.c: Removed obaddr() function (no longer required). (RFB)
- aes/geminit.c aes/gemobed.c aes/gemoblib.c aes/gemrslib.c aes/gemshlib.c
  aes/gemsuper.c desk/deskact.c desk/deskdir.c desk/deskinf.c desk/deskins.c
  desk/deskmain.c desk/desksupp.c: Removed #include for taddr.h. (RFB)
- include/taddr.h: Deleted (no longer required). (RFB)

2013-03-03
- bdos/fsfat.c: Rewrote getrealcl() for better performance. Based on a
  idea by Laurent Vogel. (RFB)
- bdos/fsfat.c: Rewrote clfix() for better performance. Based on an idea
  by Laurent Vogel. (RFB)

2013-03-04
- aes/gemdos.c aes/gemgraf.c aes/gemgsxif.c aes/gemgsxif.h aes/geminput.c
  aes/gemmnlib.c aes/gempd.c aes/gemsclib.c aes/gemshlib.c aes/gemshlib.h
  aes/gemwmlib.c aes/gemwrect.c bios/font.c desk/deskgraf.c desk/deskmain.h
  tools/erd.c vdi/vdi_defs.h vdi/vdi_input.c Makefile: Convert remaining K&R
  code to ANSI-C. Contributed by Eero Tamminen. (VRI)
- aes/gemaplib.c aes/gemdisp.c aes/gemdisp.h aes/geminput.c aes/geminput.h
  bios/ide.c include/portab.h: Fixed forkq() prototype. (VRI)
- Makefile: Fix compatibility with GCC 2.95. Contributed by Eero Tamminen. (VRI)
- bdos/fs.h: Make BCB compatible with TOS tools. (RFB)
- util/minicrt.S: Correct misleading usage of STACK_SIZE. (RFB)
- util/boot.c: Convert K&R code to ANSI-C. (RFB)

2013-03-05
- tools/bug.c: Static cleanup. Contributed by Eero Tamminen. (RFB)
- tools/bug.c: Removed unused function try_c_string(). (VRI)
- Makefile bootasm.S: Added new firebee-ram target. (VRI)
- bios/vectors.S: Fixed return value of unimplemented (X)BIOS functions. (VRI)
- aes/gemdos.c aes/gemdos.h aes/geminit.c desk/deskbind.h desk/deskdir.c:
  Allow dos_read()/dos_write() to transfer >64K. (RFB)
- desk/deskbind.h desk/deskdir.c: Improve desktop file copy performance. (RFB)
- tools/bug.c: Generate warning messages for illegal alerts (disabled
  initially). Contributed by Eero Tamminen. (RFB)

2013-03-06
- bios/blkdev.c bios/blkdev.h bdos/fs.h bdos/fsdrive.c: Static cleanup. (RFB)
- bdos/fsmain.c bdos/fsopnclo.c: Added some clarification comments. (RFB)

2013-03-07
- aes/gemctrl.c aes/gemgsxif.c aes/geminit.c aes/geminit.h: Code cleanup:
  use MFORM for mouse form instead of array of WORDs. (RFB)
- aes/gemgsxif.c aes/gemsuper.c include/compat.h: Code cleanup: eliminate
  LWCOPY macro. (RFB)
- bios/memory.S: Do not clear the FastRAM anymore, to improve boot speed. (VRI)
- aes/gemaplib.c aes/gemdisp.c aes/geminit.c aes/geminput.c aes/gemoblib.c
  aes/gemqueue.c aes/gemshlib.c desk/deskapp.c desk/deskinf.c
  include/compat.h: Code cleanup: eliminate LBCOPY macro. (RFB)
- util/memmove.S: Improve memcpy() speed for small lengths. (RFB)
- bdos/fs.h bdos/fsopnclo.c: Remove some duplicate #defines. (RFB)

2013-03-08
- bios/blkdev.c bios/blkdev.h: Static cleanup. (RFB)

2013-03-09
- cli/command.c: Fix occasional crash in CLI rename command. (RFB)
- include/config.h aes/gemdisof.S aes/gemsuper.c aes/struct.h: Added
  CONF_DEBUG_AES_STACK to debug and estimate the AES stack usage. (VRI)
- aes/struct.h: Increased STACK_SIZE to allow running XaAES with GEM=ROM. (VRI)
- desk/deskmain.c desk/desksupp.c desk/desktop.def desk/desktop.rsc:
  Remove unnecessary info dialog for "New folder" (present in all ROMs
  but only used in 192K). (RFB)

2013-03-11
- aes/geminit.c: Fix divide-by-zero when ev_dclick() is called before
  gl_ticktime is initialised. (RFB)

2013-03-12
- bios/dmasound.c: Added remaining Soundcmd() functionality for Falcon. (THH)
- bios/bios.c: Panic instead of endless loop on zero divide on ColdFire. (VRI)
- include/asm.h: Safe set_sr() for ColdFire. Reported by Markus Fröschle. (VRI)
- *.S: Replaced dc.b by .dc.b and so on. This makes the pseudo-ops more visible
  and fixes compilation with buggy m68k-elf toolchain with -g. (VRI)
- bios/xhdi.c: Uncomment XHMiNTInfo and add it to the XHDI handler. Contributed
  by David Gálvez. (VRI)
- bdos/fsdir.c include/gemerror.h: Allow Frename() to rename folders. (RFB)

2013-03-13
- bdos/fsdir.c: Removed non-TOS extension to Dsetpath(). (RFB)
- aes/gemshlib.c: Small code optimisation. (RFB)
- aes/gemqueue.c aes/gemwmlib.c desk/deskapp.c desk/deskfpd.c
  desk/deskins.c desk/deskobj.c desk/deskwin.c include/compat.h: Replace
  movs() macro with memcpy(). (RFB)
- aes/optimize.c aes/optimize.h desk/deskinf.c: Eliminate inf_fldset()
  function to save space & clarify code. (RFB)

2013-03-14
- desk/deskinf.c: Code cleanup: save some stack & code space. (RFB)
- desk/deskmain.c desk/deskstart.S include/config.h: Added
  CONF_DEBUG_DESK_STACK to debug and estimate desktop stack usage. (RFB)
- desk/deskinf.c: Code cleanup: eliminate compatibility macros, replace
  some globals with locals. (RFB)
- desk/deskinf.c desk/desksupp.c desk/desktop.def desk/desktop.rsc:
  Allow folders to be renamed from the desktop. (RFB)
- desk/deskbind.h desk/deskdir.c desk/deskfun.c desk/deskpro.c:
  Eliminate global variables D.g_srcpth, D.g_dstpth. (RFB)

2013-03-15
- desk/deskinf.c desk/deskinf.h desk/desksupp.c desk/desktop.def
  desk/desktop.rsc: Combine file and folder information dialogs. (RFB)

2013-03-16
- bios/kprint.c: Added CRLF translation in kprintf_outc_rs232(). (VRI)
- aes/gemsuper.c bios/chardev.c bios/ikbd.c include/config.h: Added new define
  CONF_SERIAL_CONSOLE to redirect console I/O to the serial port. (VRI)
- desk/deskdir.c desk/desktop.def desk/desktop.rsc: Combine copy and
  delete desktop dialogs. (RFB)

2013-03-17
- desk/deskdir.c desk/deskinf.c desk/deskmain.c desk/deskmain.h:
  Automatically centre desktop dialog titles. (RFB)
- desk/deskdir.c: Code cleanup: simplify fold_wind(). (RFB)
- bios/vt52.c: Removed unused vt52_initialized. (VRI)
- bios/bios.c bios/kprint.h: Check CHARDEV_AVAILABLE in BIOS character IO. (VRI)
- desk/deskapp.c desk/deskdir.c desk/deskdir.h: Refresh relevant open
  windows after saving EMUDESK.INF. (RFB)

2013-03-18
- desk/deskdir.c desk/deskdir.h desk/deskfun.c: Rewrote some functions
  to fix a window refresh bug, simplify code, and save space. (RFB)
- bios/chardev.c bios/vt52.c: Added ANSI translation for serial console. (VRI)
- desk/desktop.def desk/desktop.rsc: Fixed 'Open Application' dialog size
  for low-res display. (RFB)
- bdos/fsdrive.c: Code cleanup: remove bogus initialisation of
  o_bytnum/o_curbyt. (RFB)
- include/config.h: Change consistency check for CONF_WITH_DESK1 /
  CONF_WITH_DESKTOP_ICONS for future use. (RFB)

2013-03-19
- Don't use -Wold-style-definition by default, for GCC 2.x compatibility. (VRI)
- bios/fnt_* bios/keyb_*: Do not use forward declarations for arrays. (VRI)
- bios/bios.c: Fixed declarations after instructions, for ANSI compliance. (VRI)
- desk/deskapp.c desk/deskapp.h desk/deskmain.c: Allow CONF_WITH_DESK1 to
  be specified without CONF_WITH_DESKTOP_ICONS. (RFB)
- *: Fixed most warnings with -pedantic. (VRI)
- bios/aciavecs.S bios/ikbd.c bios/ikbd.h bios/sound.h: Cleaned up kbd_int()
  and keyclick() parameter signedness. (VRI)
- vdi/vdi_line.c: Now abline() uses pointers to UWORD instead of UBYTE. (VRI)
- tools/erd.c: Add static and const where relevant. Contributed by Eero
  Tamminen. (RFB)

2013-03-20
- util/bootasm.S: Removed non-ASCII dash. Contributed by David Savinkoff. (VRI)
- Makefile: Updated make help. Suggested by David Savinkoff. (VRI)
- Makefile: Adjust warning options according to GCC version. Contributed by Eero
  Tamminen. (VRI)
- tools/compr.c tools/erd.c tools/mkflop.c tools/mkrom.c tools/uncompr.c:
  Static cleanup. Contributed by Eero Tamminen. (VRI)
- Makefile bios/coldfire.c bios/coldfire.h bios/coldpriv.h bios/serport.c
  include/config.h: Added CONF_WITH_COLDFIRE_RS232 to use the internal ColdFire
  RS-232 port instead of the MFP one. (VRI)
- tools/erd.c: Fixed warnings when compiling erd.c with ICON_RSC defined. (RFB)
- tools/bug.c: Fix warning message. (RFB)
- tools/erd.c: Generate smaller icons.c if CONF_WITH_DESKTOP_ICONS is 0. (RFB)
- include/config.h: Changed the default desktop for 192K ROMs to DESK1. (RFB)

2013-03-21
- Makefile bios/coldfire.c bios/coldfire.h bios/coldfire2.S bios/coldpriv.h
  bios/mfp.c bios/vectors.S: Added CONF_COLDFIRE_TIMER_C to emulate the Timer C
  on ColdFire machines without MFP, using the internal ColdFire timers. (VRI)

2013-03-22
- bios/dmasound.c xbios.c: Implemented setracks() and setmontracks(). (THH)
- include/config.h: Enable CONF_WITH_FASTRAM when CONF_FASTRAM_SIZE is
  defined. (VRI)
- bios/vt52.c: Fixed cursor artifact on Esc E (Clear Screen). (VRI)
- cli/command.c: Use Esc E to clear the screen. (VRI)
- bios/vt52.c: Disable SERIAL_CONSOLE_HONOR_HOME by default. (VRI)
- Makefile release.mk bios/coldfire.c bios/coldfire.h bios/coldfire2.S
  bios/coldpriv.h bios/ide.c bios/machine.c bios/startup.S doc/readme-m548x.txt
  include/config.h: Added support for the ColdFire Evaluation boards. (VRI)

2013-03-23
- include/config.h: Fixed regression on FastRAM support. (VRI)
- tools/erd.c: Changed name of strdup() due to conflict on BSD systems. (RFB)

2013-03-24
- bios/dmasound.* bios/xbios.c: Added dsptristate() and gpio() XBIOS calls,
  and fixed write_microwire() to wait correctly now. (THH)

2013-03-25
- bios/dmasound.c: Added volume control via soundcmd() for STE/TT, too, and
  improved sndstatus() for Falcon. (THH)
- vdi/vdi_defs.h vdi/vdi_gdp.c vdi/vdi_line.c vdi/vdi_main.c: Static cleanup.
  Contributed by Eero Tamminen. (VRI)
- bios/kprintasm.S: Removed unused ASM glue for kprintf(). (VRI)
- bios/linea.S: Added DBG_LINEA. (VRI)
- bios/bios.c: Disabled DBGAUTOBOOT. (VRI)
- bios/acsi.c: Added DBG_ACSI. (VRI)
- bios/disk.c: Always test DBG_DISK before calling kprintf(). (VRI)
- aes/gemsuper.c: Always test DBG_GEMSUPER before calling kprintf(). (VRI)
- aes/gemgsxif.c: Added DBG_GEMGSXIF. (VRI)
- bios/blkdev.c: Always test DBG_BLKDEV before calling kprintf(). (VRI)
- bios/kprintf.c: Hide the cursor in panic(). (VRI)
- bios.linea.S: Cleaned up linea_stub. (VRI)
- bios.linea.S: Fail with panic on unimplemented Line A function. (VRI)

2013-03-27
- *: Static cleanup. Contributed by Eero Tamminen. (VRI)

2013-04-04
- cli/cmd.h cli/cmdasm.S cli/cmdedit.c cli/cmdexec.c cli/cmdint.c
  cli/cmdmain.c cli/cmdparse.c cli/cmdutil.c cli/Makefile: Added new
  (standalone) version of EmuCON. (RFB)

2013-04-07
- cli/cmdasm.S: Minor code cleanup. Thanks to Vincent Riviere. (RFB)
- cli/cmdexec.c: Formatting: change tabs to spaces, add GPL. (RFB)
- cli/cmdexec.c: Execute programs even if file extension is omitted. (RFB)

2013-04-13
- cli/cmdexec.c: Fix line endings. (RFB)
- cli/cmd.h cli/cmdedit.c: Add command completion. (RFB)

2013-04-14
- cli/cmdedit.c: Improve command completion. (RFB)

2013-04-18
- cli/cmd.h cli/cmdedit.c cli/cmdexec.c cli/cmdutil.c: Command
  completion for first word in line only includes executable
  programs. (RFB)

2013-04-22
- include/config.h include/kprint.h: Added KDEBUG(()) and KINFO(()). (VRI)
- bios/disk.c: Always display partition information with KINFO(()). (VRI)
- bios/bios.c: Added many KDEBUG(()) to track bios_init() progress. (VRI)

2013-04-24
- aes/*.c desk/*.c bios/delay.c bios/floppy.c: Make sure that each *.c file
  includes its own *.h to get proper prototype checking. Patch contributed
  by Eero Tamminen. (THH)
- Makefile: Keep "all" as first target. (VRI)
- desk/deskapp.c desk/deskapp.h desk/deskbind.h desk/deskmain.c
  desk/deskwin.c desk/deskwin.h: The number of columns of icons in desktop
  windows is now dynamically adjusted according to window width. (RFB)

2013-04-25
- bios/kprint.c include/config.h: Added COLDFIRE_DEBUG_PRINT. (VRI)
- cli/cmdedit.c: In line edit, ctl-C may now be used to cancel the
  current line. (RFB)

2013-04-30
- cli/cmdutil.c: Fix comparison of date_sep. Based on a contribution by
  Eero Tamminen. (RFB)
- bios/lineavars.h vdi/vdi_esc.c: Fix bug: vq_chcells() returned fixed
  values for rows/cols. (RFB)

2013-05-01
- doc/status.txt: Updated status of a couple of VDI functions. (RFB)
- bios/screen.c: Replaced DBG_SCREEN with KDEBUG(()). (RFB)

2013-05-03
- bios/lineainit.c bios/lineavars.h: Expand shift_offset[] to handle
  8 planes. (RFB)
- bios/lineainit.c bios/lineavars.h bios/lineavars.S vdi/vdi_mouse.c:
  Allow mouse cursor in 8 planes. (RFB)

2013-05-04
- vdi/vdi_tblit.S  vdi/vdi_tblit_cf.S: Support text blitting for
  8 planes. (RFB)
- vdi/vdi_raster.c: Support 8 planes for vro_cpyfm(), vrt_cpyfm(). (RFB)

2013-05-05
- bios/videl.h desk/deskrez.c desk/desktop.def desk/desktop.rsc:
  Allow 256 colours for desktop. (RFB)

2013-05-06
- bios/xhdi.c: Fixed XHInqDriver(). Reported by Markus Fröschle, fixed by
  David Gálvez. (VRI)
- Makefile: Fixed "Unknown ColdFire Machine" non-fatal error when doing
  "make coldfire-sources". (VRI)
- po/de.po: Updated German translation. (THH)

2013-05-07
- bios/linea.S: Fixed compilation with binutils 2.9.1. (VRI)
- aes/gemgraf.c include/compat.h: Code cleanup: eliminate LHIBT() &
  LLOBT() macros. (RFB)
- desk/deskact.c desk/desksupp.c desk/deskwin.c include/compat.h:
  Code cleanup: eliminate LPOINTER macro. (RFB)

2013-05-08
- po/fr.po: Updated. (VRI)
- desk/deskinf.c: Fix bug: file info dialog showed residual values for
  number of files/folders. (RFB)
- desk/deskinf.c: Grey out number of files/folders when displaying file
  info. (RFB)
- desk/desktop.def desk/desktop.rsc tools/erd.c: Use common strings for
  number of files/folders. (RFB)

2013-05-10
- bios/natfeat.S bios/xhdi.c: Added comments about the XHDI handler. (VRI)
- po/fr.po: Updated. (VRI)
- po/de.po: Updated. (THH)

2013-05-11
- cli/cmdedit.c: Handle input characters < 0x20 correctly. (RFB)
- cli/Makefile cli/cmd.h cli/cmdasm.S: Eliminate usage of osbind.h. (RFB)

2013-05-12
- po/ru.po: Updated. Contributed by Dima Sobolev. (VRI)
- po/fi.po: Updated. Contributed by Eero Tamminen. (VRI)
- cli/Makefile cli/cmd.h cli/cmdedit.c cli/cmdexec.c cli/cmdint.c
  cli/cmdmain.c cli/cmdparse.c cli/cmdutil.c: Added constness, prepare
  for integration into EmuTOS. (RFB)
- cli/cmdutil.c: Fix strcpy() bug in standalone version. (RFB)
- cli/cmdutil.c: Make redirected text lines from internal commands
  end in cr/lf. (RFB)
- cli/cmdutil.c: Fix cr/lf problem in internal ls command. (RFB)
- Makefile: Integrate new console into EmuTOS. (RFB)

2013-05-13
- po/it.po: Updated. Contributed by Lodovico Zanier. (VRI)
- po/es.po: Updated. Contributed by David Gálvez. (VRI)

2013-05-15
- cli/cmd.h cli/cmdedit.c cli/cmdmain.c: Make console ctl-C behaviour
  like other shells. (RFB)

2013-05-17
- cli/cmdint.c cli/cmdutil.c: Fix bugs in console copy command. (RFB)
- cli/cmdint.c: Fix bug: move command copied instead of moving. (RFB)

2013-05-19
- cli/cmdint.c: Fix crash in wrap command. (RFB)
- cli/cmdutil.c: Fix strequal() to properly ignore case. (RFB)

2013-05-21
- aes/optimize.c: Fix crash with non-standard filenames from Hatari. (RFB)

2013-05-25
- po/gr.po: Updated Greek translation. Contributed by Christos Tziotzis. (VRI)

2013-05-27
- tools/bug.c: Fixed warning about unused variable line_start. (VRI)

2013-05-28
- cli/cmd.h cli/cmdedit.c cli/cmdexec.c cli/cmdint.c cli/cmdmain.c
  cli/cmdutil.c: Added more const keywords. (VRI)
- tools/mkrom.c: Fixed for 64-bit systems. Suggested by Radoslaw Kujawa. (VRI)
- po/gr.po: Fixed long strings. Contributed by Christos Tziotzis. (VRI)

2013-05-30
- aes/gemshlib.c bios/bios.c cli/coma.S cli/command.c: Removed source
  files and code references for old console. (RFB)
- cli/cmdmain.c: Display blank line after welcome message. (RFB)

2013-06-03
- doc/resource.txt doc/todo.txt: Minor documentation updates and
  corrections. (RFB)
- doc/announce.txt: Updated for release 0.9.1. (RFB)

2013-06-04
- po/cs.po: Updated Czech translation. Contributed by Pavel Salač. (VRI)

2013-06-05
- doc/*: Updated. (VRI)

2013-06-08
- bios/vt52.c: Fixed compilation when !CONF_SERIAL_CONSOLE_ANSI. (VRI)

2013-06-13
- bios/ikbd.c: More accurate comment about IKBD reset. (VRI)

2013-06-16
- doc/announce.txt: Updated. Contributed by Eero Tamminen. (VRI)
- bios/linea.S: On unimplemented Line-A function, display a debug trace instead
  of calling panic(). Suggested by David Savinkoff. (VRI)

2013-06-19
- cli/cmdint.c: Fix panic when 'echo'ing control character. (RFB)
- cli/cmdint.c: Remove the internal command 'rem'. (RFB)
- cli/cmdint.c cli/cmdutil.c: Small optimisation for eol handling. (RFB)
- cli/cmd.h cli/cmdint.c cli/cmdutil.c: Moved output() and friends to
  make them private functions. (RFB)
- cli/cmdint.c: Allow interruption and flow control for output of 'ls'
  and 'copy/move'. (RFB)

2013-06-20
- bios/disk.c: Changed byteswap message. (VRI)
- bios/ikbd.c: Added scancode emulation for EmuCON2 on serial console. (VRI)

2013-06-21
- bdos/mem.h bdos/osmem.c doc/osmemory.txt: Fix regression: Malloc()
  should not cause a halt() due to lack of internal memory. (RFB)

2013-06-23
- Makefile: Added support for "make ramtos.dsm". (VRI)
- util/bootasm.S: Fixed memory corruption due to bad stack in boot.prg. (VRI)
- bios/bios.c: Hide the cursor after system halted. (VRI)

2013-06-24
- *: Updated copyright year for files modified since last release. (VRI)

2013-06-25
- *: Stripped trailing spaces. (VRI)

2013-07-03
- doc/announce.txt: Updated release date. (VRI)

* Release: 0.9.1

2013-07-29
- vdi/vdi_line.c: Speed up rectangle draw by eliminating locals. (RFB)
- vdi/vdi_defs.h vdi/vdi_fill.c vdi/vdi_line.c: Static cleanup. (RFB)

2013-07-30
- bios/acsi.c bios/blkdev.c bios/blkdev.h bios/disk.c bios/floppy.c:
  Use shift for logical/physical sector number conversion. (RFB)

2013-07-31
- aes/gemasync.c aes/gemdisp.c aes/geminput.c aes/gemoblib.c
  include/compat.h: Eliminate LLOWD() compatibility macro. (RFB)
- aes/geminput.c include/compat.h: Eliminate LHIWD() compatibility
  macro. (RFB)

2013-08-01
- aes/gemevlib.c aes/gemevlib.h aes/gemsuper.c: Replace some macro usage
  with inline function. (RFB)
- aes/gemsuper.c: Replace some compatibility macro usage. (RFB)
- aes/gemasync.c aes/geminput.c include/compat.h: Eliminate HW()
  compatibility macro. (RFB)
- aes/gemsclib.c aes/gemshlib.c desk/deskfun.c include/compat.h:
  Eliminate LBGET() compatibility macro. (RFB)
- aes/gemaplib.c aes/gemsclib.c aes/gemshlib.c include/compat.h:
  Eliminate LBSET() compatibility macro. (RFB)

2013-08-03
- aes/gemshlib.c: Fix bug in shel_find(): the AES path wasn't
  searched. (RFB)
- aes/gemsuper.c aes/gemsuper.h: Code cleanup: replace #defines, casts
  with structure definition. (RFB)
- aes/gemrslib.c aes/gemrslib.h aes/gemsuper.c: Code cleanup: replace
  #defines, casts with structure definition. (RFB)
- aes/gemrslib.c include/compat.h: Eliminate LW() compatibility macro. (RFB)
- aes/gemrslib.c: Code cleanup: replace #defines with union. (RFB)

2013-08-05
- aes/gemrslib.c include/compat.h: Code cleanup: replace #defines, casts
  with structures, unions. (RFB)
- desk/deskact.c desk/deskapp.c desk/deskbind.h include/compat.h:
  Eliminate LWGET() compatibility macro. (RFB)
- aes/geminit.h: Make AES PATH= environment string the same as TOS. (RFB)

2013-08-15
- aes/gempd.c: Code cleanup: simplify, reduce size, fix minor error. (RFB)
- aes/gemshlib.c: Fix bug in sh_ldapp(): application directory was not
  set correctly. (RFB)
- aes/gemshlib.c: Make search order for shel_find()/rsrc_load() the same
  as TOS3/TOS4. (RFB)
- aes/basepage.h aes/gemaplib.c aes/gemaplib.h aes/gemasm.h aes/gemasync.c
  aes/gemctrl.c aes/gemctrl.h aes/gemdisp.c aes/gemfmlib.c aes/geminit.c
  aes/geminput.c aes/geminput.h aes/gemlib.h aes/gemmnlib.c aes/gemmnlib.h
  aes/gempd.c aes/gempd.h aes/gemqueue.c aes/gemwmlib.c aes/gemwmlib.h
  aes/struct.h: Code cleanup: rename AES's PD structure to AESPD to avoid
  conflict with the BDOS PD. (RFB)
- aes/gemgraf.h desk/deskgraf.c desk/deskgraf.h include/gsxdefs.h: Code
  cleanup: move common definitions to gsxdefs.h. (RFB)
- aes/gemgraf.c aes/gemgsxif.c aes/gemoblib.c desk/deskgraf.c
  desk/deskinf.c include/gsxdefs.h: Eliminate ad_intin global. (RFB)
- aes/gemshlib.c desk/deskdir.c desk/deskinf.c: Code cleanup: remove
  unneeded ADDR() macros. (RFB)
- desk/deskgraf.c: Remove reference to ad_intin from uncompiled code. (RFB)
- desk/gembind.c: Code cleanup: remove a few more ADDR() macros. (RFB)

2013-08-16
- desk/aesbind.h desk/deskact.c desk/deskbind.h desk/deskmain.c
  desk/deskpro.c desk/deskpro.h desk/desksupp.c desk/gembind.c:
  Code cleanup: eliminate some desktop globals. (RFB)
- desk/deskbind.h desk/deskfpd.c: Code cleanup: eliminate never-referenced
  desktop globals. (RFB)
- desk/deskbind.h desk/deskfpd.c: Code cleanup: eliminate another desktop
  global. (RFB)
- desk/desk1.c desk/deskact.c desk/deskapp.c desk/deskbind.h desk/deskdir.c
  desk/deskfpd.c desk/deskfun.c desk/deskglob.c desk/deskinf.c
  desk/deskmain.c desk/deskobj.c desk/deskpro.c desk/deskrez.c
  desk/desksupp.c desk/deskwin.c: Merge infodef.h into deskbind.h. (RFB)
- desk/infodef.h: Removed, no longer required. (RFB)
- desk/deskbind.h desk/deskdir.c: Code cleanup: rename the desktop's 'FCB'
  structure to 'DTA' to reduce confusion. (RFB)

2013-08-17
- desk/desk1.c desk/deskbind.h desk/deskdir.c: Code cleanup: use HGLASS
  instead of HRGLASS. (RFB)
- desk/deskact.c desk/deskbind.h desk/deskmain.c desk/deskobj.c
  desk/desksupp.c desk/deskwin.c: Code cleanup: eliminate another desktop
  global. (RFB)
- desk/aesbind.h desk/deskact.c desk/deskdir.c desk/deskinf.c desk/deskobj.c
  desk/desksupp.c desk/deskwin.c desk/gembind.c include/obdefs.h:
  Code cleanup: set type of first arg to objc_xxx() as OBJECT *. (RFB)
- aes/gemmnlib.c aes/gemmnlib.h aes/gemwmlib.c aes/gemwmlib.h:
  Code cleanup: change scope of gl_datree, gl_wtree to local. (RFB)
- include/dos.h: Code cleanup: remove unused structure definitions. (RFB)

2013-09-04
- bios/acsi.c bios/acsi.h bios/blkdev.c: Fix ACSI to work on real disks,
  both ACSI & SCSI via converter.  Enhanced version of patch provided by
  Hampa Hug. (RFB)

2013-09-05
- bios/acsi.c: Code cleanup: remove meaningless #if/#endif. (RFB)

2013-09-21
- bios/linea.S vdi/vdi_defs.h vdi/vdi_fill.c vdi/vdi_mouse.c: Added Line-A pixel
  set/get & sprite draw/undraw support. Contributed by Eero Tamminen. (VRI)
- vdi/vdi_mouse.c: Avoid side effects between mouse and sprite save area.
  Contributed by Eero Tamminen. (VRI)
- bios/dma.c bios/dma.h bios/mfp.c bios/mfp.h: Minor code tidy up. (RFB)
- bios/acsi.c bios/floppy.c bios/mfp.c bios/mfp.h: Eliminate divide in
  timeout_gpip() by passing timeout in ticks. (RFB)
- bios/xhdi.c: Code cleanup: use KDEBUG() for debugging statements. (RFB)
- bios/acsi.c bios/acsi.h bios/xhdi.c: XHInqTarget()/XHInqTarget2() now
  report error if selected ACSI drive is not present. (RFB)

2013-09-23
- bios/acsi.c: Support drives >1GB on ACSI interface. (RFB)
- bios/acsi.c: Retrieve status properly for all ACSI commands. (RFB)
- bios/acsi.c bios/acsi.h bios/xhdi.c doc/xhdi.txt: XHGetCapacity() is
  now supported for ACSI devices. (RFB)

2013-09-24
- bios/linea.S vdi/vdi_blit.S vdi/vdi_raster.c: Added Line-A bitblit & textblit
  support. Contributed by Eero Tamminen. (VRI)
- bios/linea.S vdi/vdi_bezier.c vdi/vdi_defs.h vdi/vdi_fill.c vdi/vdi_line.c
  vdi/vdi_text.c: Added support for Line-A hline/line/fillrect. Contributed
  by Eero Tamminen. (VRI)
- vdi/vdi_line.c: Improved linea_color() performance. Contributed by David
  Savinkoff. (VRI)

2013-09-25
- vdi/vdi_raster.c: Fixed "make firebee". Contributed by Eero Tamminen. (VRI)
- vdi/vdi_line.c: Improved linea_color() performance again. Contributed by David
  Savinkoff. (VRI)
- bios/disk.c: Improved determination of disk capacity & blocksize. (RFB)
- bios/disk.c: Circumvent Hatari bug in handling Read Capacity command. (RFB)

2013-10-04
- bios/blkdev.c bios/ide.c bios/ide.h bios/mfp.h: Updated IDE code to
  follow official PIO data transfer diagrams. (RFB)

2013-10-08
- bios/amiga.h bios/ide.c: Fixed Amiga compilation. (VRI)

2013-10-10
- bios/ide.c include/asm.h: Use 32-bit IDE transfer width for non-548x
  hardware. (RFB)

2013-10-23
- bios/ide.c: Support up to 4 IDE interfaces. (RFB)
- bios/ide.c: Code cleanup: use 'interface' instead of 'bus' within IDE
  code to avoid confusion. (RFB)

2013-10-24
- bios/ide.c bios/ide.h bios/xhdi.c: Disk capacity is now obtained from
  IDE devices. (RFB)
- bios/ide.c: Code cleanup: remove residual ENABLE_KDEBUG; use the same
  pattern of args for read & write routines. (RFB)

2013-10-25
- bios/ide.c bios/ide.h bios/xhdi.c: For IDE, XHInqTarget/XHInqTarget2
  now return actual product name. (RFB)

2013-10-28
- bios/ide.c: Use Read/Write Multiple instead of Read/Write Sector
  commands, where possible. (RFB)
- bios/ide.c: Fix uninitialized variables when debug is enabled. (RFB)

2013-10-30
- bios/ide.c: Fix crash during startup caused by previous update. (RFB)
- desk/desktop.def desk/desktop.rsc: Change FBOXTEXT objects to FTEXT
  for faster dialog display. Suggested by Eero Tamminen. (RFB)

2013-11-21
- Makefile bios/blkdev.c bios/blkdev.h bios/coldpriv.h bios/disk.c
  bios/sd.c bios/sd.h bios/spi.c bios/spi.h bios/xhdi.c: Add support
  for SD/MMC cards on FireBee. (RFB)
- bios/ide.c bios/ide.h bios/xhdi.c: Code cleanup: use ioctl model
  for miscellaneous IDE routines. (RFB)
- desk/desktop.def desk/desktop.rsc: Reverted previous FBOXTEXT change
  which caused display problems. (RFB)

2013-11-28
- bios/acsi.c bios/acsi.h bios/xhdi.c: Code cleanup: use ioctl model
  for miscellaneous ACSI routines. (RFB)

2013-12-07
- bdos/fs.h bdos/fsfat.c bdos/fsio.c bdos/fsopnclo.c: Handle all valid
  DOS FAT end-of-chain markers (in case file/folder was written on
  another system). (RFB)

2013-12-10
- bdos/fsio.c: Code cleanup: rewrote ixlseek() for greater simplicity and
  added many explanatory comments. (RFB)
- bdos/bdosmain.c bdos/fsbuf.c bdos/fsdir.c bdos/fsdrive.c bdos/fsio.c
  bdos/iumem.c bdos/kpgmld.c bdos/proc.c bdos/umem.c: Code cleanup: use
  KDEBUG() for debugging statements. (RFB)

2013-12-11
- bios/ide.c: Added missing IDE features/error register on M548x. (VRI)
- bios/ide.c: Fix potential bug: use LONG instead of WORD for timeout
  values. (RFB)

2013-12-15
- bios/bios.c bios/coldfire.c bios/coldfire.h: Added poweroff support on the
  FireBee. (VRI)
- bios/ide.c: Set a maximum of two IDE interfaces for FireBee. (RFB)
- bios/bios.c: Fixed implicit declaration of firebee_shutdown(). (RFB)

2013-12-24
- bios/linea.S bios/lineavars.S vdi/vdi_defs.h vdi/vdi_line.c vdi/vdi_raster.c:
  Added support for "Copy raster form". Contributed by Eero Tamminen. (VRI)

2013-12-31
- bios/ide.c: Disable IDE multi-sector i/o (causes problems with some
  CF cards). (RFB)

2014-01-01
- aes/gemgsxif.c aes/gsx2.c aes/gsx2.h Makefile: Converted gsx2.S to C, and
  added d2/a2 to the VDI trap clobber list. This makes EmuTOS compatible
  with fVDI's v_hide_c() and v_show_c() which clobbers d2. (VRI)
- *: Replaced asm by __asm__, inline by __inline__ and __volatile__ to volatile
  to be more compliant with the standards. (VRI)

2014-01-02
- aes/gemgraf.c aes/gemgsxif.c aes/gemgsxif.h: Get the correct number of planes
  from the VDI workstation. This fixes the menu with fVDI 32-bit modes. (VRI)
- aes/gemgraf.c desk/deskgraf.c include/gsxdefs.h: Removed unused gl_nrows and
  gl_ncols variables. (VRI)

2014-01-03
- bios/ide.c: Fix some debugging messages. (RFB)

2014-01-07
- bios/ide.c: Fix obscure bug detected by code inspection. (RFB)

2014-01-08
- bios/ide.c: Fixed IDE regression on Amiga. 32-bit access is unsupported. (VRI)

2014-01-09
- bios/blkdev.c bios/disk.c bios/floppy.c: Small refactoring of media
  change detection. (RFB)

2014-01-09
- bios/blkdev.c bios/blkdev.h bios/ide.c bios/sd.c: Refactor media change
  code to simplify future updates. (RFB)

2014-01-09
- bios/blkdev.c: Replaced DBG_BLKDEV with KDEBUG. (RFB)

2014-01-13
- bios/floppy.c: Replaced DBG_FLOP with KDEBUG. (RFB)

2014-01-16
- bios/blkdev.c bios/blkdev.h bios/disk.c bios/disk.h: Refactor partition
  detection for future media change update. (RFB)

2014-01-20
- bios/disk.c: Code cleanup: use MBR definition rather than hardcoded
  offsets. (RFB)
- bios/blkdev.c bios/blkdev.h bios/disk.c: Improve detection of FAT12 /
  FAT16 / FAT32 partitions. (RFB)
- bios/blkdev.c: Code cleanup: use ptr instead of index. (RFB)
- bios/acsi.c: Handle GET_MEDIACHANGE in acsi_ioctl(). (RFB)

2014-01-21
- bios/acsi.c bios/blkdev.c bios/ide.c bios/sd.c bios/xhdi.c: Propagate
  Rwabs() read/write flags to low-level drivers. (RFB)

2014-01-22
- bios/blkdev.c bios/blkdev.h bios/disk.c bios/disk.h bios/sd.c
  bios/xhdi.c bios/xhdi.h: Add media change support for SD/MMC. (RFB)

2014-01-23
- bios/xhdi.c: Code cleanup: remove unnecessary case statements. (RFB)
- bios/floppy.c: Detect floppy drives when no disks are inserted. (RFB)

2014-01-24
- bios/disk.c bios/xhdi.c: Always assign at least 1 logical device to
  the SD/MMC slot. (RFB)

2014-01-26
- bios/ide.c: Bypass firmware bug on certain CF cards which caused
  multi-sector i/o to fail. (RFB)
- desk/deskmain.c desk/desksupp.c: Avoid opening window for a disk that
  no longer exists. (RFB)
- bios/disk.c: Code cleanup: use pointer instead of index. (RFB)
- aes/gemaplib.c aes/gemevlib.c aes/gemgsxif.c aes/gemoblib.c
  aes/gemrslib.c aes/gemsuper.c aes/gemwmlib.c: Code cleanup: eliminate
  ADDR() macro in AES routines. (RFB)

2014-01-27
- aes/gemaplib.c aes/gemaplib.h aes/gemdisp.c aes/geminit.c
  aes/gemsuper.c aes/struct.h: Fix appl_trecord() & appl_tplay(). (RFB)
- include/compat.h: Remove #define for LWSET(), no longer used. (RFB)
- desk/gembind.c: Code cleanup: remove unnecessary global. (RFB)
- desk/deskact.c: Code cleanup: remove a few more ADDR() macros. (RFB)

2014-01-29
- bios/disk.c: Fix regression: ext2 partitions were not assigned
  (inaccessible) logical drives. (RFB)
- desk/deskmain.c desk/desksupp.c: Revert previous update which caused
  various problems with removable disks. (RFB)

2014-01-30
- bios/ide.c: Avoid using multi-sector i/o unless it's beneficial. (RFB)

2014-02-01
- aes/gemgsxif.c aes/gsx2.h: Eliminate redundant macro i_lptr1(). (RFB)
- aes/gemshlib.c aes/gsx2.h include/compat.h: Code cleanup: eliminate
  LLSET() compatibility macro. (RFB)
- aes/gemgsxif.c aes/gemoblib.c desk/deskapp.c include/compat.h: Code
  cleanup: eliminate LLGET() compatibility macro. (RFB)

2014-02-02
- aes/gemdos.c aes/gemdos.h aes/geminit.c aes/gemrslib.c desk/deskapp.c
  desk/deskdir.c: Change arg3 of dos_read()/dos_write() from LONG to
  void *. (RFB)
- bios/blkdev.c: Fix regression of 2014-01-09: mediachange was not set
  properly for SCSI bus (affects Aranym). (RFB)
- aes/gemdos.c aes/gemdos.h aes/gemfslib.c aes/geminit.c aes/gemsclib.c
  aes/gemshlib.c desk/deskdir.c desk/deskfpd.c: Code cleanup: change
  dos_sdta() arg from LONG to void *. (RFB)
- desk/aesbind.h desk/deskapp.h desk/gembind.c: Code cleanup: change
  arg1 of shel_get()/shel_put() from LONG to void *. (RFB)
- desk/deskfun.c desk/deskmain.c desk/desksupp.c: Code cleanup: remove
  unnecessary typecasts for wind_set() parameters. (RFB)
- desk/deskact.c desk/deskact.h desk/desksupp.c: Code cleanup: change
  arg2 of act_chg() from LONG to OBJECT *. (RFB)
- desk/deskact.c desk/deskact.h desk/desksupp.c: Code cleanup: change
  arg2 of act_allchg() from LONG to OBJECT *. (RFB)
- desk/deskact.c desk/deskact.h desk/deskmain.c: Code cleanup: change
  arg2 of act_bsclick() from LONG to OBJECT *. (RFB)
- desk/deskact.c desk/deskact.h desk/deskmain.c: Code cleanup: change
  arg2 of act_bdown() from LONG to OBJECT *. (RFB)
- desk/deskact.c: Code cleanup: remove no-longer-required temporary
  variables. (RFB)

2014-02-03
- bios/disk.c bios/blkdev.c: Fix regression: FAT32/ext2 partitions were
  not available via XHDI. (RFB)

2014-02-04
- bdos/fsdrive.c bios/disk.c bios/floppy.c: When media change is detected,
  close windows displaying the contents of no-longer-available media. (RFB)
- aes/gemgraf.c aes/gemgraf.h aes/gemrslib.c desk/deskapp.c desk/deskins.c
  desk/deskwin.c include/obdefs.h tools/erd.c: Code cleanup: fixup types of
  some ICONBLK fields. (RFB)
- desk/deskapp.c desk/deskfun.c desk/deskmain.c desk/deskwin.c
  desk/gembind.c include/compat.h: Code cleanup: eliminate usage of ADDR()
  compatibility macro. (RFB)
- aes/optimopt.h desk/deskinf.c include/compat.h: Code cleanup: move
  function prototype to appropriate header. (RFB)

2014-02-06
- bios/acsi.c: Improve send_command(). Contributed by David Savinkoff. (RFB)

2014-02-10
- bios/screen.c: Initialise vblsem: fixes intermittent problems booting
  EmuTOS RAM on ST(e). (RFB)

2014-02-12
- readme.txt doc/*.txt: Updated documentation. (VRI)
- *: make expand. (VRI)
- Makefile: Fixed "make charset" for dirty source tree. (VRI)
- doc/status.txt: Updated documentation. (RFB)

2014-02-15
- *: Updated copyright year. (VRI)
- aes/gsx2.h: Fixed potential strict-aliasing issue. (VRI)
- Makefile bios/sd.c bios/sd.h bios/spi.c bios/spi.h include/config.h: Do not
  restrict SD/MMC support to ColdFire targets (even if SPI is). (VRI)

2014-02-18
- bios/acsi.c: Add stop_until_interrupt() while waiting for hz_200. (RFB)

2014-02-20
- doc/announce.txt: Updated. (VRI)

2014-02-21
- doc/status.txt: Added Line-A. (VRI)
- doc/status.txt: Updated supported emulators/hardware. (VRI)
- doc/bugs.txt: Updated. Contributed by Eero Tamminen. (VRI)
- doc/announce.txt: Updated release date. (VRI)

* Release: 0.9.2

2014-02-22
- doc/readme-firebee.txt: Updated with missing release information. (VRI)
- Makefile: Compile with -O2 by default, or -Os only when short of space. (VRI)
- aes/gemdisp.c aes/gemfmalt.c aes/geminit.c aes/gemshlib.c
  aes/gemsuper.c: Replaced DBG_xxx with KDEBUG(). (RFB)
- bdos/osmem.c: Replaced DBG_xxx with KDEBUG(). (RFB)
- bios/biosmem.c bios/clock.c bios/dmasound.c bios/font.c bios/ikbd.c
  bios/machine.c bios/mouse.c bios/nvram.c bios/videl.c:  Replaced
  DBG_xxx with KDEBUG(). (RFB)

2014-02-24
- include/config.h: Fix regression in emutos-aranym handling of IDE. (RFB)

2014-02-25
- bdos/fsdir.c: Fix formatting within xsnext() function. (RFB)

2014-02-25
- doc/bugs.txt: Updated. Contributed by Eero Tamminen. (VRI)
- Makefile: Reverted compilation with -O2 for the bugfix release. (VRI)
- readme.txt doc/announce.txt: Updated. (VRI)

* Release: 0.9.3
